#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-audit-event.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_0.web.vo.PersistentObject import PersistentObject
from delphixpy.v1_3_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class AuditEvent(PersistentObject):
    """
    *(extends* :py:class:`v1_3_0.web.vo.PersistentObject` *)* Represents an
    audit event, a permanent record of user activity on the server.
    """
    def __init__(self, undef_enabled=True):
        super(AuditEvent, self).__init__()
        self._type = ("AuditEvent", True)
        self._user_name = (self.__undef__, True)
        self._title = (self.__undef__, True)
        self._successful = (self.__undef__, True)
        self._user = (self.__undef__, True)
        self._start_time = (self.__undef__, True)
        self._user_agent = (self.__undef__, True)
        self._details = (self.__undef__, True)

    API_VERSION = "1.3.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(AuditEvent, cls).from_dict(data, dirty, undef_enabled)
        obj._user_name = (data.get("userName", obj.__undef__), dirty)
        if obj._user_name[0] is not None and obj._user_name[0] is not obj.__undef__:
            assert isinstance(obj._user_name[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._user_name[0]))
            common.validate_format(obj._user_name[0], "None", None, None)
        obj._title = (data.get("title", obj.__undef__), dirty)
        if obj._title[0] is not None and obj._title[0] is not obj.__undef__:
            assert isinstance(obj._title[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._title[0]))
            common.validate_format(obj._title[0], "None", None, None)
        obj._successful = (data.get("successful", obj.__undef__), dirty)
        if obj._successful[0] is not None and obj._successful[0] is not obj.__undef__:
            assert isinstance(obj._successful[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._successful[0]))
            common.validate_format(obj._successful[0], "None", None, None)
        obj._user = (data.get("user", obj.__undef__), dirty)
        if obj._user[0] is not None and obj._user[0] is not obj.__undef__:
            assert isinstance(obj._user[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._user[0]))
            common.validate_format(obj._user[0], "objectReference", None, None)
        obj._start_time = (data.get("startTime", obj.__undef__), dirty)
        if obj._start_time[0] is not None and obj._start_time[0] is not obj.__undef__:
            assert isinstance(obj._start_time[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._start_time[0]))
            common.validate_format(obj._start_time[0], "date", None, None)
        obj._user_agent = (data.get("userAgent", obj.__undef__), dirty)
        if obj._user_agent[0] is not None and obj._user_agent[0] is not obj.__undef__:
            assert isinstance(obj._user_agent[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._user_agent[0]))
            common.validate_format(obj._user_agent[0], "None", None, None)
        obj._details = (data.get("details", obj.__undef__), dirty)
        if obj._details[0] is not None and obj._details[0] is not obj.__undef__:
            assert isinstance(obj._details[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._details[0]))
            common.validate_format(obj._details[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(AuditEvent, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "user_name" == "type" or (self.user_name is not self.__undef__ and not (dirty and not self._user_name[1])):
            dct["userName"] = dictify(self.user_name)
        if "title" == "type" or (self.title is not self.__undef__ and not (dirty and not self._title[1])):
            dct["title"] = dictify(self.title)
        if "successful" == "type" or (self.successful is not self.__undef__ and not (dirty and not self._successful[1])):
            dct["successful"] = dictify(self.successful)
        if "user" == "type" or (self.user is not self.__undef__ and not (dirty and not self._user[1])):
            dct["user"] = dictify(self.user)
        if "start_time" == "type" or (self.start_time is not self.__undef__ and not (dirty and not self._start_time[1])):
            dct["startTime"] = dictify(self.start_time)
        if "user_agent" == "type" or (self.user_agent is not self.__undef__ and not (dirty and not self._user_agent[1])):
            dct["userAgent"] = dictify(self.user_agent)
        if "details" == "type" or (self.details is not self.__undef__ and not (dirty and not self._details[1])):
            dct["details"] = dictify(self.details)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._user_name = (self._user_name[0], True)
        self._title = (self._title[0], True)
        self._successful = (self._successful[0], True)
        self._user = (self._user[0], True)
        self._start_time = (self._start_time[0], True)
        self._user_agent = (self._user_agent[0], True)
        self._details = (self._details[0], True)

    def is_dirty(self):
        return any([self._user_name[1], self._title[1], self._successful[1], self._user[1], self._start_time[1], self._user_agent[1], self._details[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, AuditEvent):
            return False
        return super(AuditEvent, self).__eq__(other) and \
               self.user_name == other.user_name and \
               self.title == other.title and \
               self.successful == other.successful and \
               self.user == other.user and \
               self.start_time == other.start_time and \
               self.user_agent == other.user_agent and \
               self.details == other.details

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def user_name(self):
        """
        Name of user that initiated the action.

        :rtype: ``basestring``
        """
        return self._user_name[0]

    @user_name.setter
    def user_name(self, value):
        self._user_name = (value, True)

    @property
    def title(self):
        """
        Audit event title.

        :rtype: ``basestring``
        """
        return self._title[0]

    @title.setter
    def title(self, value):
        self._title = (value, True)

    @property
    def successful(self):
        """
        Indicates whether the action was successful or not.

        :rtype: ``bool``
        """
        return self._successful[0]

    @successful.setter
    def successful(self, value):
        self._successful = (value, True)

    @property
    def user(self):
        """
        User that initiated the action.

        :rtype: ``basestring``
        """
        return self._user[0]

    @user.setter
    def user(self, value):
        self._user = (value, True)

    @property
    def start_time(self):
        """
        The time the event occurred. For long running processes, this
        represents the starting time.

        :rtype: ``basestring``
        """
        return self._start_time[0]

    @start_time.setter
    def start_time(self, value):
        self._start_time = (value, True)

    @property
    def user_agent(self):
        """
        Name of client software used to initiate the action.

        :rtype: ``basestring``
        """
        return self._user_agent[0]

    @user_agent.setter
    def user_agent(self, value):
        self._user_agent = (value, True)

    @property
    def details(self):
        """
        Plain text description of the audit event.

        :rtype: ``basestring``
        """
        return self._details[0]

    @details.setter
    def details(self, value):
        self._details = (value, True)

