#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-application-container.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_0.web.vo.DVCApplication import DVCApplication
from delphixpy.v1_3_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCApplicationContainer(DVCApplication):
    """
    *(extends* :py:class:`v1_3_0.web.vo.DVCApplication` *)* A container
    represents an application template provisioned for a specific user.
    """
    def __init__(self, undef_enabled=True):
        super(DVCApplicationContainer, self).__init__()
        self._type = ("DVCApplicationContainer", True)
        self._owner = (self.__undef__, True)
        self._state = (self.__undef__, True)
        self._template = (self.__undef__, True)

    API_VERSION = "1.3.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCApplicationContainer, cls).from_dict(data, dirty, undef_enabled)
        obj._owner = (data.get("owner", obj.__undef__), dirty)
        if obj._owner[0] is not None and obj._owner[0] is not obj.__undef__:
            assert isinstance(obj._owner[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._owner[0]))
            common.validate_format(obj._owner[0], "objectReference", None, None)
        obj._state = (data.get("state", obj.__undef__), dirty)
        if obj._state[0] is not None and obj._state[0] is not obj.__undef__:
            assert isinstance(obj._state[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._state[0]))
            assert obj._state[0] in [u'ENABLED', u'DISABLED', u'DELETING', u'FAULTED'], "Expected enum [u'ENABLED', u'DISABLED', u'DELETING', u'FAULTED'] but got %s" % obj._state[0]
            common.validate_format(obj._state[0], "None", None, None)
        obj._template = (data.get("template", obj.__undef__), dirty)
        if obj._template[0] is not None and obj._template[0] is not obj.__undef__:
            assert isinstance(obj._template[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._template[0]))
            common.validate_format(obj._template[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCApplicationContainer, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "owner" == "type" or (self.owner is not self.__undef__ and not (dirty and not self._owner[1])):
            dct["owner"] = dictify(self.owner)
        if "state" == "type" or (self.state is not self.__undef__ and not (dirty and not self._state[1])):
            dct["state"] = dictify(self.state)
        if "template" == "type" or (self.template is not self.__undef__ and not (dirty and not self._template[1])):
            dct["template"] = dictify(self.template)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._owner = (self._owner[0], True)
        self._state = (self._state[0], True)
        self._template = (self._template[0], True)

    def is_dirty(self):
        return any([self._owner[1], self._state[1], self._template[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCApplicationContainer):
            return False
        return super(DVCApplicationContainer, self).__eq__(other) and \
               self.owner == other.owner and \
               self.state == other.state and \
               self.template == other.template

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def owner(self):
        """
        A reference to the user that owns this application container.

        :rtype: ``basestring``
        """
        return self._owner[0]

    @owner.setter
    def owner(self, value):
        self._owner = (value, True)

    @property
    def state(self):
        """
        The state of the application container. *(permitted values: ENABLED,
        DISABLED, DELETING, FAULTED)*

        :rtype: ``basestring``
        """
        return self._state[0]

    @state.setter
    def state(self, value):
        self._state = (value, True)

    @property
    def template(self):
        """
        The application template that this application container was
        provisioned from.

        :rtype: ``basestring``
        """
        return self._template[0]

    @template.setter
    def template(self, value):
        self._template = (value, True)

