#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-bookmark-tag.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_0.web.vo.TypedObject import TypedObject
from delphixpy.v1_3_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCBookmarkTag(TypedObject):
    """
    *(extends* :py:class:`v1_3_0.web.vo.TypedObject` *)* A user-defined label
    for a DVC bookmark.
    """
    def __init__(self, undef_enabled=True):
        super(DVCBookmarkTag, self).__init__()
        self._type = ("DVCBookmarkTag", True)
        self._tag = (self.__undef__, True)

    API_VERSION = "1.3.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCBookmarkTag, cls).from_dict(data, dirty, undef_enabled)
        obj._tag = (data.get("tag", obj.__undef__), dirty)
        if obj._tag[0] is not None and obj._tag[0] is not obj.__undef__:
            assert isinstance(obj._tag[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._tag[0]))
            common.validate_format(obj._tag[0], "None", None, 256)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCBookmarkTag, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "tag" == "type" or (self.tag is not self.__undef__ and not (dirty and not self._tag[1])):
            dct["tag"] = dictify(self.tag)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._tag = (self._tag[0], True)

    def is_dirty(self):
        return any([self._tag[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCBookmarkTag):
            return False
        return super(DVCBookmarkTag, self).__eq__(other) and \
               self.tag == other.tag

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def tag(self):
        """
        The user-defined label.

        :rtype: ``basestring``
        """
        return self._tag[0]

    @tag.setter
    def tag(self, value):
        self._tag = (value, True)

