#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-source-data-timestamp-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_0.web.vo.TypedObject import TypedObject
from delphixpy.v1_3_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCSourceDataTimestampParameters(TypedObject):
    """
    *(extends* :py:class:`v1_3_0.web.vo.TypedObject` *)* Input parameters for
    the API that given a point in time, returns the timestamps of the latest
    provisionable points, before the specified time, for each data source in
    the given application.
    """
    def __init__(self, undef_enabled=True):
        super(DVCSourceDataTimestampParameters, self).__init__()
        self._type = ("DVCSourceDataTimestampParameters", True)
        self._application = (self.__undef__, True)
        self._time = (self.__undef__, True)

    API_VERSION = "1.3.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCSourceDataTimestampParameters, cls).from_dict(data, dirty, undef_enabled)
        if "application" not in data:
            raise ValueError("Missing required property \"application\".")
        obj._application = (data.get("application", obj.__undef__), dirty)
        if obj._application[0] is not None and obj._application[0] is not obj.__undef__:
            assert isinstance(obj._application[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._application[0]))
            common.validate_format(obj._application[0], "objectReference", None, None)
        if "time" not in data:
            raise ValueError("Missing required property \"time\".")
        obj._time = (data.get("time", obj.__undef__), dirty)
        if obj._time[0] is not None and obj._time[0] is not obj.__undef__:
            assert isinstance(obj._time[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._time[0]))
            common.validate_format(obj._time[0], "date", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCSourceDataTimestampParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "application" == "type" or (self.application is not self.__undef__ and not (dirty and not self._application[1])):
            dct["application"] = dictify(self.application)
        if "time" == "type" or (self.time is not self.__undef__ and not (dirty and not self._time[1])):
            dct["time"] = dictify(self.time)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._application = (self._application[0], True)
        self._time = (self._time[0], True)

    def is_dirty(self):
        return any([self._application[1], self._time[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCSourceDataTimestampParameters):
            return False
        return super(DVCSourceDataTimestampParameters, self).__eq__(other) and \
               self.application == other.application and \
               self.time == other.time

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def application(self):
        """
        A reference to the DVC application.

        :rtype: ``basestring``
        """
        return self._application[0]

    @application.setter
    def application(self, value):
        self._application = (value, True)

    @property
    def time(self):
        """
        The time that will be used to find provisionable timestamps for the
        sources in the application.

        :rtype: ``basestring``
        """
        return self._time[0]

    @time.setter
    def time(self, value):
        self._time = (value, True)

