#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-appdata-linked-source.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_1.web.vo.AppDataSource import AppDataSource
from delphixpy.v1_3_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class AppDataLinkedSource(AppDataSource):
    """
    *(extends* :py:class:`v1_3_1.web.vo.AppDataSource` *)* An AppData linked
    source
    """
    def __init__(self, undef_enabled=True):
        super(AppDataLinkedSource, self).__init__()
        self._type = ("AppDataLinkedSource", True)
        self._post_script = (self.__undef__, True)
        self._pre_script = (self.__undef__, True)
        self._config = (self.__undef__, True)

    API_VERSION = "1.3.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(AppDataLinkedSource, cls).from_dict(data, dirty, undef_enabled)
        obj._post_script = (data.get("postScript", obj.__undef__), dirty)
        if obj._post_script[0] is not None and obj._post_script[0] is not obj.__undef__:
            assert isinstance(obj._post_script[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._post_script[0]))
            common.validate_format(obj._post_script[0], "None", None, 1024)
        obj._pre_script = (data.get("preScript", obj.__undef__), dirty)
        if obj._pre_script[0] is not None and obj._pre_script[0] is not obj.__undef__:
            assert isinstance(obj._pre_script[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._pre_script[0]))
            common.validate_format(obj._pre_script[0], "None", None, 1024)
        obj._config = (data.get("config", obj.__undef__), dirty)
        if obj._config[0] is not None and obj._config[0] is not obj.__undef__:
            assert isinstance(obj._config[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._config[0]))
            common.validate_format(obj._config[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(AppDataLinkedSource, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "post_script" == "type" or (self.post_script is not self.__undef__ and not (dirty and not self._post_script[1])):
            dct["postScript"] = dictify(self.post_script)
        if "pre_script" == "type" or (self.pre_script is not self.__undef__ and not (dirty and not self._pre_script[1])):
            dct["preScript"] = dictify(self.pre_script)
        if "config" == "type" or (self.config is not self.__undef__ and not (dirty and not self._config[1])):
            dct["config"] = dictify(self.config)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._post_script = (self._post_script[0], True)
        self._pre_script = (self._pre_script[0], True)
        self._config = (self._config[0], True)

    def is_dirty(self):
        return any([self._post_script[1], self._pre_script[1], self._config[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, AppDataLinkedSource):
            return False
        return super(AppDataLinkedSource, self).__eq__(other) and \
               self.post_script == other.post_script and \
               self.pre_script == other.pre_script and \
               self.config == other.config

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def post_script(self):
        """
        The path to a script on the target host to run after SnapSync.

        :rtype: ``basestring``
        """
        return self._post_script[0]

    @post_script.setter
    def post_script(self, value):
        self._post_script = (value, True)

    @property
    def pre_script(self):
        """
        The path to a script on the target host to run before SnapSync.

        :rtype: ``basestring``
        """
        return self._pre_script[0]

    @pre_script.setter
    def pre_script(self, value):
        self._pre_script = (value, True)

    @property
    def config(self):
        """
        Reference to the configuration for the source.

        :rtype: ``basestring``
        """
        return self._config[0]

    @config.setter
    def config(self, value):
        self._config = (value, True)

