#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-application.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_1.web.vo.NamedUserObject import NamedUserObject
from delphixpy.v1_3_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCApplication(NamedUserObject):
    """
    *(extends* :py:class:`v1_3_1.web.vo.NamedUserObject` *)* An application
    comprised of a set of data sources and configuration information.
    """
    def __init__(self, undef_enabled=True):
        super(DVCApplication, self).__init__()
        self._type = ("DVCApplication", True)
        self._current_branch = (self.__undef__, True)
        self._notes = (self.__undef__, True)
        self._last_updated = (self.__undef__, True)
        self._properties = (self.__undef__, True)

    API_VERSION = "1.3.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCApplication, cls).from_dict(data, dirty, undef_enabled)
        obj._current_branch = (data.get("currentBranch", obj.__undef__), dirty)
        if obj._current_branch[0] is not None and obj._current_branch[0] is not obj.__undef__:
            assert isinstance(obj._current_branch[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._current_branch[0]))
            common.validate_format(obj._current_branch[0], "objectReference", None, None)
        obj._notes = (data.get("notes", obj.__undef__), dirty)
        if obj._notes[0] is not None and obj._notes[0] is not obj.__undef__:
            assert isinstance(obj._notes[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._notes[0]))
            common.validate_format(obj._notes[0], "None", None, 4096)
        obj._last_updated = (data.get("lastUpdated", obj.__undef__), dirty)
        if obj._last_updated[0] is not None and obj._last_updated[0] is not obj.__undef__:
            assert isinstance(obj._last_updated[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._last_updated[0]))
            common.validate_format(obj._last_updated[0], "date", None, None)
        obj._properties = (data.get("properties", obj.__undef__), dirty)
        if obj._properties[0] is not None and obj._properties[0] is not obj.__undef__:
            assert isinstance(obj._properties[0], dict), ("Expected one of [u'object'], but got %s" % type(obj._properties[0]))
            common.validate_format(obj._properties[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCApplication, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "current_branch" == "type" or (self.current_branch is not self.__undef__ and not (dirty and not self._current_branch[1])):
            dct["currentBranch"] = dictify(self.current_branch)
        if "notes" == "type" or (self.notes is not self.__undef__ and not (dirty and not self._notes[1])):
            dct["notes"] = dictify(self.notes)
        if "last_updated" == "type" or (self.last_updated is not self.__undef__ and not (dirty and not self._last_updated[1])):
            dct["lastUpdated"] = dictify(self.last_updated)
        if "properties" == "type" or (self.properties is not self.__undef__ and not (dirty and not self._properties[1])):
            dct["properties"] = dictify(self.properties)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._current_branch = (self._current_branch[0], True)
        self._notes = (self._notes[0], True)
        self._last_updated = (self._last_updated[0], True)
        self._properties = (self._properties[0], True)

    def is_dirty(self):
        return any([self._current_branch[1], self._notes[1], self._last_updated[1], self._properties[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCApplication):
            return False
        return super(DVCApplication, self).__eq__(other) and \
               self.current_branch == other.current_branch and \
               self.notes == other.notes and \
               self.last_updated == other.last_updated and \
               self.properties == other.properties

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def current_branch(self):
        """
        The active branch of the application.

        :rtype: ``basestring``
        """
        return self._current_branch[0]

    @current_branch.setter
    def current_branch(self, value):
        self._current_branch = (value, True)

    @property
    def notes(self):
        """
        Notes for this application.

        :rtype: ``basestring``
        """
        return self._notes[0]

    @notes.setter
    def notes(self, value):
        self._notes = (value, True)

    @property
    def last_updated(self):
        """
        Timestamp of the last update to the application.

        :rtype: ``basestring``
        """
        return self._last_updated[0]

    @last_updated.setter
    def last_updated(self, value):
        self._last_updated = (value, True)

    @property
    def properties(self):
        """
        Key/value pairs used to specify attributes for this application.

        :rtype: ``dict``
        """
        return self._properties[0]

    @properties.setter
    def properties(self, value):
        self._properties = (value, True)

