#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-branch.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_1.web.vo.NamedUserObject import NamedUserObject
from delphixpy.v1_3_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCBranch(NamedUserObject):
    """
    *(extends* :py:class:`v1_3_1.web.vo.NamedUserObject` *)* A branch
    represents a distinct timeline for data sources in an application.
    """
    def __init__(self, undef_enabled=True):
        super(DVCBranch, self).__init__()
        self._type = ("DVCBranch", True)
        self._application = (self.__undef__, True)
        self._parent_bookmark = (self.__undef__, True)

    API_VERSION = "1.3.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCBranch, cls).from_dict(data, dirty, undef_enabled)
        obj._application = (data.get("application", obj.__undef__), dirty)
        if obj._application[0] is not None and obj._application[0] is not obj.__undef__:
            assert isinstance(obj._application[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._application[0]))
            common.validate_format(obj._application[0], "objectReference", None, None)
        obj._parent_bookmark = (data.get("parentBookmark", obj.__undef__), dirty)
        if obj._parent_bookmark[0] is not None and obj._parent_bookmark[0] is not obj.__undef__:
            assert isinstance(obj._parent_bookmark[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._parent_bookmark[0]))
            common.validate_format(obj._parent_bookmark[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCBranch, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "application" == "type" or (self.application is not self.__undef__ and not (dirty and not self._application[1])):
            dct["application"] = dictify(self.application)
        if "parent_bookmark" == "type" or (self.parent_bookmark is not self.__undef__ and not (dirty and not self._parent_bookmark[1])):
            dct["parentBookmark"] = dictify(self.parent_bookmark)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._application = (self._application[0], True)
        self._parent_bookmark = (self._parent_bookmark[0], True)

    def is_dirty(self):
        return any([self._application[1], self._parent_bookmark[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCBranch):
            return False
        return super(DVCBranch, self).__eq__(other) and \
               self.application == other.application and \
               self.parent_bookmark == other.parent_bookmark

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def application(self):
        """
        A reference to the application this branch was created on.

        :rtype: ``basestring``
        """
        return self._application[0]

    @application.setter
    def application(self, value):
        self._application = (value, True)

    @property
    def parent_bookmark(self):
        """
        A reference to the bookmark this branch was created from.

        :rtype: ``basestring``
        """
        return self._parent_bookmark[0]

    @parent_bookmark.setter
    def parent_bookmark(self, value):
        self._parent_bookmark = (value, True)

