#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-data-source.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_1.web.vo.NamedUserObject import NamedUserObject
from delphixpy.v1_3_1 import factory
from delphixpy.v1_3_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCDataSource(NamedUserObject):
    """
    *(extends* :py:class:`v1_3_1.web.vo.NamedUserObject` *)* The data source
    used for Data Version Control applications.
    """
    def __init__(self, undef_enabled=True):
        super(DVCDataSource, self).__init__()
        self._type = ("DVCDataSource", True)
        self._container = (self.__undef__, True)
        self._description = (self.__undef__, True)
        self._enabled = (self.__undef__, True)
        self._application = (self.__undef__, True)
        self._runtime = (self.__undef__, True)
        self._properties = (self.__undef__, True)

    API_VERSION = "1.3.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCDataSource, cls).from_dict(data, dirty, undef_enabled)
        obj._container = (data.get("container", obj.__undef__), dirty)
        if obj._container[0] is not None and obj._container[0] is not obj.__undef__:
            assert isinstance(obj._container[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._container[0]))
            common.validate_format(obj._container[0], "objectReference", None, None)
        obj._description = (data.get("description", obj.__undef__), dirty)
        if obj._description[0] is not None and obj._description[0] is not obj.__undef__:
            assert isinstance(obj._description[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._description[0]))
            common.validate_format(obj._description[0], "None", None, 4096)
        obj._enabled = (data.get("enabled", obj.__undef__), dirty)
        if obj._enabled[0] is not None and obj._enabled[0] is not obj.__undef__:
            assert isinstance(obj._enabled[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._enabled[0]))
            common.validate_format(obj._enabled[0], "None", None, None)
        obj._application = (data.get("application", obj.__undef__), dirty)
        if obj._application[0] is not None and obj._application[0] is not obj.__undef__:
            assert isinstance(obj._application[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._application[0]))
            common.validate_format(obj._application[0], "objectReference", None, None)
        if "runtime" in data and data["runtime"] is not None:
            obj._runtime = (factory.create_object(data["runtime"], "SourceConnectionInfo"), dirty)
            factory.validate_type(obj._runtime[0], "SourceConnectionInfo")
        else:
            obj._runtime = (obj.__undef__, dirty)
        obj._properties = (data.get("properties", obj.__undef__), dirty)
        if obj._properties[0] is not None and obj._properties[0] is not obj.__undef__:
            assert isinstance(obj._properties[0], dict), ("Expected one of [u'object'], but got %s" % type(obj._properties[0]))
            common.validate_format(obj._properties[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCDataSource, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "container" == "type" or (self.container is not self.__undef__ and not (dirty and not self._container[1])):
            dct["container"] = dictify(self.container)
        if "description" == "type" or (self.description is not self.__undef__ and not (dirty and not self._description[1])):
            dct["description"] = dictify(self.description)
        if "enabled" == "type" or (self.enabled is not self.__undef__ and not (dirty and not self._enabled[1])):
            dct["enabled"] = dictify(self.enabled)
        if "application" == "type" or (self.application is not self.__undef__ and not (dirty and not self._application[1])):
            dct["application"] = dictify(self.application)
        if "runtime" == "type" or (self.runtime is not self.__undef__ and not (dirty and not self._runtime[1])):
            dct["runtime"] = dictify(self.runtime)
        if "properties" == "type" or (self.properties is not self.__undef__ and not (dirty and not self._properties[1])):
            dct["properties"] = dictify(self.properties)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._container = (self._container[0], True)
        self._description = (self._description[0], True)
        self._enabled = (self._enabled[0], True)
        self._application = (self._application[0], True)
        self._runtime = (self._runtime[0], True)
        self._properties = (self._properties[0], True)

    def is_dirty(self):
        return any([self._container[1], self._description[1], self._enabled[1], self._application[1], self._runtime[1], self._properties[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCDataSource):
            return False
        return super(DVCDataSource, self).__eq__(other) and \
               self.container == other.container and \
               self.description == other.description and \
               self.enabled == other.enabled and \
               self.application == other.application and \
               self.runtime == other.runtime and \
               self.properties == other.properties

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def container(self):
        """
        A reference to the underlying container.

        :rtype: ``basestring``
        """
        return self._container[0]

    @container.setter
    def container(self, value):
        self._container = (value, True)

    @property
    def description(self):
        """
        A description of this data source.

        :rtype: ``basestring``
        """
        return self._description[0]

    @description.setter
    def description(self, value):
        self._description = (value, True)

    @property
    def enabled(self):
        """
        Flag indicating whether the source is enabled.

        :rtype: ``bool``
        """
        return self._enabled[0]

    @enabled.setter
    def enabled(self, value):
        self._enabled = (value, True)

    @property
    def application(self):
        """
        A reference to the DVC application to which this source belongs.

        :rtype: ``basestring``
        """
        return self._application[0]

    @application.setter
    def application(self, value):
        self._application = (value, True)

    @property
    def runtime(self):
        """
        Runtime properties of this data source.

        :rtype: :py:class:`v1_3_1.web.vo.SourceConnectionInfo`
        """
        return self._runtime[0]

    @runtime.setter
    def runtime(self, value):
        self._runtime = (value, True)

    @property
    def properties(self):
        """
        Key/value pairs used to specify attributes for this data source.

        :rtype: ``dict``
        """
        return self._properties[0]

    @properties.setter
    def properties(self, value):
        self._properties = (value, True)

