#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-timeline-point-time-input.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_1.web.vo.DVCTimelinePointTimeParameters import DVCTimelinePointTimeParameters
from delphixpy.v1_3_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCTimelinePointTimeInput(DVCTimelinePointTimeParameters):
    """
    *(extends* :py:class:`v1_3_1.web.vo.DVCTimelinePointTimeParameters` *)*
    Specifies a point in time on the DVC timeline for a specific application.
    Latest provisionable points before the specified time will be used.
    """
    def __init__(self, undef_enabled=True):
        super(DVCTimelinePointTimeInput, self).__init__()
        self._type = ("DVCTimelinePointTimeInput", True)
        self._source_application = (self.__undef__, True)
        self._time = (self.__undef__, True)

    API_VERSION = "1.3.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCTimelinePointTimeInput, cls).from_dict(data, dirty, undef_enabled)
        if "sourceApplication" not in data:
            raise ValueError("Missing required property \"sourceApplication\".")
        obj._source_application = (data.get("sourceApplication", obj.__undef__), dirty)
        if obj._source_application[0] is not None and obj._source_application[0] is not obj.__undef__:
            assert isinstance(obj._source_application[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._source_application[0]))
            common.validate_format(obj._source_application[0], "objectReference", None, None)
        if "time" not in data:
            raise ValueError("Missing required property \"time\".")
        obj._time = (data.get("time", obj.__undef__), dirty)
        if obj._time[0] is not None and obj._time[0] is not obj.__undef__:
            assert isinstance(obj._time[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._time[0]))
            common.validate_format(obj._time[0], "date", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCTimelinePointTimeInput, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "source_application" == "type" or (self.source_application is not self.__undef__ and not (dirty and not self._source_application[1])):
            dct["sourceApplication"] = dictify(self.source_application)
        if "time" == "type" or (self.time is not self.__undef__ and not (dirty and not self._time[1])):
            dct["time"] = dictify(self.time)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._source_application = (self._source_application[0], True)
        self._time = (self._time[0], True)

    def is_dirty(self):
        return any([self._source_application[1], self._time[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCTimelinePointTimeInput):
            return False
        return super(DVCTimelinePointTimeInput, self).__eq__(other) and \
               self.source_application == other.source_application and \
               self.time == other.time

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def source_application(self):
        """
        The reference to the application used for this operation.

        :rtype: ``basestring``
        """
        return self._source_application[0]

    @source_application.setter
    def source_application(self, value):
        self._source_application = (value, True)

    @property
    def time(self):
        """
        A point in time on the application's timeline.

        :rtype: ``basestring``
        """
        return self._time[0]

    @time.setter
    def time(self, value):
        self._time = (value, True)

