#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-oracle-source.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_1.web.vo.Source import Source
from delphixpy.v1_3_1 import factory
from delphixpy.v1_3_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class OracleSource(Source):
    """
    *(extends* :py:class:`v1_3_1.web.vo.Source` *)* An Oracle source
    """
    def __init__(self, undef_enabled=True):
        super(OracleSource, self).__init__()
        self._type = ("OracleSource", True)
        self._runtime = (self.__undef__, True)
        self._role = (self.__undef__, True)

    API_VERSION = "1.3.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(OracleSource, cls).from_dict(data, dirty, undef_enabled)
        if "runtime" in data and data["runtime"] is not None:
            obj._runtime = (factory.create_object(data["runtime"], "OracleSourceRuntime"), dirty)
            factory.validate_type(obj._runtime[0], "OracleSourceRuntime")
        else:
            obj._runtime = (obj.__undef__, dirty)
        obj._role = (data.get("role", obj.__undef__), dirty)
        if obj._role[0] is not None and obj._role[0] is not obj.__undef__:
            assert isinstance(obj._role[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._role[0]))
            assert obj._role[0] in [u'PHYSICAL_STANDBY', u'PRIMARY', u'UNKNOWN'], "Expected enum [u'PHYSICAL_STANDBY', u'PRIMARY', u'UNKNOWN'] but got %s" % obj._role[0]
            common.validate_format(obj._role[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(OracleSource, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "runtime" == "type" or (self.runtime is not self.__undef__ and not (dirty and not self._runtime[1])):
            dct["runtime"] = dictify(self.runtime)
        if "role" == "type" or (self.role is not self.__undef__ and not (dirty and not self._role[1])):
            dct["role"] = dictify(self.role)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._runtime = (self._runtime[0], True)
        self._role = (self._role[0], True)

    def is_dirty(self):
        return any([self._runtime[1], self._role[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, OracleSource):
            return False
        return super(OracleSource, self).__eq__(other) and \
               self.runtime == other.runtime and \
               self.role == other.role

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def runtime(self):
        """
        Runtime properties for this Oracle source.

        :rtype: :py:class:`v1_3_1.web.vo.OracleSourceRuntime`
        """
        return self._runtime[0]

    @runtime.setter
    def runtime(self, value):
        self._runtime = (value, True)

    @property
    def role(self):
        """
        Operating role of the database. *(permitted values: PHYSICAL_STANDBY,
        PRIMARY, UNKNOWN)*

        :rtype: ``basestring``
        """
        return self._role[0]

    @role.setter
    def role(self, value):
        self._role = (value, True)

