#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-oracle-source-runtime.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_1.web.vo.SourceRuntime import SourceRuntime
from delphixpy.v1_3_1 import factory
from delphixpy.v1_3_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class OracleSourceRuntime(SourceRuntime):
    """
    *(extends* :py:class:`v1_3_1.web.vo.SourceRuntime` *)* Runtime (non-
    persistent) properties of an Oracle source.
    """
    def __init__(self, undef_enabled=True):
        super(OracleSourceRuntime, self).__init__()
        self._type = ("OracleSourceRuntime", True)
        self._database_stats = (self.__undef__, True)
        self._bct_enabled = (self.__undef__, True)
        self._active_instances = (self.__undef__, True)
        self._database_mode = (self.__undef__, True)
        self._archivelog_enabled = (self.__undef__, True)
        self._last_non_logged_location = (self.__undef__, True)
        self._dnfs_enabled = (self.__undef__, True)
        self._rac_enabled = (self.__undef__, True)

    API_VERSION = "1.3.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(OracleSourceRuntime, cls).from_dict(data, dirty, undef_enabled)
        obj._database_stats = []
        for item in data.get("databaseStats") or []:
            obj._database_stats.append(factory.create_object(item))
            factory.validate_type(obj._database_stats[-1], "OracleDatabaseStatsSection")
        obj._database_stats = (obj._database_stats, dirty)
        obj._bct_enabled = (data.get("bctEnabled", obj.__undef__), dirty)
        if obj._bct_enabled[0] is not None and obj._bct_enabled[0] is not obj.__undef__:
            assert isinstance(obj._bct_enabled[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._bct_enabled[0]))
            common.validate_format(obj._bct_enabled[0], "None", None, None)
        obj._active_instances = []
        for item in data.get("activeInstances") or []:
            obj._active_instances.append(factory.create_object(item))
            factory.validate_type(obj._active_instances[-1], "OracleActiveInstance")
        obj._active_instances = (obj._active_instances, dirty)
        obj._database_mode = (data.get("databaseMode", obj.__undef__), dirty)
        if obj._database_mode[0] is not None and obj._database_mode[0] is not obj.__undef__:
            assert isinstance(obj._database_mode[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._database_mode[0]))
            assert obj._database_mode[0] in [u'READ_WRITE', u'READ_ONLY', u'STANDBY_READ_ONLY', u'MOUNTED_ONLY', u'UNKNOWN'], "Expected enum [u'READ_WRITE', u'READ_ONLY', u'STANDBY_READ_ONLY', u'MOUNTED_ONLY', u'UNKNOWN'] but got %s" % obj._database_mode[0]
            common.validate_format(obj._database_mode[0], "None", None, None)
        obj._archivelog_enabled = (data.get("archivelogEnabled", obj.__undef__), dirty)
        if obj._archivelog_enabled[0] is not None and obj._archivelog_enabled[0] is not obj.__undef__:
            assert isinstance(obj._archivelog_enabled[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._archivelog_enabled[0]))
            common.validate_format(obj._archivelog_enabled[0], "None", None, None)
        obj._last_non_logged_location = (data.get("lastNonLoggedLocation", obj.__undef__), dirty)
        if obj._last_non_logged_location[0] is not None and obj._last_non_logged_location[0] is not obj.__undef__:
            assert isinstance(obj._last_non_logged_location[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._last_non_logged_location[0]))
            common.validate_format(obj._last_non_logged_location[0], "None", None, None)
        obj._dnfs_enabled = (data.get("dnfsEnabled", obj.__undef__), dirty)
        if obj._dnfs_enabled[0] is not None and obj._dnfs_enabled[0] is not obj.__undef__:
            assert isinstance(obj._dnfs_enabled[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._dnfs_enabled[0]))
            common.validate_format(obj._dnfs_enabled[0], "None", None, None)
        obj._rac_enabled = (data.get("racEnabled", obj.__undef__), dirty)
        if obj._rac_enabled[0] is not None and obj._rac_enabled[0] is not obj.__undef__:
            assert isinstance(obj._rac_enabled[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._rac_enabled[0]))
            common.validate_format(obj._rac_enabled[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(OracleSourceRuntime, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "database_stats" == "type" or (self.database_stats is not self.__undef__ and not (dirty and not self._database_stats[1])):
            dct["databaseStats"] = dictify(self.database_stats)
        if "bct_enabled" == "type" or (self.bct_enabled is not self.__undef__ and not (dirty and not self._bct_enabled[1])):
            dct["bctEnabled"] = dictify(self.bct_enabled)
        if "active_instances" == "type" or (self.active_instances is not self.__undef__ and not (dirty and not self._active_instances[1])):
            dct["activeInstances"] = dictify(self.active_instances)
        if "database_mode" == "type" or (self.database_mode is not self.__undef__ and not (dirty and not self._database_mode[1])):
            dct["databaseMode"] = dictify(self.database_mode)
        if "archivelog_enabled" == "type" or (self.archivelog_enabled is not self.__undef__ and not (dirty and not self._archivelog_enabled[1])):
            dct["archivelogEnabled"] = dictify(self.archivelog_enabled)
        if "last_non_logged_location" == "type" or (self.last_non_logged_location is not self.__undef__ and not (dirty and not self._last_non_logged_location[1])):
            dct["lastNonLoggedLocation"] = dictify(self.last_non_logged_location)
        if "dnfs_enabled" == "type" or (self.dnfs_enabled is not self.__undef__ and not (dirty and not self._dnfs_enabled[1])):
            dct["dnfsEnabled"] = dictify(self.dnfs_enabled)
        if "rac_enabled" == "type" or (self.rac_enabled is not self.__undef__ and not (dirty and not self._rac_enabled[1])):
            dct["racEnabled"] = dictify(self.rac_enabled)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._database_stats = (self._database_stats[0], True)
        self._bct_enabled = (self._bct_enabled[0], True)
        self._active_instances = (self._active_instances[0], True)
        self._database_mode = (self._database_mode[0], True)
        self._archivelog_enabled = (self._archivelog_enabled[0], True)
        self._last_non_logged_location = (self._last_non_logged_location[0], True)
        self._dnfs_enabled = (self._dnfs_enabled[0], True)
        self._rac_enabled = (self._rac_enabled[0], True)

    def is_dirty(self):
        return any([self._database_stats[1], self._bct_enabled[1], self._active_instances[1], self._database_mode[1], self._archivelog_enabled[1], self._last_non_logged_location[1], self._dnfs_enabled[1], self._rac_enabled[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, OracleSourceRuntime):
            return False
        return super(OracleSourceRuntime, self).__eq__(other) and \
               self.database_stats == other.database_stats and \
               self.bct_enabled == other.bct_enabled and \
               self.active_instances == other.active_instances and \
               self.database_mode == other.database_mode and \
               self.archivelog_enabled == other.archivelog_enabled and \
               self.last_non_logged_location == other.last_non_logged_location and \
               self.dnfs_enabled == other.dnfs_enabled and \
               self.rac_enabled == other.rac_enabled

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def database_stats(self):
        """
        Table of key database performance statistics.

        :rtype: ``list`` of
            :py:class:`v1_3_1.web.vo.OracleDatabaseStatsSection`
        """
        return self._database_stats[0]

    @database_stats.setter
    def database_stats(self, value):
        self._database_stats = (value, True)

    @property
    def bct_enabled(self):
        """
        True if block change tracking is enabled.

        :rtype: ``bool``
        """
        return self._bct_enabled[0]

    @bct_enabled.setter
    def bct_enabled(self, value):
        self._bct_enabled = (value, True)

    @property
    def active_instances(self):
        """
        List of active database instances for the source.

        :rtype: ``list`` of :py:class:`v1_3_1.web.vo.OracleActiveInstance`
        """
        return self._active_instances[0]

    @active_instances.setter
    def active_instances(self, value):
        self._active_instances = (value, True)

    @property
    def database_mode(self):
        """
        *(default value: UNKNOWN)* Operating mode of the database. *(permitted
        values: READ_WRITE, READ_ONLY, STANDBY_READ_ONLY, MOUNTED_ONLY,
        UNKNOWN)*

        :rtype: ``basestring``
        """
        return self._database_mode[0]

    @database_mode.setter
    def database_mode(self, value):
        self._database_mode = (value, True)

    @property
    def archivelog_enabled(self):
        """
        True if the database is running in ARCHIVELOG mode.

        :rtype: ``bool``
        """
        return self._archivelog_enabled[0]

    @archivelog_enabled.setter
    def archivelog_enabled(self, value):
        self._archivelog_enabled = (value, True)

    @property
    def last_non_logged_location(self):
        """
        Highest SCN at which non-logged changes were generated.

        :rtype: ``basestring``
        """
        return self._last_non_logged_location[0]

    @last_non_logged_location.setter
    def last_non_logged_location(self, value):
        self._last_non_logged_location = (value, True)

    @property
    def dnfs_enabled(self):
        """
        True if the database has Oracle Direct NFS client enabled.

        :rtype: ``bool``
        """
        return self._dnfs_enabled[0]

    @dnfs_enabled.setter
    def dnfs_enabled(self, value):
        self._dnfs_enabled = (value, True)

    @property
    def rac_enabled(self):
        """
        True for a RAC source database.

        :rtype: ``bool``
        """
        return self._rac_enabled[0]

    @rac_enabled.setter
    def rac_enabled(self, value):
        self._rac_enabled = (value, True)

