#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-bookmark-create-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_2.web.vo.TypedObject import TypedObject
from delphixpy.v1_3_2 import factory
from delphixpy.v1_3_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCBookmarkCreateParameters(TypedObject):
    """
    *(extends* :py:class:`v1_3_2.web.vo.TypedObject` *)* The parameters used to
    create a DVC bookmark.
    """
    def __init__(self, undef_enabled=True):
        super(DVCBookmarkCreateParameters, self).__init__()
        self._type = ("DVCBookmarkCreateParameters", True)
        self._bookmark = (self.__undef__, True)
        self._timeline_point_parameters = (self.__undef__, True)

    API_VERSION = "1.3.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCBookmarkCreateParameters, cls).from_dict(data, dirty, undef_enabled)
        if "bookmark" in data and data["bookmark"] is not None:
            obj._bookmark = (factory.create_object(data["bookmark"], "DVCBookmark"), dirty)
            factory.validate_type(obj._bookmark[0], "DVCBookmark")
        else:
            obj._bookmark = (obj.__undef__, dirty)
        if "timelinePointParameters" not in data:
            raise ValueError("Missing required property \"timelinePointParameters\".")
        if "timelinePointParameters" in data and data["timelinePointParameters"] is not None:
            obj._timeline_point_parameters = (factory.create_object(data["timelinePointParameters"], "DVCTimelinePointTimeParameters"), dirty)
            factory.validate_type(obj._timeline_point_parameters[0], "DVCTimelinePointTimeParameters")
        else:
            obj._timeline_point_parameters = (obj.__undef__, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCBookmarkCreateParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "bookmark" == "type" or (self.bookmark is not self.__undef__ and not (dirty and not self._bookmark[1])):
            dct["bookmark"] = dictify(self.bookmark)
        if "timeline_point_parameters" == "type" or (self.timeline_point_parameters is not self.__undef__ and not (dirty and not self._timeline_point_parameters[1])):
            dct["timelinePointParameters"] = dictify(self.timeline_point_parameters)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._bookmark = (self._bookmark[0], True)
        self._timeline_point_parameters = (self._timeline_point_parameters[0], True)

    def is_dirty(self):
        return any([self._bookmark[1], self._timeline_point_parameters[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCBookmarkCreateParameters):
            return False
        return super(DVCBookmarkCreateParameters, self).__eq__(other) and \
               self.bookmark == other.bookmark and \
               self.timeline_point_parameters == other.timeline_point_parameters

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def bookmark(self):
        """
        The DVC bookmark object.

        :rtype: :py:class:`v1_3_2.web.vo.DVCBookmark`
        """
        return self._bookmark[0]

    @bookmark.setter
    def bookmark(self, value):
        self._bookmark = (value, True)

    @property
    def timeline_point_parameters(self):
        """
        The DVC data timeline point at which the bookmark will be created.

        :rtype: :py:class:`v1_3_2.web.vo.DVCTimelinePointTimeParameters`
        """
        return self._timeline_point_parameters[0]

    @timeline_point_parameters.setter
    def timeline_point_parameters(self, value):
        self._timeline_point_parameters = (value, True)

