#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-pgsql-attach-source-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_2.web.vo.AttachSourceParameters import AttachSourceParameters
from delphixpy.v1_3_2 import factory
from delphixpy.v1_3_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class PgSQLAttachSourceParameters(AttachSourceParameters):
    """
    *(extends* :py:class:`v1_3_2.web.vo.AttachSourceParameters` *)* Represents
    the PostgreSQL specific parameters of an attach request.
    """
    def __init__(self, undef_enabled=True):
        super(PgSQLAttachSourceParameters, self).__init__()
        self._type = ("PgSQLAttachSourceParameters", True)
        self._ppt_host_user = (self.__undef__, True)
        self._db_credentials = (self.__undef__, True)
        self._connection_database = (self.__undef__, True)
        self._db_user = (self.__undef__, True)
        self._ppt_repository = (self.__undef__, True)

    API_VERSION = "1.3.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(PgSQLAttachSourceParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._ppt_host_user = (data.get("pptHostUser", obj.__undef__), dirty)
        if obj._ppt_host_user[0] is not None and obj._ppt_host_user[0] is not obj.__undef__:
            assert isinstance(obj._ppt_host_user[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._ppt_host_user[0]))
            common.validate_format(obj._ppt_host_user[0], "objectReference", None, None)
        if "dbCredentials" in data and data["dbCredentials"] is not None:
            obj._db_credentials = (factory.create_object(data["dbCredentials"], "PasswordCredential"), dirty)
            factory.validate_type(obj._db_credentials[0], "PasswordCredential")
        else:
            obj._db_credentials = (obj.__undef__, dirty)
        obj._connection_database = (data.get("connectionDatabase", obj.__undef__), dirty)
        if obj._connection_database[0] is not None and obj._connection_database[0] is not obj.__undef__:
            assert isinstance(obj._connection_database[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._connection_database[0]))
            common.validate_format(obj._connection_database[0], "None", None, 256)
        obj._db_user = (data.get("dbUser", obj.__undef__), dirty)
        if obj._db_user[0] is not None and obj._db_user[0] is not obj.__undef__:
            assert isinstance(obj._db_user[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._db_user[0]))
            common.validate_format(obj._db_user[0], "None", None, None)
        obj._ppt_repository = (data.get("pptRepository", obj.__undef__), dirty)
        if obj._ppt_repository[0] is not None and obj._ppt_repository[0] is not obj.__undef__:
            assert isinstance(obj._ppt_repository[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._ppt_repository[0]))
            common.validate_format(obj._ppt_repository[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(PgSQLAttachSourceParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "ppt_host_user" == "type" or (self.ppt_host_user is not self.__undef__ and not (dirty and not self._ppt_host_user[1])):
            dct["pptHostUser"] = dictify(self.ppt_host_user)
        if "db_credentials" == "type" or (self.db_credentials is not self.__undef__ and not (dirty and not self._db_credentials[1])):
            dct["dbCredentials"] = dictify(self.db_credentials)
        if "connection_database" == "type" or (self.connection_database is not self.__undef__ and not (dirty and not self._connection_database[1])):
            dct["connectionDatabase"] = dictify(self.connection_database)
        if "db_user" == "type" or (self.db_user is not self.__undef__ and not (dirty and not self._db_user[1])):
            dct["dbUser"] = dictify(self.db_user)
        if "ppt_repository" == "type" or (self.ppt_repository is not self.__undef__ and not (dirty and not self._ppt_repository[1])):
            dct["pptRepository"] = dictify(self.ppt_repository)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._ppt_host_user = (self._ppt_host_user[0], True)
        self._db_credentials = (self._db_credentials[0], True)
        self._connection_database = (self._connection_database[0], True)
        self._db_user = (self._db_user[0], True)
        self._ppt_repository = (self._ppt_repository[0], True)

    def is_dirty(self):
        return any([self._ppt_host_user[1], self._db_credentials[1], self._connection_database[1], self._db_user[1], self._ppt_repository[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, PgSQLAttachSourceParameters):
            return False
        return super(PgSQLAttachSourceParameters, self).__eq__(other) and \
               self.ppt_host_user == other.ppt_host_user and \
               self.db_credentials == other.db_credentials and \
               self.connection_database == other.connection_database and \
               self.db_user == other.db_user and \
               self.ppt_repository == other.ppt_repository

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def ppt_host_user(self):
        """
        OS user on the staging host to use for linking.

        :rtype: ``basestring``
        """
        return self._ppt_host_user[0]

    @ppt_host_user.setter
    def ppt_host_user(self, value):
        self._ppt_host_user = (value, True)

    @property
    def db_credentials(self):
        """
        The PostgreSQL login password for the source DB user.

        :rtype: :py:class:`v1_3_2.web.vo.PasswordCredential`
        """
        return self._db_credentials[0]

    @db_credentials.setter
    def db_credentials(self, value):
        self._db_credentials = (value, True)

    @property
    def connection_database(self):
        """
        *(default value: postgres)* The database that must be used to run SQL
        queries against this cluster.

        :rtype: ``basestring``
        """
        return self._connection_database[0]

    @connection_database.setter
    def connection_database(self, value):
        self._connection_database = (value, True)

    @property
    def db_user(self):
        """
        The PostgreSQL login username for the source DB user.

        :rtype: ``basestring``
        """
        return self._db_user[0]

    @db_user.setter
    def db_user(self, value):
        self._db_user = (value, True)

    @property
    def ppt_repository(self):
        """
        The PostgreSQL instance on the staging environment to use for pre-
        provisioning.

        :rtype: ``basestring``
        """
        return self._ppt_repository[0]

    @ppt_repository.setter
    def ppt_repository(self, value):
        self._ppt_repository = (value, True)

