#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dvc-bookmark.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_3.web.vo.NamedUserObject import NamedUserObject
from delphixpy.v1_3_3 import factory
from delphixpy.v1_3_3 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class DVCBookmark(NamedUserObject):
    """
    *(extends* :py:class:`v1_3_3.web.vo.NamedUserObject` *)* A named entity
    that represents a point in time for all of the data sources in an
    application.
    """
    def __init__(self, undef_enabled=True):
        super(DVCBookmark, self).__init__()
        self._type = ("DVCBookmark", True)
        self._container = (self.__undef__, True)
        self._description = (self.__undef__, True)
        self._tags = (self.__undef__, True)
        self._timestamp = (self.__undef__, True)
        self._branch = (self.__undef__, True)
        self._shared = (self.__undef__, True)
        self._template = (self.__undef__, True)

    API_VERSION = "1.3.3"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DVCBookmark, cls).from_dict(data, dirty, undef_enabled)
        obj._container = (data.get("container", obj.__undef__), dirty)
        if obj._container[0] is not None and obj._container[0] is not obj.__undef__:
            assert isinstance(obj._container[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._container[0]))
            common.validate_format(obj._container[0], "objectReference", None, None)
        obj._description = (data.get("description", obj.__undef__), dirty)
        if obj._description[0] is not None and obj._description[0] is not obj.__undef__:
            assert isinstance(obj._description[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._description[0]))
            common.validate_format(obj._description[0], "None", None, 4096)
        obj._tags = []
        for item in data.get("tags") or []:
            obj._tags.append(factory.create_object(item))
            factory.validate_type(obj._tags[-1], "DVCBookmarkTag")
        obj._tags = (obj._tags, dirty)
        obj._timestamp = (data.get("timestamp", obj.__undef__), dirty)
        if obj._timestamp[0] is not None and obj._timestamp[0] is not obj.__undef__:
            assert isinstance(obj._timestamp[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._timestamp[0]))
            common.validate_format(obj._timestamp[0], "date", None, None)
        obj._branch = (data.get("branch", obj.__undef__), dirty)
        if obj._branch[0] is not None and obj._branch[0] is not obj.__undef__:
            assert isinstance(obj._branch[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._branch[0]))
            common.validate_format(obj._branch[0], "objectReference", None, None)
        obj._shared = (data.get("shared", obj.__undef__), dirty)
        if obj._shared[0] is not None and obj._shared[0] is not obj.__undef__:
            assert isinstance(obj._shared[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._shared[0]))
            common.validate_format(obj._shared[0], "None", None, None)
        obj._template = (data.get("template", obj.__undef__), dirty)
        if obj._template[0] is not None and obj._template[0] is not obj.__undef__:
            assert isinstance(obj._template[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._template[0]))
            common.validate_format(obj._template[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(DVCBookmark, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "container" == "type" or (self.container is not self.__undef__ and not (dirty and not self._container[1])):
            dct["container"] = dictify(self.container)
        if "description" == "type" or (self.description is not self.__undef__ and not (dirty and not self._description[1])):
            dct["description"] = dictify(self.description)
        if "tags" == "type" or (self.tags is not self.__undef__ and not (dirty and not self._tags[1])):
            dct["tags"] = dictify(self.tags)
        if "timestamp" == "type" or (self.timestamp is not self.__undef__ and not (dirty and not self._timestamp[1])):
            dct["timestamp"] = dictify(self.timestamp)
        if "branch" == "type" or (self.branch is not self.__undef__ and not (dirty and not self._branch[1])):
            dct["branch"] = dictify(self.branch)
        if "shared" == "type" or (self.shared is not self.__undef__ and not (dirty and not self._shared[1])):
            dct["shared"] = dictify(self.shared)
        if "template" == "type" or (self.template is not self.__undef__ and not (dirty and not self._template[1])):
            dct["template"] = dictify(self.template)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._container = (self._container[0], True)
        self._description = (self._description[0], True)
        self._tags = (self._tags[0], True)
        self._timestamp = (self._timestamp[0], True)
        self._branch = (self._branch[0], True)
        self._shared = (self._shared[0], True)
        self._template = (self._template[0], True)

    def is_dirty(self):
        return any([self._container[1], self._description[1], self._tags[1], self._timestamp[1], self._branch[1], self._shared[1], self._template[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DVCBookmark):
            return False
        return super(DVCBookmark, self).__eq__(other) and \
               self.container == other.container and \
               self.description == other.description and \
               self.tags == other.tags and \
               self.timestamp == other.timestamp and \
               self.branch == other.branch and \
               self.shared == other.shared and \
               self.template == other.template

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def container(self):
        """
        The application container this bookmark was created on. This will be
        null if the bookmark was created on an application template.

        :rtype: ``basestring``
        """
        return self._container[0]

    @container.setter
    def container(self, value):
        self._container = (value, True)

    @property
    def description(self):
        """
        Description of this bookmark.

        :rtype: ``basestring``
        """
        return self._description[0]

    @description.setter
    def description(self, value):
        self._description = (value, True)

    @property
    def tags(self):
        """
        A set of user-defined labels for this bookmark.

        :rtype: ``list`` of :py:class:`v1_3_3.web.vo.DVCBookmarkTag`
        """
        return self._tags[0]

    @tags.setter
    def tags(self, value):
        self._tags = (value, True)

    @property
    def timestamp(self):
        """
        The time when this bookmark was created.

        :rtype: ``basestring``
        """
        return self._timestamp[0]

    @timestamp.setter
    def timestamp(self, value):
        self._timestamp = (value, True)

    @property
    def branch(self):
        """
        A reference to the DVC application branch this bookmark applies to.

        :rtype: ``basestring``
        """
        return self._branch[0]

    @branch.setter
    def branch(self, value):
        self._branch = (value, True)

    @property
    def shared(self):
        """
        True if this bookmark is shared.

        :rtype: ``bool``
        """
        return self._shared[0]

    @shared.setter
    def shared(self, value):
        self._shared = (value, True)

    @property
    def template(self):
        """
        The application template this bookmark was created on or the template
        of the application container this bookmark was created on.

        :rtype: ``basestring``
        """
        return self._template[0]

    @template.setter
    def template(self, value):
        self._template = (value, True)

