#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-file-upload-result.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_3.web.vo.TypedObject import TypedObject
from delphixpy.v1_3_3 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class FileUploadResult(TypedObject):
    """
    *(extends* :py:class:`v1_3_3.web.vo.TypedObject` *)* Result of a file
    upload request.
    """
    def __init__(self, undef_enabled=True):
        super(FileUploadResult, self).__init__()
        self._type = ("FileUploadResult", True)
        self._token = (self.__undef__, True)
        self._post_url = (self.__undef__, True)

    API_VERSION = "1.3.3"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(FileUploadResult, cls).from_dict(data, dirty, undef_enabled)
        obj._token = (data.get("token", obj.__undef__), dirty)
        if obj._token[0] is not None and obj._token[0] is not obj.__undef__:
            assert isinstance(obj._token[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._token[0]))
            common.validate_format(obj._token[0], "None", None, None)
        obj._post_url = (data.get("postUrl", obj.__undef__), dirty)
        if obj._post_url[0] is not None and obj._post_url[0] is not obj.__undef__:
            assert isinstance(obj._post_url[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._post_url[0]))
            common.validate_format(obj._post_url[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(FileUploadResult, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "token" == "type" or (self.token is not self.__undef__ and not (dirty and not self._token[1])):
            dct["token"] = dictify(self.token)
        if "post_url" == "type" or (self.post_url is not self.__undef__ and not (dirty and not self._post_url[1])):
            dct["postUrl"] = dictify(self.post_url)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._token = (self._token[0], True)
        self._post_url = (self._post_url[0], True)

    def is_dirty(self):
        return any([self._token[1], self._post_url[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, FileUploadResult):
            return False
        return super(FileUploadResult, self).__eq__(other) and \
               self.token == other.token and \
               self.post_url == other.post_url

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def token(self):
        """
        Token to pass with upload to identify the upload.

        :rtype: ``basestring``
        """
        return self._token[0]

    @token.setter
    def token(self, value):
        self._token = (value, True)

    @property
    def post_url(self):
        """
        URL to upload to.

        :rtype: ``basestring``
        """
        return self._post_url[0]

    @post_url.setter
    def post_url(self, value):
        self._post_url = (value, True)

