#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-oracle-rac-instance.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_3.web.vo.OracleInstance import OracleInstance
from delphixpy.v1_3_3 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class OracleRACInstance(OracleInstance):
    """
    *(extends* :py:class:`v1_3_3.web.vo.OracleInstance` *)* The representation
    of an Oracle Database RAC Instance Configuration.
    """
    def __init__(self, undef_enabled=True):
        super(OracleRACInstance, self).__init__()
        self._type = ("OracleRACInstance", True)
        self._node = (self.__undef__, True)

    API_VERSION = "1.3.3"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(OracleRACInstance, cls).from_dict(data, dirty, undef_enabled)
        obj._node = (data.get("node", obj.__undef__), dirty)
        if obj._node[0] is not None and obj._node[0] is not obj.__undef__:
            assert isinstance(obj._node[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._node[0]))
            common.validate_format(obj._node[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(OracleRACInstance, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "node" == "type" or (self.node is not self.__undef__ and not (dirty and not self._node[1])):
            dct["node"] = dictify(self.node)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._node = (self._node[0], True)

    def is_dirty(self):
        return any([self._node[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, OracleRACInstance):
            return False
        return super(OracleRACInstance, self).__eq__(other) and \
               self.node == other.node

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def node(self):
        """
        Reference to the Oracle cluster node that the RAC instance is running
        on.

        :rtype: ``basestring``
        """
        return self._node[0]

    @node.setter
    def node(self, value):
        self._node = (value, True)

