#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-oracle-si-source-connection-info.json
#
# Do not edit this file manually!
#

from delphixpy.v1_3_3.web.vo.OracleSourceConnectionInfo import OracleSourceConnectionInfo
from delphixpy.v1_3_3 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class OracleSISourceConnectionInfo(OracleSourceConnectionInfo):
    """
    *(extends* :py:class:`v1_3_3.web.vo.OracleSourceConnectionInfo` *)*
    Contains information that can be used to connect to a single instance
    Oracle source.
    """
    def __init__(self, undef_enabled=True):
        super(OracleSISourceConnectionInfo, self).__init__()
        self._type = ("OracleSISourceConnectionInfo", True)
        self._host = (self.__undef__, True)

    API_VERSION = "1.3.3"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(OracleSISourceConnectionInfo, cls).from_dict(data, dirty, undef_enabled)
        obj._host = (data.get("host", obj.__undef__), dirty)
        if obj._host[0] is not None and obj._host[0] is not obj.__undef__:
            assert isinstance(obj._host[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._host[0]))
            common.validate_format(obj._host[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(OracleSISourceConnectionInfo, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "host" == "type" or (self.host is not self.__undef__ and not (dirty and not self._host[1])):
            dct["host"] = dictify(self.host)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._host = (self._host[0], True)

    def is_dirty(self):
        return any([self._host[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, OracleSISourceConnectionInfo):
            return False
        return super(OracleSISourceConnectionInfo, self).__eq__(other) and \
               self.host == other.host

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def host(self):
        """
        The hostname or IP address of the host where the source resides.

        :rtype: ``basestring``
        """
        return self._host[0]

    @host.setter
    def host(self, value):
        self._host = (value, True)

