#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-network-route-lookup-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_4_1.web.vo.TypedObject import TypedObject
from delphixpy.v1_4_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class NetworkRouteLookupParameters(TypedObject):
    """
    *(extends* :py:class:`v1_4_1.web.vo.TypedObject` *)* Parameters used for a
    routing table lookup.
    """
    def __init__(self, undef_enabled=True):
        super(NetworkRouteLookupParameters, self).__init__()
        self._type = ("NetworkRouteLookupParameters", True)
        self._destination = (self.__undef__, True)

    API_VERSION = "1.4.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(NetworkRouteLookupParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._destination = (data.get("destination", obj.__undef__), dirty)
        if obj._destination[0] is not None and obj._destination[0] is not obj.__undef__:
            assert isinstance(obj._destination[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._destination[0]))
            common.validate_format(obj._destination[0], "host", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(NetworkRouteLookupParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "destination" == "type" or (self.destination is not self.__undef__ and not (dirty and not self._destination[1])):
            dct["destination"] = dictify(self.destination)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._destination = (self._destination[0], True)

    def is_dirty(self):
        return any([self._destination[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, NetworkRouteLookupParameters):
            return False
        return super(NetworkRouteLookupParameters, self).__eq__(other) and \
               self.destination == other.destination

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def destination(self):
        """
        Destination address or hostname.

        :rtype: ``basestring``
        """
        return self._destination[0]

    @destination.setter
    def destination(self, value):
        self._destination = (value, True)

