#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-analytics-network-interface-util-datapoint-stream.json
#
# Do not edit this file manually!
#

from delphixpy.v1_4_2.web.vo.DatapointStream import DatapointStream
from delphixpy.v1_4_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class NetworkInterfaceUtilDatapointStream(DatapointStream):
    """
    *(extends* :py:class:`v1_4_2.web.vo.DatapointStream` *)* A stream of
    datapoints from a NETWORK_INTERFACE_UTIL analytics slice.
    """
    def __init__(self, undef_enabled=True):
        super(NetworkInterfaceUtilDatapointStream, self).__init__()
        self._type = ("NetworkInterfaceUtilDatapointStream", True)
        self._network_interface = (self.__undef__, True)

    API_VERSION = "1.4.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(NetworkInterfaceUtilDatapointStream, cls).from_dict(data, dirty, undef_enabled)
        obj._network_interface = (data.get("networkInterface", obj.__undef__), dirty)
        if obj._network_interface[0] is not None and obj._network_interface[0] is not obj.__undef__:
            assert isinstance(obj._network_interface[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._network_interface[0]))
            common.validate_format(obj._network_interface[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(NetworkInterfaceUtilDatapointStream, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "network_interface" == "type" or (self.network_interface is not self.__undef__ and not (dirty and not self._network_interface[1])):
            dct["networkInterface"] = dictify(self.network_interface)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._network_interface = (self._network_interface[0], True)

    def is_dirty(self):
        return any([self._network_interface[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, NetworkInterfaceUtilDatapointStream):
            return False
        return super(NetworkInterfaceUtilDatapointStream, self).__eq__(other) and \
               self.network_interface == other.network_interface

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def network_interface(self):
        """
        Which network interface was utilized.

        :rtype: ``basestring``
        """
        return self._network_interface[0]

    @network_interface.setter
    def network_interface(self, value):
        self._network_interface = (value, True)

