#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-network-throughput-test-execute-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_4_3.web.vo.TypedObject import TypedObject
from delphixpy.v1_4_3 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class NetworkThroughputTestExecuteParameters(TypedObject):
    """
    *(extends* :py:class:`v1_4_3.web.vo.TypedObject` *)* Parameters used to
    execute a network throughput test.
    """
    def __init__(self, undef_enabled=True):
        super(NetworkThroughputTestExecuteParameters, self).__init__()
        self._type = ("NetworkThroughputTestExecuteParameters", True)
        self._duration = (self.__undef__, True)
        self._direction = (self.__undef__, True)
        self._remote_host = (self.__undef__, True)
        self._num_connections = (self.__undef__, True)

    API_VERSION = "1.4.3"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(NetworkThroughputTestExecuteParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._duration = (data.get("duration", obj.__undef__), dirty)
        if obj._duration[0] is not None and obj._duration[0] is not obj.__undef__:
            assert isinstance(obj._duration[0], int), ("Expected one of [u'integer'], but got %s" % type(obj._duration[0]))
            common.validate_format(obj._duration[0], "None", None, None)
        obj._direction = (data.get("direction", obj.__undef__), dirty)
        if obj._direction[0] is not None and obj._direction[0] is not obj.__undef__:
            assert isinstance(obj._direction[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._direction[0]))
            assert obj._direction[0] in [u'TRANSMIT', u'RECEIVE'], "Expected enum [u'TRANSMIT', u'RECEIVE'] but got %s" % obj._direction[0]
            common.validate_format(obj._direction[0], "None", None, None)
        obj._remote_host = (data.get("remoteHost", obj.__undef__), dirty)
        if obj._remote_host[0] is not None and obj._remote_host[0] is not obj.__undef__:
            assert isinstance(obj._remote_host[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._remote_host[0]))
            common.validate_format(obj._remote_host[0], "objectReference", None, None)
        obj._num_connections = (data.get("numConnections", obj.__undef__), dirty)
        if obj._num_connections[0] is not None and obj._num_connections[0] is not obj.__undef__:
            assert isinstance(obj._num_connections[0], int), ("Expected one of [u'integer'], but got %s" % type(obj._num_connections[0]))
            common.validate_format(obj._num_connections[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(NetworkThroughputTestExecuteParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "duration" == "type" or (self.duration is not self.__undef__ and not (dirty and not self._duration[1])):
            dct["duration"] = dictify(self.duration)
        if "direction" == "type" or (self.direction is not self.__undef__ and not (dirty and not self._direction[1])):
            dct["direction"] = dictify(self.direction)
        if "remote_host" == "type" or (self.remote_host is not self.__undef__ and not (dirty and not self._remote_host[1])):
            dct["remoteHost"] = dictify(self.remote_host)
        if "num_connections" == "type" or (self.num_connections is not self.__undef__ and not (dirty and not self._num_connections[1])):
            dct["numConnections"] = dictify(self.num_connections)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._duration = (self._duration[0], True)
        self._direction = (self._direction[0], True)
        self._remote_host = (self._remote_host[0], True)
        self._num_connections = (self._num_connections[0], True)

    def is_dirty(self):
        return any([self._duration[1], self._direction[1], self._remote_host[1], self._num_connections[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, NetworkThroughputTestExecuteParameters):
            return False
        return super(NetworkThroughputTestExecuteParameters, self).__eq__(other) and \
               self.duration == other.duration and \
               self.direction == other.direction and \
               self.remote_host == other.remote_host and \
               self.num_connections == other.num_connections

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def duration(self):
        """
        *(default value: 30)* The duration of the test in seconds. Note that
        when numConnections is 0, an initial period of time will be spent
        calculating the optimal number of connections, and that time does not
        count toward the duration of the test.

        :rtype: ``int``
        """
        return self._duration[0]

    @duration.setter
    def duration(self, value):
        self._duration = (value, True)

    @property
    def direction(self):
        """
        *(default value: TRANSMIT)* Whether the test is a transmit or receive
        test. *(permitted values: TRANSMIT, RECEIVE)*

        :rtype: ``basestring``
        """
        return self._direction[0]

    @direction.setter
    def direction(self, value):
        self._direction = (value, True)

    @property
    def remote_host(self):
        """
        The remote host for the throughput test. The host must be part of an
        existing environment.

        :rtype: ``basestring``
        """
        return self._remote_host[0]

    @remote_host.setter
    def remote_host(self, value):
        self._remote_host = (value, True)

    @property
    def num_connections(self):
        """
        The number of connections to use for the test. The special value 0 (the
        default) causes the test to automatically discover and use the optimal
        number of connections to use for maximum throughput.

        :rtype: ``int``
        """
        return self._num_connections[0]

    @num_connections.setter
    def num_connections(self, value):
        self._num_connections = (value, True)

