#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-host-create-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_5_0.web.vo.TypedObject import TypedObject
from delphixpy.v1_5_0 import factory
from delphixpy.v1_5_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class HostCreateParameters(TypedObject):
    """
    *(extends* :py:class:`v1_5_0.web.vo.TypedObject` *)* The parameters used
    for the add host operation.
    """
    def __init__(self, undef_enabled=True):
        super(HostCreateParameters, self).__init__()
        self._type = ("HostCreateParameters", True)
        self._host = (self.__undef__, True)

    API_VERSION = "1.5.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(HostCreateParameters, cls).from_dict(data, dirty, undef_enabled)
        if "host" in data and data["host"] is not None:
            obj._host = (factory.create_object(data["host"], "Host"), dirty)
            factory.validate_type(obj._host[0], "Host")
        else:
            obj._host = (obj.__undef__, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(HostCreateParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "host" == "type" or (self.host is not self.__undef__ and not (dirty and not self._host[1])):
            dct["host"] = dictify(self.host)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._host = (self._host[0], True)

    def is_dirty(self):
        return any([self._host[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, HostCreateParameters):
            return False
        return super(HostCreateParameters, self).__eq__(other) and \
               self.host == other.host

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def host(self):
        """
        The host object.

        :rtype: :py:class:`v1_5_0.web.vo.Host`
        """
        return self._host[0]

    @host.setter
    def host(self, value):
        self._host = (value, True)

