#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-ase-specific-backup-sync-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_5_2.web.vo.ASESyncParameters import ASESyncParameters
from delphixpy.v1_5_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class ASESpecificBackupSyncParameters(ASESyncParameters):
    """
    *(extends* :py:class:`v1_5_2.web.vo.ASESyncParameters` *)* The parameters
    to use as input to sync a SAP ASE database using a specific existing
    backup.
    """
    def __init__(self, undef_enabled=True):
        super(ASESpecificBackupSyncParameters, self).__init__()
        self._type = ("ASESpecificBackupSyncParameters", True)
        self._backup_files = (self.__undef__, True)

    API_VERSION = "1.5.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(ASESpecificBackupSyncParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._backup_files = []
        for item in data.get("backupFiles") or []:
            assert isinstance(item, basestring), ("Expected one of [u'string'], but got %s" % type(item))
            common.validate_format(item, "None", None, None)
            obj._backup_files.append(item)
        obj._backup_files = (obj._backup_files, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(ASESpecificBackupSyncParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "backup_files" == "type" or (self.backup_files is not self.__undef__ and not (dirty and not self._backup_files[1])):
            dct["backupFiles"] = dictify(self.backup_files)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._backup_files = (self._backup_files[0], True)

    def is_dirty(self):
        return any([self._backup_files[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, ASESpecificBackupSyncParameters):
            return False
        return super(ASESpecificBackupSyncParameters, self).__eq__(other) and \
               self.backup_files == other.backup_files

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def backup_files(self):
        """
        The location of the full backup of the source database to restore from.
        The backup should be present in the shared backup location for the
        source database.

        :rtype: ``list`` of ``basestring``
        """
        return self._backup_files[0]

    @backup_files.setter
    def backup_files(self, value):
        self._backup_files = (value, True)

