#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-timeflow-log-fetch-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_5_3.web.vo.LogFetchSSH import LogFetchSSH
from delphixpy.v1_5_3 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class TimeflowLogFetchParameters(LogFetchSSH):
    """
    *(extends* :py:class:`v1_5_3.web.vo.LogFetchSSH` *)* Parameters to fetch
    log files within a TimeFlow.
    """
    def __init__(self, undef_enabled=True):
        super(TimeflowLogFetchParameters, self).__init__()
        self._type = ("TimeflowLogFetchParameters", True)
        self._end_location = (self.__undef__, True)
        self._timeflow = (self.__undef__, True)
        self._start_location = (self.__undef__, True)

    API_VERSION = "1.5.3"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(TimeflowLogFetchParameters, cls).from_dict(data, dirty, undef_enabled)
        if "endLocation" not in data:
            raise ValueError("Missing required property \"endLocation\".")
        obj._end_location = (data.get("endLocation", obj.__undef__), dirty)
        if obj._end_location[0] is not None and obj._end_location[0] is not obj.__undef__:
            assert isinstance(obj._end_location[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._end_location[0]))
            common.validate_format(obj._end_location[0], "None", None, None)
        if "timeflow" not in data:
            raise ValueError("Missing required property \"timeflow\".")
        obj._timeflow = (data.get("timeflow", obj.__undef__), dirty)
        if obj._timeflow[0] is not None and obj._timeflow[0] is not obj.__undef__:
            assert isinstance(obj._timeflow[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._timeflow[0]))
            common.validate_format(obj._timeflow[0], "objectReference", None, None)
        if "startLocation" not in data:
            raise ValueError("Missing required property \"startLocation\".")
        obj._start_location = (data.get("startLocation", obj.__undef__), dirty)
        if obj._start_location[0] is not None and obj._start_location[0] is not obj.__undef__:
            assert isinstance(obj._start_location[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._start_location[0]))
            common.validate_format(obj._start_location[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(TimeflowLogFetchParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "end_location" == "type" or (self.end_location is not self.__undef__ and not (dirty and not self._end_location[1])):
            dct["endLocation"] = dictify(self.end_location)
        if "timeflow" == "type" or (self.timeflow is not self.__undef__ and not (dirty and not self._timeflow[1])):
            dct["timeflow"] = dictify(self.timeflow)
        if "start_location" == "type" or (self.start_location is not self.__undef__ and not (dirty and not self._start_location[1])):
            dct["startLocation"] = dictify(self.start_location)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._end_location = (self._end_location[0], True)
        self._timeflow = (self._timeflow[0], True)
        self._start_location = (self._start_location[0], True)

    def is_dirty(self):
        return any([self._end_location[1], self._timeflow[1], self._start_location[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, TimeflowLogFetchParameters):
            return False
        return super(TimeflowLogFetchParameters, self).__eq__(other) and \
               self.end_location == other.end_location and \
               self.timeflow == other.timeflow and \
               self.start_location == other.start_location

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def end_location(self):
        """
        The ending SCN of the range of log files to fetch.

        :rtype: ``basestring``
        """
        return self._end_location[0]

    @end_location.setter
    def end_location(self, value):
        self._end_location = (value, True)

    @property
    def timeflow(self):
        """
        Reference to the TimeFlow for which to fetch logs.

        :rtype: ``basestring``
        """
        return self._timeflow[0]

    @timeflow.setter
    def timeflow(self, value):
        self._timeflow = (value, True)

    @property
    def start_location(self):
        """
        The starting SCN of the range of log files to fetch.

        :rtype: ``basestring``
        """
        return self._start_location[0]

    @start_location.setter
    def start_location(self, value):
        self._start_location = (value, True)

