#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-appdata-base-timeflow.json
#
# Do not edit this file manually!
#

from delphixpy.v1_6_0.web.vo.Timeflow import Timeflow
from delphixpy.v1_6_0 import factory
from delphixpy.v1_6_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class AppDataBaseTimeflow(Timeflow):
    """
    *(extends* :py:class:`v1_6_0.web.vo.Timeflow` *)* TimeFlow representing
    historical data for a particular timeline within a data container.
    """
    def __init__(self, undef_enabled=True):
        super(AppDataBaseTimeflow, self).__init__()
        self._type = ("AppDataBaseTimeflow", True)
        self._parent_point = (self.__undef__, True)

    API_VERSION = "1.6.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(AppDataBaseTimeflow, cls).from_dict(data, dirty, undef_enabled)
        if "parentPoint" in data and data["parentPoint"] is not None:
            obj._parent_point = (factory.create_object(data["parentPoint"], "AppDataTimeflowPoint"), dirty)
            factory.validate_type(obj._parent_point[0], "AppDataTimeflowPoint")
        else:
            obj._parent_point = (obj.__undef__, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(AppDataBaseTimeflow, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "parent_point" == "type" or (self.parent_point is not self.__undef__ and not (dirty and not self._parent_point[1])):
            dct["parentPoint"] = dictify(self.parent_point)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._parent_point = (self._parent_point[0], True)

    def is_dirty(self):
        return any([self._parent_point[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, AppDataBaseTimeflow):
            return False
        return super(AppDataBaseTimeflow, self).__eq__(other) and \
               self.parent_point == other.parent_point

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def parent_point(self):
        """
        The origin point on the parent TimeFlow from which this TimeFlow was
        provisioned. This will not be present for TimeFlows derived from linked
        sources.

        :rtype: :py:class:`v1_6_0.web.vo.AppDataTimeflowPoint`
        """
        return self._parent_point[0]

    @parent_point.setter
    def parent_point(self, value):
        self._parent_point = (value, True)

