#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-timeflow-point-engine-time.json
#
# Do not edit this file manually!
#

from delphixpy.v1_6_0.web.vo.TimeflowPointParameters import TimeflowPointParameters
from delphixpy.v1_6_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class TimeflowPointEngineTime(TimeflowPointParameters):
    """
    *(extends* :py:class:`v1_6_0.web.vo.TimeflowPointParameters` *)* TimeFlow
    point based on a Delphix Engine timestamp.
    """
    def __init__(self, undef_enabled=True):
        super(TimeflowPointEngineTime, self).__init__()
        self._type = ("TimeflowPointEngineTime", True)
        self._timestamp = (self.__undef__, True)
        self._container = (self.__undef__, True)

    API_VERSION = "1.6.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(TimeflowPointEngineTime, cls).from_dict(data, dirty, undef_enabled)
        if "timestamp" not in data:
            raise ValueError("Missing required property \"timestamp\".")
        obj._timestamp = (data.get("timestamp", obj.__undef__), dirty)
        if obj._timestamp[0] is not None and obj._timestamp[0] is not obj.__undef__:
            assert isinstance(obj._timestamp[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._timestamp[0]))
            common.validate_format(obj._timestamp[0], "date", None, None)
        if "container" not in data:
            raise ValueError("Missing required property \"container\".")
        obj._container = (data.get("container", obj.__undef__), dirty)
        if obj._container[0] is not None and obj._container[0] is not obj.__undef__:
            assert isinstance(obj._container[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._container[0]))
            common.validate_format(obj._container[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(TimeflowPointEngineTime, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "timestamp" == "type" or (self.timestamp is not self.__undef__ and not (dirty and not self._timestamp[1])):
            dct["timestamp"] = dictify(self.timestamp)
        if "container" == "type" or (self.container is not self.__undef__ and not (dirty and not self._container[1])):
            dct["container"] = dictify(self.container)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._timestamp = (self._timestamp[0], True)
        self._container = (self._container[0], True)

    def is_dirty(self):
        return any([self._timestamp[1], self._container[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, TimeflowPointEngineTime):
            return False
        return super(TimeflowPointEngineTime, self).__eq__(other) and \
               self.timestamp == other.timestamp and \
               self.container == other.container

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def timestamp(self):
        """
        The desired date in Delphix Engine time.

        :rtype: ``basestring``
        """
        return self._timestamp[0]

    @timestamp.setter
    def timestamp(self, value):
        self._timestamp = (value, True)

    @property
    def container(self):
        """
        Reference to the container containing this point.

        :rtype: ``basestring``
        """
        return self._container[0]

    @container.setter
    def container(self, value):
        self._container = (value, True)

