#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-replication-secure-list.json
#
# Do not edit this file manually!
#

from delphixpy.v1_6_2.web.vo.ReplicationObjectSpecification import ReplicationObjectSpecification
from delphixpy.v1_6_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class ReplicationSecureList(ReplicationObjectSpecification):
    """
    *(extends* :py:class:`v1_6_2.web.vo.ReplicationObjectSpecification` *)*
    List of containers that are to be securely replicated.
    """
    def __init__(self, undef_enabled=True):
        super(ReplicationSecureList, self).__init__()
        self._type = ("ReplicationSecureList", True)
        self._containers = (self.__undef__, True)

    API_VERSION = "1.6.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(ReplicationSecureList, cls).from_dict(data, dirty, undef_enabled)
        obj._containers = []
        for item in data.get("containers") or []:
            assert isinstance(item, basestring), ("Expected one of [u'string'], but got %s" % type(item))
            common.validate_format(item, "objectReference", None, None)
            obj._containers.append(item)
        obj._containers = (obj._containers, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(ReplicationSecureList, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "containers" == "type" or (self.containers is not self.__undef__ and not (dirty and not self._containers[1])):
            dct["containers"] = dictify(self.containers)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._containers = (self._containers[0], True)

    def is_dirty(self):
        return any([self._containers[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, ReplicationSecureList):
            return False
        return super(ReplicationSecureList, self).__eq__(other) and \
               self.containers == other.containers

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def containers(self):
        """
        Containers to replicate, in canonical object reference form.

        :rtype: ``list`` of ``basestring``
        """
        return self._containers[0]

    @containers.setter
    def containers(self, value):
        self._containers = (value, True)

