#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-oracle-add-live-source-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_7_0.web.vo.AddLiveSourceParameters import AddLiveSourceParameters
from delphixpy.v1_7_0 import factory
from delphixpy.v1_7_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class OracleAddLiveSourceParameters(AddLiveSourceParameters):
    """
    *(extends* :py:class:`v1_7_0.web.vo.AddLiveSourceParameters` *)* The
    parameters to use as input to convert an Oracle dSource to an Oracle
    LiveSource.
    """
    def __init__(self, undef_enabled=True):
        super(OracleAddLiveSourceParameters, self).__init__()
        self._type = ("OracleAddLiveSourceParameters", True)
        self._username = (self.__undef__, True)
        self._source_config = (self.__undef__, True)
        self._source = (self.__undef__, True)
        self._credential = (self.__undef__, True)

    API_VERSION = "1.7.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(OracleAddLiveSourceParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._username = (data.get("username", obj.__undef__), dirty)
        if obj._username[0] is not None and obj._username[0] is not obj.__undef__:
            assert isinstance(obj._username[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._username[0]))
            common.validate_format(obj._username[0], "None", None, None)
        if "sourceConfig" not in data:
            raise ValueError("Missing required property \"sourceConfig\".")
        if "sourceConfig" in data and data["sourceConfig"] is not None:
            obj._source_config = (factory.create_object(data["sourceConfig"], "OracleDBConfig"), dirty)
            factory.validate_type(obj._source_config[0], "OracleDBConfig")
        else:
            obj._source_config = (obj.__undef__, dirty)
        if "source" not in data:
            raise ValueError("Missing required property \"source\".")
        if "source" in data and data["source"] is not None:
            obj._source = (factory.create_object(data["source"], "OracleLiveSource"), dirty)
            factory.validate_type(obj._source[0], "OracleLiveSource")
        else:
            obj._source = (obj.__undef__, dirty)
        if "credential" in data and data["credential"] is not None:
            obj._credential = (factory.create_object(data["credential"], "Credential"), dirty)
            factory.validate_type(obj._credential[0], "Credential")
        else:
            obj._credential = (obj.__undef__, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(OracleAddLiveSourceParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "username" == "type" or (self.username is not self.__undef__ and not (dirty and not self._username[1])):
            dct["username"] = dictify(self.username)
        if "source_config" == "type" or (self.source_config is not self.__undef__ and not (dirty and not self._source_config[1])):
            dct["sourceConfig"] = dictify(self.source_config)
        if "source" == "type" or (self.source is not self.__undef__ and not (dirty and not self._source[1])):
            dct["source"] = dictify(self.source)
        if "credential" == "type" or (self.credential is not self.__undef__ and not (dirty and not self._credential[1])):
            dct["credential"] = dictify(self.credential)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._username = (self._username[0], True)
        self._source_config = (self._source_config[0], True)
        self._source = (self._source[0], True)
        self._credential = (self._credential[0], True)

    def is_dirty(self):
        return any([self._username[1], self._source_config[1], self._source[1], self._credential[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, OracleAddLiveSourceParameters):
            return False
        return super(OracleAddLiveSourceParameters, self).__eq__(other) and \
               self.username == other.username and \
               self.source_config == other.source_config and \
               self.source == other.source and \
               self.credential == other.credential

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def username(self):
        """
        The name of the privileged user to run the LiveSource creation
        operation as.

        :rtype: ``basestring``
        """
        return self._username[0]

    @username.setter
    def username(self, value):
        self._username = (value, True)

    @property
    def source_config(self):
        """
        The source config of the LiveSource.

        :rtype: :py:class:`v1_7_0.web.vo.OracleDBConfig`
        """
        return self._source_config[0]

    @source_config.setter
    def source_config(self, value):
        self._source_config = (value, True)

    @property
    def source(self):
        """
        The source that describes the LiveSource.

        :rtype: :py:class:`v1_7_0.web.vo.OracleLiveSource`
        """
        return self._source[0]

    @source.setter
    def source(self, value):
        self._source = (value, True)

    @property
    def credential(self):
        """
        The security credential of the privileged user to run the LiveSource
        creation operation as.

        :rtype: :py:class:`v1_7_0.web.vo.Credential`
        """
        return self._credential[0]

    @credential.setter
    def credential(self, value):
        self._credential = (value, True)

