#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-control-node-initialization-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_8_0.web.vo.SystemInitializationParameters import SystemInitializationParameters
from delphixpy.v1_8_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class ControlNodeInitializationParameters(SystemInitializationParameters):
    """
    *(extends* :py:class:`v1_8_0.web.vo.SystemInitializationParameters` *)*
    Parameters used for initializing a control node.
    """
    def __init__(self, undef_enabled=True):
        super(ControlNodeInitializationParameters, self).__init__()
        self._type = ("ControlNodeInitializationParameters", True)
        self._grid = (self.__undef__, True)
        self._default_user = (self.__undef__, True)
        self._devices = (self.__undef__, True)
        self._default_password = (self.__undef__, True)

    API_VERSION = "1.8.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(ControlNodeInitializationParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._grid = (data.get("grid", obj.__undef__), dirty)
        if obj._grid[0] is not None and obj._grid[0] is not obj.__undef__:
            assert isinstance(obj._grid[0], bool), ("Expected one of [u'boolean'], but got %s" % type(obj._grid[0]))
            common.validate_format(obj._grid[0], "None", None, None)
        obj._default_user = (data.get("defaultUser", obj.__undef__), dirty)
        if obj._default_user[0] is not None and obj._default_user[0] is not obj.__undef__:
            assert isinstance(obj._default_user[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._default_user[0]))
            common.validate_format(obj._default_user[0], "None", 1, 256)
        obj._devices = []
        for item in data.get("devices") or []:
            assert isinstance(item, basestring), ("Expected one of [u'string'], but got %s" % type(item))
            common.validate_format(item, "objectReference", None, None)
            obj._devices.append(item)
        obj._devices = (obj._devices, dirty)
        obj._default_password = (data.get("defaultPassword", obj.__undef__), dirty)
        if obj._default_password[0] is not None and obj._default_password[0] is not obj.__undef__:
            assert isinstance(obj._default_password[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._default_password[0]))
            common.validate_format(obj._default_password[0], "password", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(ControlNodeInitializationParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "grid" == "type" or (self.grid is not self.__undef__ and not (dirty and not self._grid[1])):
            dct["grid"] = dictify(self.grid)
        if "default_user" == "type" or (self.default_user is not self.__undef__ and not (dirty and not self._default_user[1])):
            dct["defaultUser"] = dictify(self.default_user)
        if "devices" == "type" or (self.devices is not self.__undef__ and not (dirty and not self._devices[1])):
            dct["devices"] = dictify(self.devices)
        if "default_password" == "type" or (self.default_password is not self.__undef__ and not (dirty and not self._default_password[1])):
            dct["defaultPassword"] = dictify(self.default_password)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._grid = (self._grid[0], True)
        self._default_user = (self._default_user[0], True)
        self._devices = (self._devices[0], True)
        self._default_password = (self._default_password[0], True)

    def is_dirty(self):
        return any([self._grid[1], self._default_user[1], self._devices[1], self._default_password[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, ControlNodeInitializationParameters):
            return False
        return super(ControlNodeInitializationParameters, self).__eq__(other) and \
               self.grid == other.grid and \
               self.default_user == other.default_user and \
               self.devices == other.devices and \
               self.default_password == other.default_password

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def grid(self):
        """
        Indicates if the current machine will be used as a grid control node.

        :rtype: ``bool``
        """
        return self._grid[0]

    @grid.setter
    def grid(self, value):
        self._grid = (value, True)

    @property
    def default_user(self):
        """
        *(default value: delphix_admin)* Name of the default domain
        administrator to create.

        :rtype: ``basestring``
        """
        return self._default_user[0]

    @default_user.setter
    def default_user(self, value):
        self._default_user = (value, True)

    @property
    def devices(self):
        """
        List of storage devices to use for the node which is being initialized.

        :rtype: ``list`` of ``basestring``
        """
        return self._devices[0]

    @devices.setter
    def devices(self, value):
        self._devices = (value, True)

    @property
    def default_password(self):
        """
        *(default value: delphix)* Password to use for the default domain
        administrator.

        :rtype: ``basestring``
        """
        return self._default_password[0]

    @default_password.setter
    def default_password(self, value):
        self._default_password = (value, True)

