#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-appdata-source-connection-info.json
#
# Do not edit this file manually!
#

from delphixpy.v1_8_1.web.vo.SourceConnectionInfo import SourceConnectionInfo
from delphixpy.v1_8_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class AppDataSourceConnectionInfo(SourceConnectionInfo):
    """
    *(extends* :py:class:`v1_8_1.web.vo.SourceConnectionInfo` *)* Contains
    information that can be used to connect to the application source.
    """
    def __init__(self, undef_enabled=True):
        super(AppDataSourceConnectionInfo, self).__init__()
        self._type = ("AppDataSourceConnectionInfo", True)
        self._path = (self.__undef__, True)
        self._host = (self.__undef__, True)

    API_VERSION = "1.8.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(AppDataSourceConnectionInfo, cls).from_dict(data, dirty, undef_enabled)
        obj._path = (data.get("path", obj.__undef__), dirty)
        if obj._path[0] is not None and obj._path[0] is not obj.__undef__:
            assert isinstance(obj._path[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._path[0]))
            common.validate_format(obj._path[0], "None", None, None)
        obj._host = (data.get("host", obj.__undef__), dirty)
        if obj._host[0] is not None and obj._host[0] is not obj.__undef__:
            assert isinstance(obj._host[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._host[0]))
            common.validate_format(obj._host[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(AppDataSourceConnectionInfo, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "path" == "type" or (self.path is not self.__undef__ and not (dirty and not self._path[1])):
            dct["path"] = dictify(self.path)
        if "host" == "type" or (self.host is not self.__undef__ and not (dirty and not self._host[1])):
            dct["host"] = dictify(self.host)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._path = (self._path[0], True)
        self._host = (self._host[0], True)

    def is_dirty(self):
        return any([self._path[1], self._host[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, AppDataSourceConnectionInfo):
            return False
        return super(AppDataSourceConnectionInfo, self).__eq__(other) and \
               self.path == other.path and \
               self.host == other.host

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def path(self):
        """
        The path where the application data is located on the host.

        :rtype: ``basestring``
        """
        return self._path[0]

    @path.setter
    def path(self, value):
        self._path = (value, True)

    @property
    def host(self):
        """
        The hostname or IP address of the host where the source resides.

        :rtype: ``basestring``
        """
        return self._host[0]

    @host.setter
    def host(self, value):
        self._host = (value, True)

