#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-js-operation-endpoint-branch-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_8_1.web.vo.JSOperationEndpointParameters import JSOperationEndpointParameters
from delphixpy.v1_8_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class JSOperationEndpointBranchParameters(JSOperationEndpointParameters):
    """
    *(extends* :py:class:`v1_8_1.web.vo.JSOperationEndpointParameters` *)* The
    branch to fetch the first and last event from.
    """
    def __init__(self, undef_enabled=True):
        super(JSOperationEndpointBranchParameters, self).__init__()
        self._type = ("JSOperationEndpointBranchParameters", True)
        self._branch = (self.__undef__, True)

    API_VERSION = "1.8.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(JSOperationEndpointBranchParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._branch = (data.get("branch", obj.__undef__), dirty)
        if obj._branch[0] is not None and obj._branch[0] is not obj.__undef__:
            assert isinstance(obj._branch[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._branch[0]))
            common.validate_format(obj._branch[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(JSOperationEndpointBranchParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "branch" == "type" or (self.branch is not self.__undef__ and not (dirty and not self._branch[1])):
            dct["branch"] = dictify(self.branch)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._branch = (self._branch[0], True)

    def is_dirty(self):
        return any([self._branch[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, JSOperationEndpointBranchParameters):
            return False
        return super(JSOperationEndpointBranchParameters, self).__eq__(other) and \
               self.branch == other.branch

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def branch(self):
        """
        The branch to search.

        :rtype: ``basestring``
        """
        return self._branch[0]

    @branch.setter
    def branch(self, value):
        self._branch = (value, True)

