#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-oracle-sysaux-datafile-specification.json
#
# Do not edit this file manually!
#

from delphixpy.v1_8_1.web.vo.OracleDatafileTempfileSpecification import OracleDatafileTempfileSpecification
from delphixpy.v1_8_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class OracleSysauxDatafileSpecification(OracleDatafileTempfileSpecification):
    """
    *(extends* :py:class:`v1_8_1.web.vo.OracleDatafileTempfileSpecification`
    *)* Describes an Oracle datafile in the SYSAUX tablespace.
    """
    def __init__(self, undef_enabled=True):
        super(OracleSysauxDatafileSpecification, self).__init__()
        self._type = ("OracleSysauxDatafileSpecification", True)
        self._size = (self.__undef__, True)

    API_VERSION = "1.8.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(OracleSysauxDatafileSpecification, cls).from_dict(data, dirty, undef_enabled)
        obj._size = (data.get("size", obj.__undef__), dirty)
        if obj._size[0] is not None and obj._size[0] is not obj.__undef__:
            assert isinstance(obj._size[0], int), ("Expected one of [u'integer'], but got %s" % type(obj._size[0]))
            common.validate_format(obj._size[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(OracleSysauxDatafileSpecification, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "size" == "type" or (self.size is not self.__undef__ and not (dirty and not self._size[1])):
            dct["size"] = dictify(self.size)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._size = (self._size[0], True)

    def is_dirty(self):
        return any([self._size[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, OracleSysauxDatafileSpecification):
            return False
        return super(OracleSysauxDatafileSpecification, self).__eq__(other) and \
               self.size == other.size

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def size(self):
        """
        *(default value: 900)* The size of the file in MB.

        :rtype: ``int``
        """
        return self._size[0]

    @size.setter
    def size(self, value):
        self._size = (value, True)

