#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#
# Do not edit this file manually!
#

from delphixpy.v1_8_2.web.vo.TypedObject import TypedObject
from delphixpy.v1_8_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class GetLogParameters(TypedObject):
    """
    *(extends* :py:class:`v1_8_2.web.vo.TypedObject` *)* The parameters to use
    as input to Log.get.
    """
    def __init__(self, undef_enabled=True):
        super(GetLogParameters, self).__init__()
        self._type = ("GetLogParameters", True)
        self._log_type = (self.__undef__, True)
        self._log_number = (self.__undef__, True)

    API_VERSION = "1.8.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(GetLogParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._log_type = (data.get("logType", obj.__undef__), dirty)
        if obj._log_type[0] is not None and obj._log_type[0] is not obj.__undef__:
            assert isinstance(obj._log_type[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._log_type[0]))
            assert obj._log_type[0] in [u'info', u'debug', u'error', u'trace'], "Expected enum [u'info', u'debug', u'error', u'trace'] but got %s" % obj._log_type[0]
            common.validate_format(obj._log_type[0], "None", None, None)
        obj._log_number = (data.get("logNumber", obj.__undef__), dirty)
        if obj._log_number[0] is not None and obj._log_number[0] is not obj.__undef__:
            assert isinstance(obj._log_number[0], int), ("Expected one of [u'integer'], but got %s" % type(obj._log_number[0]))
            common.validate_format(obj._log_number[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(GetLogParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "log_type" == "type" or (self.log_type is not self.__undef__ and not (dirty and not self._log_type[1])):
            dct["logType"] = dictify(self.log_type)
        if "log_number" == "type" or (self.log_number is not self.__undef__ and not (dirty and not self._log_number[1])):
            dct["logNumber"] = dictify(self.log_number)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._log_type = (self._log_type[0], True)
        self._log_number = (self._log_number[0], True)

    def is_dirty(self):
        return any([self._log_type[1], self._log_number[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, GetLogParameters):
            return False
        return super(GetLogParameters, self).__eq__(other) and \
               self.log_type == other.log_type and \
               self.log_number == other.log_number

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def log_type(self):
        """
        *(default value: debug)* Type of log to retrieve. *(permitted values:
        info, debug, error, trace)*

        :rtype: ``basestring``
        """
        return self._log_type[0]

    @log_type.setter
    def log_type(self, value):
        self._log_type = (value, True)

    @property
    def log_number(self):
        """
        Log number to return.

        :rtype: ``int``
        """
        return self._log_number[0]

    @log_number.setter
    def log_number(self, value):
        self._log_number = (value, True)

