#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#
# Do not edit this file manually!
#

from delphixpy.v1_8_2.web.vo.LinkData import LinkData
from delphixpy.v1_8_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class VMwareLinkData(LinkData):
    """
    *(extends* :py:class:`v1_8_2.web.vo.LinkData` *)* Represents the VMware
    specific parameters of a link request.
    """
    def __init__(self, undef_enabled=True):
        super(VMwareLinkData, self).__init__()
        self._type = ("VMwareLinkData", True)
        self._config = (self.__undef__, True)
        self._environment_user = (self.__undef__, True)

    API_VERSION = "1.8.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(VMwareLinkData, cls).from_dict(data, dirty, undef_enabled)
        if "config" not in data:
            raise ValueError("Missing required property \"config\".")
        obj._config = (data.get("config", obj.__undef__), dirty)
        if obj._config[0] is not None and obj._config[0] is not obj.__undef__:
            assert isinstance(obj._config[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._config[0]))
            common.validate_format(obj._config[0], "objectReference", None, None)
        if "environmentUser" not in data:
            raise ValueError("Missing required property \"environmentUser\".")
        obj._environment_user = (data.get("environmentUser", obj.__undef__), dirty)
        if obj._environment_user[0] is not None and obj._environment_user[0] is not obj.__undef__:
            assert isinstance(obj._environment_user[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._environment_user[0]))
            common.validate_format(obj._environment_user[0], "objectReference", None, None)
        return obj

    def to_dict(self, dirty=False):
        dct = super(VMwareLinkData, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "config" == "type" or (self.config is not self.__undef__ and not (dirty and not self._config[1])):
            dct["config"] = dictify(self.config)
        if "environment_user" == "type" or (self.environment_user is not self.__undef__ and not (dirty and not self._environment_user[1])):
            dct["environmentUser"] = dictify(self.environment_user)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._config = (self._config[0], True)
        self._environment_user = (self._environment_user[0], True)

    def is_dirty(self):
        return any([self._config[1], self._environment_user[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, VMwareLinkData):
            return False
        return super(VMwareLinkData, self).__eq__(other) and \
               self.config == other.config and \
               self.environment_user == other.environment_user

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def config(self):
        """
        Reference to the configuration for the source.

        :rtype: ``basestring``
        """
        return self._config[0]

    @config.setter
    def config(self, value):
        self._config = (value, True)

    @property
    def environment_user(self):
        """
        The OS user to use for linking.

        :rtype: ``basestring``
        """
        return self._environment_user[0]

    @environment_user.setter
    def environment_user(self, value):
        self._environment_user = (value, True)

