#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-reset-ignored-faults-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.v1_9_0.web.vo.TypedObject import TypedObject
from delphixpy.v1_9_0 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class ResetIgnoredFaultsParameters(TypedObject):
    """
    *(extends* :py:class:`v1_9_0.web.vo.TypedObject` *)* The parameters to use
    as input when marking selected ignored faults as resolved.
    """
    def __init__(self, undef_enabled=True):
        super(ResetIgnoredFaultsParameters, self).__init__()
        self._type = ("ResetIgnoredFaultsParameters", True)
        self._fault_references = (self.__undef__, True)

    API_VERSION = "1.9.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(ResetIgnoredFaultsParameters, cls).from_dict(data, dirty, undef_enabled)
        if "faultReferences" not in data:
            raise ValueError("Missing required property \"faultReferences\".")
        obj._fault_references = []
        for item in data.get("faultReferences") or []:
            assert isinstance(item, basestring), ("Expected one of [u'string'], but got %s" % type(item))
            common.validate_format(item, "objectReference", None, None)
            obj._fault_references.append(item)
        obj._fault_references = (obj._fault_references, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(ResetIgnoredFaultsParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "fault_references" == "type" or (self.fault_references is not self.__undef__ and not (dirty and not self._fault_references[1])):
            dct["faultReferences"] = dictify(self.fault_references)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._fault_references = (self._fault_references[0], True)

    def is_dirty(self):
        return any([self._fault_references[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, ResetIgnoredFaultsParameters):
            return False
        return super(ResetIgnoredFaultsParameters, self).__eq__(other) and \
               self.fault_references == other.fault_references

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def fault_references(self):
        """
        Input list of ignored faults which will be marked as resolved.

        :rtype: ``list`` of ``basestring``
        """
        return self._fault_references[0]

    @fault_references.setter
    def fault_references(self, value):
        self._fault_references = (value, True)

