#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-ase-host-environment-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.web.vo.TypedObject import TypedObject
from delphixpy import factory
from delphixpy import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class ASEHostEnvironmentParameters(TypedObject):
    """
    *(extends* :py:class:`delphixpy.web.vo.TypedObject` *)* SAP ASE host
    environment parameters.
    """
    def __init__(self, undef_enabled=True):
        super(ASEHostEnvironmentParameters, self).__init__()
        self._type = ("ASEHostEnvironmentParameters", True)
        self._db_user = (self.__undef__, True)
        self._credentials = (self.__undef__, True)

    API_VERSION = "1.9.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(ASEHostEnvironmentParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._db_user = (data.get("dbUser", obj.__undef__), dirty)
        if obj._db_user[0] is not None and obj._db_user[0] is not obj.__undef__:
            assert isinstance(obj._db_user[0], basestring), ("Expected one of [u'string'], but got %s" % type(obj._db_user[0]))
            common.validate_format(obj._db_user[0], "None", None, 256)
        if "credentials" in data and data["credentials"] is not None:
            obj._credentials = (factory.create_object(data["credentials"], "Credential"), dirty)
            factory.validate_type(obj._credentials[0], "Credential")
        else:
            obj._credentials = (obj.__undef__, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(ASEHostEnvironmentParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "db_user" == "type" or (self.db_user is not self.__undef__ and not (dirty and not self._db_user[1])):
            dct["dbUser"] = dictify(self.db_user)
        if "credentials" == "type" or (self.credentials is not self.__undef__ and not (dirty and not self._credentials[1])):
            dct["credentials"] = dictify(self.credentials)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._db_user = (self._db_user[0], True)
        self._credentials = (self._credentials[0], True)

    def is_dirty(self):
        return any([self._db_user[1], self._credentials[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, ASEHostEnvironmentParameters):
            return False
        return super(ASEHostEnvironmentParameters, self).__eq__(other) and \
               self.db_user == other.db_user and \
               self.credentials == other.credentials

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def db_user(self):
        """
        The username of the database user.

        :rtype: ``basestring``
        """
        return self._db_user[0]

    @db_user.setter
    def db_user(self, value):
        self._db_user = (value, True)

    @property
    def credentials(self):
        """
        The credentials of the database user.

        :rtype: :py:class:`delphixpy.web.vo.Credential`
        """
        return self._credentials[0]

    @credentials.setter
    def credentials(self, value):
        self._credentials = (value, True)

