#
# Copyright 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-js-data-container-create-with-refresh-parameters.json
#
# Do not edit this file manually!
#

from delphixpy.web.vo.JSDataContainerCreateParameters import JSDataContainerCreateParameters
from delphixpy import factory
from delphixpy import common

class __Undef(object):
    def __repr__(self):
        return "undef"

_UNDEFINED = __Undef()

class JSDataContainerCreateWithRefreshParameters(JSDataContainerCreateParameters):
    """
    *(extends* :py:class:`delphixpy.web.vo.JSDataContainerCreateParameters` *)*
    The parameters used to create a data container when refreshing data
    sources.
    """
    def __init__(self, undef_enabled=True):
        super(JSDataContainerCreateWithRefreshParameters, self).__init__()
        self._type = ("JSDataContainerCreateWithRefreshParameters", True)
        self._timeline_point_parameters = (self.__undef__, True)

    API_VERSION = "1.9.0"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(JSDataContainerCreateWithRefreshParameters, cls).from_dict(data, dirty, undef_enabled)
        if "timelinePointParameters" not in data:
            raise ValueError("Missing required property \"timelinePointParameters\".")
        if "timelinePointParameters" in data and data["timelinePointParameters"] is not None:
            obj._timeline_point_parameters = (factory.create_object(data["timelinePointParameters"], "JSTimelinePointParameters"), dirty)
            factory.validate_type(obj._timeline_point_parameters[0], "JSTimelinePointParameters")
        else:
            obj._timeline_point_parameters = (obj.__undef__, dirty)
        return obj

    def to_dict(self, dirty=False):
        dct = super(JSDataContainerCreateWithRefreshParameters, self).to_dict(dirty)

        def dictify(obj):
            if isinstance(obj, list):
                return [dictify(o) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict()
            else:
                return obj
        if "timeline_point_parameters" == "type" or (self.timeline_point_parameters is not self.__undef__ and not (dirty and not self._timeline_point_parameters[1])):
            dct["timelinePointParameters"] = dictify(self.timeline_point_parameters)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._timeline_point_parameters = (self._timeline_point_parameters[0], True)

    def is_dirty(self):
        return any([self._timeline_point_parameters[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, JSDataContainerCreateWithRefreshParameters):
            return False
        return super(JSDataContainerCreateWithRefreshParameters, self).__eq__(other) and \
               self.timeline_point_parameters == other.timeline_point_parameters

    def __ne__(self, other):
        return not self.__eq__(other)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def timeline_point_parameters(self):
        """
        Create the data container with initial data specified by this Jet
        Stream timeline point.

        :rtype: :py:class:`delphixpy.web.vo.JSTimelinePointParameters`
        """
        return self._timeline_point_parameters[0]

    @timeline_point_parameters.setter
    def timeline_point_parameters(self, value):
        self._timeline_point_parameters = (value, True)

