#!/usr/bin/env python
#
# Copyright 2014, 2017 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

from distutils.core import setup
setup(
    name='delphixpy',
    version='1.9.0.0',
    description='Delphix Client Bindings',
    author='Delphix',
    author_email='support@delphix.com',
    url='http://www.delphix.com',
    packages=[
        'delphixpy',
        'delphixpy/v1_5_2',
        'delphixpy/v1_5_2/web',
        'delphixpy/v1_5_2/web/action',
        'delphixpy/v1_5_2/web/database',
        'delphixpy/v1_5_2/web/database/template',
        'delphixpy/v1_5_2/web/host',
        'delphixpy/v1_5_2/web/host/privilegeElevation',
        'delphixpy/v1_5_2/web/host/privilegeElevation/profile',
        'delphixpy/v1_5_2/web/vo',
        'delphixpy/v1_5_2/web/jetstream',
        'delphixpy/v1_5_2/web/jetstream/template',
        'delphixpy/v1_5_2/web/jetstream/branch',
        'delphixpy/v1_5_2/web/jetstream/usagedata',
        'delphixpy/v1_5_2/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_5_2/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_5_2/web/jetstream/bookmark',
        'delphixpy/v1_5_2/web/jetstream/datasource',
        'delphixpy/v1_5_2/web/jetstream/container',
        'delphixpy/v1_5_2/web/jetstream/usage',
        'delphixpy/v1_5_2/web/jetstream/usage/template',
        'delphixpy/v1_5_2/web/jetstream/usage/branch',
        'delphixpy/v1_5_2/web/jetstream/usage/user',
        'delphixpy/v1_5_2/web/jetstream/usage/bookmark',
        'delphixpy/v1_5_2/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_5_2/web/jetstream/usage/container',
        'delphixpy/v1_5_2/web/jetstream/operation',
        'delphixpy/v1_5_2/web/snapshot',
        'delphixpy/v1_5_2/web/group',
        'delphixpy/v1_5_2/web/sourceconfig',
        'delphixpy/v1_5_2/web/sourceconfig/oracle',
        'delphixpy/v1_5_2/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_5_2/web/service',
        'delphixpy/v1_5_2/web/service/time',
        'delphixpy/v1_5_2/web/service/linkingsettings',
        'delphixpy/v1_5_2/web/service/ldap',
        'delphixpy/v1_5_2/web/service/ldap/server',
        'delphixpy/v1_5_2/web/service/schema',
        'delphixpy/v1_5_2/web/service/phonehome',
        'delphixpy/v1_5_2/web/service/proxy',
        'delphixpy/v1_5_2/web/service/smtp',
        'delphixpy/v1_5_2/web/service/syslog',
        'delphixpy/v1_5_2/web/service/dns',
        'delphixpy/v1_5_2/web/service/locale',
        'delphixpy/v1_5_2/web/service/security',
        'delphixpy/v1_5_2/web/service/support',
        'delphixpy/v1_5_2/web/service/support/access',
        'delphixpy/v1_5_2/web/service/support/bundle',
        'delphixpy/v1_5_2/web/service/certificate',
        'delphixpy/v1_5_2/web/service/snmp',
        'delphixpy/v1_5_2/web/service/snmp/manager',
        'delphixpy/v1_5_2/web/about',
        'delphixpy/v1_5_2/web/notification',
        'delphixpy/v1_5_2/web/permission',
        'delphixpy/v1_5_2/web/user',
        'delphixpy/v1_5_2/web/alert',
        'delphixpy/v1_5_2/web/alert/profile',
        'delphixpy/v1_5_2/web/environment',
        'delphixpy/v1_5_2/web/environment/user',
        'delphixpy/v1_5_2/web/environment/oracle',
        'delphixpy/v1_5_2/web/environment/oracle/listener',
        'delphixpy/v1_5_2/web/environment/oracle/clusternode',
        'delphixpy/v1_5_2/web/environment/windows',
        'delphixpy/v1_5_2/web/environment/windows/clusterinstance',
        'delphixpy/v1_5_2/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_5_2/web/environment/windows/clusternode',
        'delphixpy/v1_5_2/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_5_2/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_5_2/web/policy',
        'delphixpy/v1_5_2/web/session',
        'delphixpy/v1_5_2/web/replication',
        'delphixpy/v1_5_2/web/replication/sourcestate',
        'delphixpy/v1_5_2/web/replication/targetstate',
        'delphixpy/v1_5_2/web/replication/spec',
        'delphixpy/v1_5_2/web/replication/serializationpoint',
        'delphixpy/v1_5_2/web/capacity',
        'delphixpy/v1_5_2/web/capacity/snapshot',
        'delphixpy/v1_5_2/web/capacity/group',
        'delphixpy/v1_5_2/web/capacity/group/historical',
        'delphixpy/v1_5_2/web/capacity/system',
        'delphixpy/v1_5_2/web/capacity/system/historical',
        'delphixpy/v1_5_2/web/capacity/consumer',
        'delphixpy/v1_5_2/web/capacity/consumer/historical',
        'delphixpy/v1_5_2/web/data',
        'delphixpy/v1_5_2/web/domain',
        'delphixpy/v1_5_2/web/connectivity',
        'delphixpy/v1_5_2/web/network',
        'delphixpy/v1_5_2/web/network/route',
        'delphixpy/v1_5_2/web/network/test',
        'delphixpy/v1_5_2/web/network/test/throughput',
        'delphixpy/v1_5_2/web/network/test/latency',
        'delphixpy/v1_5_2/web/network/test/dsp',
        'delphixpy/v1_5_2/web/network/interface',
        'delphixpy/v1_5_2/web/timeflow',
        'delphixpy/v1_5_2/web/timeflow/oracle',
        'delphixpy/v1_5_2/web/timeflow/oracle/log',
        'delphixpy/v1_5_2/web/timeflow/bookmark',
        'delphixpy/v1_5_2/web/storage',
        'delphixpy/v1_5_2/web/storage/scrub',
        'delphixpy/v1_5_2/web/storage/test',
        'delphixpy/v1_5_2/web/storage/device',
        'delphixpy/v1_5_2/web/fault',
        'delphixpy/v1_5_2/web/fault/effect',
        'delphixpy/v1_5_2/web/namespace',
        'delphixpy/v1_5_2/web/system',
        'delphixpy/v1_5_2/web/system/version',
        'delphixpy/v1_5_2/web/repository',
        'delphixpy/v1_5_2/web/repository/template',
        'delphixpy/v1_5_2/web/delphix',
        'delphixpy/v1_5_2/web/source',
        'delphixpy/v1_5_2/web/source/operationTemplate',
        'delphixpy/v1_5_2/web/authorization',
        'delphixpy/v1_5_2/web/analytics',
        'delphixpy/v1_5_2/web/analytics/statistic',
        'delphixpy/v1_5_2/web/registration',
        'delphixpy/v1_5_2/web/registration/status',
        'delphixpy/v1_5_2/web/job',
        'delphixpy/v1_5_2/web/role',
        'delphixpy/v1_5_2/web/toolkit',
        'delphixpy/v1_5_1',
        'delphixpy/v1_5_1/web',
        'delphixpy/v1_5_1/web/action',
        'delphixpy/v1_5_1/web/database',
        'delphixpy/v1_5_1/web/database/template',
        'delphixpy/v1_5_1/web/host',
        'delphixpy/v1_5_1/web/host/privilegeElevation',
        'delphixpy/v1_5_1/web/host/privilegeElevation/profile',
        'delphixpy/v1_5_1/web/vo',
        'delphixpy/v1_5_1/web/jetstream',
        'delphixpy/v1_5_1/web/jetstream/template',
        'delphixpy/v1_5_1/web/jetstream/branch',
        'delphixpy/v1_5_1/web/jetstream/usagedata',
        'delphixpy/v1_5_1/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_5_1/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_5_1/web/jetstream/bookmark',
        'delphixpy/v1_5_1/web/jetstream/datasource',
        'delphixpy/v1_5_1/web/jetstream/container',
        'delphixpy/v1_5_1/web/jetstream/usage',
        'delphixpy/v1_5_1/web/jetstream/usage/template',
        'delphixpy/v1_5_1/web/jetstream/usage/branch',
        'delphixpy/v1_5_1/web/jetstream/usage/user',
        'delphixpy/v1_5_1/web/jetstream/usage/bookmark',
        'delphixpy/v1_5_1/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_5_1/web/jetstream/usage/container',
        'delphixpy/v1_5_1/web/jetstream/operation',
        'delphixpy/v1_5_1/web/snapshot',
        'delphixpy/v1_5_1/web/group',
        'delphixpy/v1_5_1/web/sourceconfig',
        'delphixpy/v1_5_1/web/sourceconfig/oracle',
        'delphixpy/v1_5_1/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_5_1/web/service',
        'delphixpy/v1_5_1/web/service/time',
        'delphixpy/v1_5_1/web/service/linkingsettings',
        'delphixpy/v1_5_1/web/service/ldap',
        'delphixpy/v1_5_1/web/service/ldap/server',
        'delphixpy/v1_5_1/web/service/schema',
        'delphixpy/v1_5_1/web/service/phonehome',
        'delphixpy/v1_5_1/web/service/proxy',
        'delphixpy/v1_5_1/web/service/smtp',
        'delphixpy/v1_5_1/web/service/syslog',
        'delphixpy/v1_5_1/web/service/dns',
        'delphixpy/v1_5_1/web/service/locale',
        'delphixpy/v1_5_1/web/service/security',
        'delphixpy/v1_5_1/web/service/support',
        'delphixpy/v1_5_1/web/service/support/access',
        'delphixpy/v1_5_1/web/service/support/bundle',
        'delphixpy/v1_5_1/web/service/certificate',
        'delphixpy/v1_5_1/web/service/snmp',
        'delphixpy/v1_5_1/web/service/snmp/manager',
        'delphixpy/v1_5_1/web/about',
        'delphixpy/v1_5_1/web/notification',
        'delphixpy/v1_5_1/web/permission',
        'delphixpy/v1_5_1/web/user',
        'delphixpy/v1_5_1/web/alert',
        'delphixpy/v1_5_1/web/alert/profile',
        'delphixpy/v1_5_1/web/environment',
        'delphixpy/v1_5_1/web/environment/user',
        'delphixpy/v1_5_1/web/environment/oracle',
        'delphixpy/v1_5_1/web/environment/oracle/listener',
        'delphixpy/v1_5_1/web/environment/oracle/clusternode',
        'delphixpy/v1_5_1/web/environment/windows',
        'delphixpy/v1_5_1/web/environment/windows/clusterinstance',
        'delphixpy/v1_5_1/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_5_1/web/environment/windows/clusternode',
        'delphixpy/v1_5_1/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_5_1/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_5_1/web/policy',
        'delphixpy/v1_5_1/web/session',
        'delphixpy/v1_5_1/web/replication',
        'delphixpy/v1_5_1/web/replication/sourcestate',
        'delphixpy/v1_5_1/web/replication/targetstate',
        'delphixpy/v1_5_1/web/replication/spec',
        'delphixpy/v1_5_1/web/replication/serializationpoint',
        'delphixpy/v1_5_1/web/capacity',
        'delphixpy/v1_5_1/web/capacity/snapshot',
        'delphixpy/v1_5_1/web/capacity/group',
        'delphixpy/v1_5_1/web/capacity/group/historical',
        'delphixpy/v1_5_1/web/capacity/system',
        'delphixpy/v1_5_1/web/capacity/system/historical',
        'delphixpy/v1_5_1/web/capacity/consumer',
        'delphixpy/v1_5_1/web/capacity/consumer/historical',
        'delphixpy/v1_5_1/web/data',
        'delphixpy/v1_5_1/web/domain',
        'delphixpy/v1_5_1/web/connectivity',
        'delphixpy/v1_5_1/web/network',
        'delphixpy/v1_5_1/web/network/route',
        'delphixpy/v1_5_1/web/network/test',
        'delphixpy/v1_5_1/web/network/test/throughput',
        'delphixpy/v1_5_1/web/network/test/latency',
        'delphixpy/v1_5_1/web/network/test/dsp',
        'delphixpy/v1_5_1/web/network/interface',
        'delphixpy/v1_5_1/web/timeflow',
        'delphixpy/v1_5_1/web/timeflow/oracle',
        'delphixpy/v1_5_1/web/timeflow/oracle/log',
        'delphixpy/v1_5_1/web/timeflow/bookmark',
        'delphixpy/v1_5_1/web/storage',
        'delphixpy/v1_5_1/web/storage/scrub',
        'delphixpy/v1_5_1/web/storage/test',
        'delphixpy/v1_5_1/web/storage/device',
        'delphixpy/v1_5_1/web/fault',
        'delphixpy/v1_5_1/web/fault/effect',
        'delphixpy/v1_5_1/web/namespace',
        'delphixpy/v1_5_1/web/system',
        'delphixpy/v1_5_1/web/system/version',
        'delphixpy/v1_5_1/web/repository',
        'delphixpy/v1_5_1/web/repository/template',
        'delphixpy/v1_5_1/web/delphix',
        'delphixpy/v1_5_1/web/source',
        'delphixpy/v1_5_1/web/source/operationTemplate',
        'delphixpy/v1_5_1/web/authorization',
        'delphixpy/v1_5_1/web/analytics',
        'delphixpy/v1_5_1/web/analytics/statistic',
        'delphixpy/v1_5_1/web/registration',
        'delphixpy/v1_5_1/web/registration/status',
        'delphixpy/v1_5_1/web/job',
        'delphixpy/v1_5_1/web/role',
        'delphixpy/v1_5_1/web/toolkit',
        'delphixpy/v1_9_0',
        'delphixpy/v1_9_0/web',
        'delphixpy/v1_9_0/web/action',
        'delphixpy/v1_9_0/web/database',
        'delphixpy/v1_9_0/web/database/template',
        'delphixpy/v1_9_0/web/database/performanceHistory',
        'delphixpy/v1_9_0/web/host',
        'delphixpy/v1_9_0/web/host/privilegeElevation',
        'delphixpy/v1_9_0/web/host/privilegeElevation/profileScript',
        'delphixpy/v1_9_0/web/host/privilegeElevation/profile',
        'delphixpy/v1_9_0/web/passwordPolicy',
        'delphixpy/v1_9_0/web/vo',
        'delphixpy/v1_9_0/web/jetstream',
        'delphixpy/v1_9_0/web/jetstream/template',
        'delphixpy/v1_9_0/web/jetstream/branch',
        'delphixpy/v1_9_0/web/jetstream/usagedata',
        'delphixpy/v1_9_0/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_9_0/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_9_0/web/jetstream/bookmark',
        'delphixpy/v1_9_0/web/jetstream/datasource',
        'delphixpy/v1_9_0/web/jetstream/config',
        'delphixpy/v1_9_0/web/jetstream/container',
        'delphixpy/v1_9_0/web/jetstream/usage',
        'delphixpy/v1_9_0/web/jetstream/usage/template',
        'delphixpy/v1_9_0/web/jetstream/usage/branch',
        'delphixpy/v1_9_0/web/jetstream/usage/user',
        'delphixpy/v1_9_0/web/jetstream/usage/bookmark',
        'delphixpy/v1_9_0/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_9_0/web/jetstream/usage/container',
        'delphixpy/v1_9_0/web/jetstream/operation',
        'delphixpy/v1_9_0/web/snapshot',
        'delphixpy/v1_9_0/web/group',
        'delphixpy/v1_9_0/web/sourceconfig',
        'delphixpy/v1_9_0/web/service',
        'delphixpy/v1_9_0/web/service/time',
        'delphixpy/v1_9_0/web/service/linkingsettings',
        'delphixpy/v1_9_0/web/service/ldap',
        'delphixpy/v1_9_0/web/service/ldap/server',
        'delphixpy/v1_9_0/web/service/tls',
        'delphixpy/v1_9_0/web/service/tls/cacert',
        'delphixpy/v1_9_0/web/service/schema',
        'delphixpy/v1_9_0/web/service/saml',
        'delphixpy/v1_9_0/web/service/saml/serviceprovider',
        'delphixpy/v1_9_0/web/service/phonehome',
        'delphixpy/v1_9_0/web/service/proxy',
        'delphixpy/v1_9_0/web/service/smtp',
        'delphixpy/v1_9_0/web/service/syslog',
        'delphixpy/v1_9_0/web/service/dns',
        'delphixpy/v1_9_0/web/service/locale',
        'delphixpy/v1_9_0/web/service/security',
        'delphixpy/v1_9_0/web/service/support',
        'delphixpy/v1_9_0/web/service/support/access',
        'delphixpy/v1_9_0/web/service/support/bundle',
        'delphixpy/v1_9_0/web/service/httpConnector',
        'delphixpy/v1_9_0/web/service/certificate',
        'delphixpy/v1_9_0/web/service/kerberos',
        'delphixpy/v1_9_0/web/service/snmp',
        'delphixpy/v1_9_0/web/service/snmp/manager',
        'delphixpy/v1_9_0/web/about',
        'delphixpy/v1_9_0/web/maskingjob',
        'delphixpy/v1_9_0/web/maskingjob/serviceconfig',
        'delphixpy/v1_9_0/web/notification',
        'delphixpy/v1_9_0/web/permission',
        'delphixpy/v1_9_0/web/user',
        'delphixpy/v1_9_0/web/alert',
        'delphixpy/v1_9_0/web/alert/profile',
        'delphixpy/v1_9_0/web/environment',
        'delphixpy/v1_9_0/web/environment/user',
        'delphixpy/v1_9_0/web/environment/oracle',
        'delphixpy/v1_9_0/web/environment/oracle/listener',
        'delphixpy/v1_9_0/web/environment/oracle/clusternode',
        'delphixpy/v1_9_0/web/environment/windows',
        'delphixpy/v1_9_0/web/environment/windows/clusterinstance',
        'delphixpy/v1_9_0/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_9_0/web/environment/windows/clusternode',
        'delphixpy/v1_9_0/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_9_0/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_9_0/web/policy',
        'delphixpy/v1_9_0/web/session',
        'delphixpy/v1_9_0/web/replication',
        'delphixpy/v1_9_0/web/replication/sourcestate',
        'delphixpy/v1_9_0/web/replication/targetstate',
        'delphixpy/v1_9_0/web/replication/spec',
        'delphixpy/v1_9_0/web/replication/serializationpoint',
        'delphixpy/v1_9_0/web/capacity',
        'delphixpy/v1_9_0/web/capacity/snapshot',
        'delphixpy/v1_9_0/web/capacity/group',
        'delphixpy/v1_9_0/web/capacity/group/historical',
        'delphixpy/v1_9_0/web/capacity/system',
        'delphixpy/v1_9_0/web/capacity/system/historical',
        'delphixpy/v1_9_0/web/capacity/consumer',
        'delphixpy/v1_9_0/web/capacity/consumer/historical',
        'delphixpy/v1_9_0/web/transformation',
        'delphixpy/v1_9_0/web/data',
        'delphixpy/v1_9_0/web/domain',
        'delphixpy/v1_9_0/web/connectivity',
        'delphixpy/v1_9_0/web/network',
        'delphixpy/v1_9_0/web/network/route',
        'delphixpy/v1_9_0/web/network/test',
        'delphixpy/v1_9_0/web/network/test/throughput',
        'delphixpy/v1_9_0/web/network/test/latency',
        'delphixpy/v1_9_0/web/network/test/dsp',
        'delphixpy/v1_9_0/web/network/interface',
        'delphixpy/v1_9_0/web/network/dsp',
        'delphixpy/v1_9_0/web/network/dsp/autotune',
        'delphixpy/v1_9_0/web/timeflow',
        'delphixpy/v1_9_0/web/timeflow/oracle',
        'delphixpy/v1_9_0/web/timeflow/oracle/log',
        'delphixpy/v1_9_0/web/timeflow/bookmark',
        'delphixpy/v1_9_0/web/storage',
        'delphixpy/v1_9_0/web/storage/remove',
        'delphixpy/v1_9_0/web/storage/scrub',
        'delphixpy/v1_9_0/web/storage/test',
        'delphixpy/v1_9_0/web/storage/device',
        'delphixpy/v1_9_0/web/fault',
        'delphixpy/v1_9_0/web/fault/effect',
        'delphixpy/v1_9_0/web/timezone',
        'delphixpy/v1_9_0/web/namespace',
        'delphixpy/v1_9_0/web/system',
        'delphixpy/v1_9_0/web/system/upgradeCheckResult',
        'delphixpy/v1_9_0/web/system/version',
        'delphixpy/v1_9_0/web/system/package',
        'delphixpy/v1_9_0/web/repository',
        'delphixpy/v1_9_0/web/repository/template',
        'delphixpy/v1_9_0/web/delphix',
        'delphixpy/v1_9_0/web/source',
        'delphixpy/v1_9_0/web/source/operationTemplate',
        'delphixpy/v1_9_0/web/authorization',
        'delphixpy/v1_9_0/web/analytics',
        'delphixpy/v1_9_0/web/analytics/statistic',
        'delphixpy/v1_9_0/web/registration',
        'delphixpy/v1_9_0/web/registration/status',
        'delphixpy/v1_9_0/web/job',
        'delphixpy/v1_9_0/web/role',
        'delphixpy/v1_9_0/web/toolkit',
        'delphixpy/v1_6_2',
        'delphixpy/v1_6_2/web',
        'delphixpy/v1_6_2/web/action',
        'delphixpy/v1_6_2/web/database',
        'delphixpy/v1_6_2/web/database/template',
        'delphixpy/v1_6_2/web/host',
        'delphixpy/v1_6_2/web/host/privilegeElevation',
        'delphixpy/v1_6_2/web/host/privilegeElevation/profile',
        'delphixpy/v1_6_2/web/vo',
        'delphixpy/v1_6_2/web/jetstream',
        'delphixpy/v1_6_2/web/jetstream/template',
        'delphixpy/v1_6_2/web/jetstream/branch',
        'delphixpy/v1_6_2/web/jetstream/usagedata',
        'delphixpy/v1_6_2/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_6_2/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_6_2/web/jetstream/bookmark',
        'delphixpy/v1_6_2/web/jetstream/datasource',
        'delphixpy/v1_6_2/web/jetstream/container',
        'delphixpy/v1_6_2/web/jetstream/usage',
        'delphixpy/v1_6_2/web/jetstream/usage/template',
        'delphixpy/v1_6_2/web/jetstream/usage/branch',
        'delphixpy/v1_6_2/web/jetstream/usage/user',
        'delphixpy/v1_6_2/web/jetstream/usage/bookmark',
        'delphixpy/v1_6_2/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_6_2/web/jetstream/usage/container',
        'delphixpy/v1_6_2/web/jetstream/operation',
        'delphixpy/v1_6_2/web/snapshot',
        'delphixpy/v1_6_2/web/group',
        'delphixpy/v1_6_2/web/sourceconfig',
        'delphixpy/v1_6_2/web/sourceconfig/oracle',
        'delphixpy/v1_6_2/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_6_2/web/service',
        'delphixpy/v1_6_2/web/service/time',
        'delphixpy/v1_6_2/web/service/linkingsettings',
        'delphixpy/v1_6_2/web/service/ldap',
        'delphixpy/v1_6_2/web/service/ldap/server',
        'delphixpy/v1_6_2/web/service/schema',
        'delphixpy/v1_6_2/web/service/phonehome',
        'delphixpy/v1_6_2/web/service/proxy',
        'delphixpy/v1_6_2/web/service/smtp',
        'delphixpy/v1_6_2/web/service/syslog',
        'delphixpy/v1_6_2/web/service/dns',
        'delphixpy/v1_6_2/web/service/locale',
        'delphixpy/v1_6_2/web/service/security',
        'delphixpy/v1_6_2/web/service/support',
        'delphixpy/v1_6_2/web/service/support/access',
        'delphixpy/v1_6_2/web/service/support/bundle',
        'delphixpy/v1_6_2/web/service/certificate',
        'delphixpy/v1_6_2/web/service/snmp',
        'delphixpy/v1_6_2/web/service/snmp/manager',
        'delphixpy/v1_6_2/web/about',
        'delphixpy/v1_6_2/web/notification',
        'delphixpy/v1_6_2/web/permission',
        'delphixpy/v1_6_2/web/user',
        'delphixpy/v1_6_2/web/alert',
        'delphixpy/v1_6_2/web/alert/profile',
        'delphixpy/v1_6_2/web/environment',
        'delphixpy/v1_6_2/web/environment/user',
        'delphixpy/v1_6_2/web/environment/oracle',
        'delphixpy/v1_6_2/web/environment/oracle/listener',
        'delphixpy/v1_6_2/web/environment/oracle/clusternode',
        'delphixpy/v1_6_2/web/environment/windows',
        'delphixpy/v1_6_2/web/environment/windows/clusterinstance',
        'delphixpy/v1_6_2/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_6_2/web/environment/windows/clusternode',
        'delphixpy/v1_6_2/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_6_2/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_6_2/web/policy',
        'delphixpy/v1_6_2/web/session',
        'delphixpy/v1_6_2/web/replication',
        'delphixpy/v1_6_2/web/replication/sourcestate',
        'delphixpy/v1_6_2/web/replication/targetstate',
        'delphixpy/v1_6_2/web/replication/spec',
        'delphixpy/v1_6_2/web/replication/serializationpoint',
        'delphixpy/v1_6_2/web/capacity',
        'delphixpy/v1_6_2/web/capacity/snapshot',
        'delphixpy/v1_6_2/web/capacity/group',
        'delphixpy/v1_6_2/web/capacity/group/historical',
        'delphixpy/v1_6_2/web/capacity/system',
        'delphixpy/v1_6_2/web/capacity/system/historical',
        'delphixpy/v1_6_2/web/capacity/consumer',
        'delphixpy/v1_6_2/web/capacity/consumer/historical',
        'delphixpy/v1_6_2/web/data',
        'delphixpy/v1_6_2/web/domain',
        'delphixpy/v1_6_2/web/connectivity',
        'delphixpy/v1_6_2/web/network',
        'delphixpy/v1_6_2/web/network/route',
        'delphixpy/v1_6_2/web/network/test',
        'delphixpy/v1_6_2/web/network/test/throughput',
        'delphixpy/v1_6_2/web/network/test/latency',
        'delphixpy/v1_6_2/web/network/test/dsp',
        'delphixpy/v1_6_2/web/network/interface',
        'delphixpy/v1_6_2/web/timeflow',
        'delphixpy/v1_6_2/web/timeflow/oracle',
        'delphixpy/v1_6_2/web/timeflow/oracle/log',
        'delphixpy/v1_6_2/web/timeflow/bookmark',
        'delphixpy/v1_6_2/web/storage',
        'delphixpy/v1_6_2/web/storage/remove',
        'delphixpy/v1_6_2/web/storage/scrub',
        'delphixpy/v1_6_2/web/storage/test',
        'delphixpy/v1_6_2/web/storage/device',
        'delphixpy/v1_6_2/web/fault',
        'delphixpy/v1_6_2/web/fault/effect',
        'delphixpy/v1_6_2/web/namespace',
        'delphixpy/v1_6_2/web/system',
        'delphixpy/v1_6_2/web/system/version',
        'delphixpy/v1_6_2/web/repository',
        'delphixpy/v1_6_2/web/repository/template',
        'delphixpy/v1_6_2/web/delphix',
        'delphixpy/v1_6_2/web/source',
        'delphixpy/v1_6_2/web/source/operationTemplate',
        'delphixpy/v1_6_2/web/authorization',
        'delphixpy/v1_6_2/web/analytics',
        'delphixpy/v1_6_2/web/analytics/statistic',
        'delphixpy/v1_6_2/web/registration',
        'delphixpy/v1_6_2/web/registration/status',
        'delphixpy/v1_6_2/web/job',
        'delphixpy/v1_6_2/web/role',
        'delphixpy/v1_6_2/web/toolkit',
        'delphixpy/v1_4_1',
        'delphixpy/v1_4_1/web',
        'delphixpy/v1_4_1/web/action',
        'delphixpy/v1_4_1/web/database',
        'delphixpy/v1_4_1/web/database/template',
        'delphixpy/v1_4_1/web/host',
        'delphixpy/v1_4_1/web/host/privilegeElevation',
        'delphixpy/v1_4_1/web/host/privilegeElevation/profile',
        'delphixpy/v1_4_1/web/vo',
        'delphixpy/v1_4_1/web/jetstream',
        'delphixpy/v1_4_1/web/jetstream/template',
        'delphixpy/v1_4_1/web/jetstream/branch',
        'delphixpy/v1_4_1/web/jetstream/usagedata',
        'delphixpy/v1_4_1/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_4_1/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_4_1/web/jetstream/bookmark',
        'delphixpy/v1_4_1/web/jetstream/capacity',
        'delphixpy/v1_4_1/web/jetstream/capacity/template',
        'delphixpy/v1_4_1/web/jetstream/capacity/branch',
        'delphixpy/v1_4_1/web/jetstream/capacity/bookmark',
        'delphixpy/v1_4_1/web/jetstream/capacity/bookmark/tag',
        'delphixpy/v1_4_1/web/jetstream/capacity/container',
        'delphixpy/v1_4_1/web/jetstream/datasource',
        'delphixpy/v1_4_1/web/jetstream/container',
        'delphixpy/v1_4_1/web/jetstream/preferences',
        'delphixpy/v1_4_1/web/jetstream/operation',
        'delphixpy/v1_4_1/web/snapshot',
        'delphixpy/v1_4_1/web/group',
        'delphixpy/v1_4_1/web/sourceconfig',
        'delphixpy/v1_4_1/web/sourceconfig/oracle',
        'delphixpy/v1_4_1/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_4_1/web/service',
        'delphixpy/v1_4_1/web/service/time',
        'delphixpy/v1_4_1/web/service/linkingsettings',
        'delphixpy/v1_4_1/web/service/ldap',
        'delphixpy/v1_4_1/web/service/ldap/server',
        'delphixpy/v1_4_1/web/service/phonehome',
        'delphixpy/v1_4_1/web/service/proxy',
        'delphixpy/v1_4_1/web/service/smtp',
        'delphixpy/v1_4_1/web/service/syslog',
        'delphixpy/v1_4_1/web/service/dns',
        'delphixpy/v1_4_1/web/service/locale',
        'delphixpy/v1_4_1/web/service/security',
        'delphixpy/v1_4_1/web/service/support',
        'delphixpy/v1_4_1/web/service/support/access',
        'delphixpy/v1_4_1/web/service/support/bundle',
        'delphixpy/v1_4_1/web/service/certificate',
        'delphixpy/v1_4_1/web/service/snmp',
        'delphixpy/v1_4_1/web/service/snmp/manager',
        'delphixpy/v1_4_1/web/about',
        'delphixpy/v1_4_1/web/notification',
        'delphixpy/v1_4_1/web/permission',
        'delphixpy/v1_4_1/web/user',
        'delphixpy/v1_4_1/web/alert',
        'delphixpy/v1_4_1/web/alert/profile',
        'delphixpy/v1_4_1/web/environment',
        'delphixpy/v1_4_1/web/environment/user',
        'delphixpy/v1_4_1/web/environment/oracle',
        'delphixpy/v1_4_1/web/environment/oracle/listener',
        'delphixpy/v1_4_1/web/environment/oracle/clusternode',
        'delphixpy/v1_4_1/web/environment/windows',
        'delphixpy/v1_4_1/web/environment/windows/clusterinstance',
        'delphixpy/v1_4_1/web/environment/windows/clusternode',
        'delphixpy/v1_4_1/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_4_1/web/policy',
        'delphixpy/v1_4_1/web/session',
        'delphixpy/v1_4_1/web/replication',
        'delphixpy/v1_4_1/web/replication/spec',
        'delphixpy/v1_4_1/web/capacity',
        'delphixpy/v1_4_1/web/capacity/snapshot',
        'delphixpy/v1_4_1/web/capacity/group',
        'delphixpy/v1_4_1/web/capacity/group/historical',
        'delphixpy/v1_4_1/web/capacity/system',
        'delphixpy/v1_4_1/web/capacity/system/historical',
        'delphixpy/v1_4_1/web/capacity/consumer',
        'delphixpy/v1_4_1/web/capacity/consumer/historical',
        'delphixpy/v1_4_1/web/data',
        'delphixpy/v1_4_1/web/domain',
        'delphixpy/v1_4_1/web/connectivity',
        'delphixpy/v1_4_1/web/network',
        'delphixpy/v1_4_1/web/network/route',
        'delphixpy/v1_4_1/web/network/test',
        'delphixpy/v1_4_1/web/network/test/throughput',
        'delphixpy/v1_4_1/web/network/test/latency',
        'delphixpy/v1_4_1/web/network/interface',
        'delphixpy/v1_4_1/web/timeflow',
        'delphixpy/v1_4_1/web/timeflow/bookmark',
        'delphixpy/v1_4_1/web/storage',
        'delphixpy/v1_4_1/web/storage/scrub',
        'delphixpy/v1_4_1/web/storage/device',
        'delphixpy/v1_4_1/web/fault',
        'delphixpy/v1_4_1/web/fault/effect',
        'delphixpy/v1_4_1/web/namespace',
        'delphixpy/v1_4_1/web/system',
        'delphixpy/v1_4_1/web/system/version',
        'delphixpy/v1_4_1/web/repository',
        'delphixpy/v1_4_1/web/delphix',
        'delphixpy/v1_4_1/web/source',
        'delphixpy/v1_4_1/web/authorization',
        'delphixpy/v1_4_1/web/analytics',
        'delphixpy/v1_4_1/web/analytics/statistic',
        'delphixpy/v1_4_1/web/registration',
        'delphixpy/v1_4_1/web/registration/status',
        'delphixpy/v1_4_1/web/job',
        'delphixpy/v1_4_1/web/role',
        'delphixpy/v1_4_1/web/toolkit',
        'delphixpy/v1_5_0',
        'delphixpy/v1_5_0/web',
        'delphixpy/v1_5_0/web/action',
        'delphixpy/v1_5_0/web/database',
        'delphixpy/v1_5_0/web/database/template',
        'delphixpy/v1_5_0/web/host',
        'delphixpy/v1_5_0/web/host/privilegeElevation',
        'delphixpy/v1_5_0/web/host/privilegeElevation/profile',
        'delphixpy/v1_5_0/web/vo',
        'delphixpy/v1_5_0/web/jetstream',
        'delphixpy/v1_5_0/web/jetstream/template',
        'delphixpy/v1_5_0/web/jetstream/branch',
        'delphixpy/v1_5_0/web/jetstream/usagedata',
        'delphixpy/v1_5_0/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_5_0/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_5_0/web/jetstream/bookmark',
        'delphixpy/v1_5_0/web/jetstream/datasource',
        'delphixpy/v1_5_0/web/jetstream/container',
        'delphixpy/v1_5_0/web/jetstream/usage',
        'delphixpy/v1_5_0/web/jetstream/usage/template',
        'delphixpy/v1_5_0/web/jetstream/usage/branch',
        'delphixpy/v1_5_0/web/jetstream/usage/user',
        'delphixpy/v1_5_0/web/jetstream/usage/bookmark',
        'delphixpy/v1_5_0/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_5_0/web/jetstream/usage/container',
        'delphixpy/v1_5_0/web/jetstream/operation',
        'delphixpy/v1_5_0/web/snapshot',
        'delphixpy/v1_5_0/web/group',
        'delphixpy/v1_5_0/web/sourceconfig',
        'delphixpy/v1_5_0/web/sourceconfig/oracle',
        'delphixpy/v1_5_0/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_5_0/web/service',
        'delphixpy/v1_5_0/web/service/time',
        'delphixpy/v1_5_0/web/service/linkingsettings',
        'delphixpy/v1_5_0/web/service/ldap',
        'delphixpy/v1_5_0/web/service/ldap/server',
        'delphixpy/v1_5_0/web/service/schema',
        'delphixpy/v1_5_0/web/service/phonehome',
        'delphixpy/v1_5_0/web/service/proxy',
        'delphixpy/v1_5_0/web/service/smtp',
        'delphixpy/v1_5_0/web/service/syslog',
        'delphixpy/v1_5_0/web/service/dns',
        'delphixpy/v1_5_0/web/service/locale',
        'delphixpy/v1_5_0/web/service/security',
        'delphixpy/v1_5_0/web/service/support',
        'delphixpy/v1_5_0/web/service/support/access',
        'delphixpy/v1_5_0/web/service/support/bundle',
        'delphixpy/v1_5_0/web/service/certificate',
        'delphixpy/v1_5_0/web/service/snmp',
        'delphixpy/v1_5_0/web/service/snmp/manager',
        'delphixpy/v1_5_0/web/about',
        'delphixpy/v1_5_0/web/notification',
        'delphixpy/v1_5_0/web/permission',
        'delphixpy/v1_5_0/web/user',
        'delphixpy/v1_5_0/web/alert',
        'delphixpy/v1_5_0/web/alert/profile',
        'delphixpy/v1_5_0/web/environment',
        'delphixpy/v1_5_0/web/environment/user',
        'delphixpy/v1_5_0/web/environment/oracle',
        'delphixpy/v1_5_0/web/environment/oracle/listener',
        'delphixpy/v1_5_0/web/environment/oracle/clusternode',
        'delphixpy/v1_5_0/web/environment/windows',
        'delphixpy/v1_5_0/web/environment/windows/clusterinstance',
        'delphixpy/v1_5_0/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_5_0/web/environment/windows/clusternode',
        'delphixpy/v1_5_0/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_5_0/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_5_0/web/policy',
        'delphixpy/v1_5_0/web/session',
        'delphixpy/v1_5_0/web/replication',
        'delphixpy/v1_5_0/web/replication/sourcestate',
        'delphixpy/v1_5_0/web/replication/targetstate',
        'delphixpy/v1_5_0/web/replication/spec',
        'delphixpy/v1_5_0/web/replication/serializationpoint',
        'delphixpy/v1_5_0/web/capacity',
        'delphixpy/v1_5_0/web/capacity/snapshot',
        'delphixpy/v1_5_0/web/capacity/group',
        'delphixpy/v1_5_0/web/capacity/group/historical',
        'delphixpy/v1_5_0/web/capacity/system',
        'delphixpy/v1_5_0/web/capacity/system/historical',
        'delphixpy/v1_5_0/web/capacity/consumer',
        'delphixpy/v1_5_0/web/capacity/consumer/historical',
        'delphixpy/v1_5_0/web/data',
        'delphixpy/v1_5_0/web/domain',
        'delphixpy/v1_5_0/web/connectivity',
        'delphixpy/v1_5_0/web/network',
        'delphixpy/v1_5_0/web/network/route',
        'delphixpy/v1_5_0/web/network/test',
        'delphixpy/v1_5_0/web/network/test/throughput',
        'delphixpy/v1_5_0/web/network/test/latency',
        'delphixpy/v1_5_0/web/network/test/dsp',
        'delphixpy/v1_5_0/web/network/interface',
        'delphixpy/v1_5_0/web/timeflow',
        'delphixpy/v1_5_0/web/timeflow/oracle',
        'delphixpy/v1_5_0/web/timeflow/oracle/log',
        'delphixpy/v1_5_0/web/timeflow/bookmark',
        'delphixpy/v1_5_0/web/storage',
        'delphixpy/v1_5_0/web/storage/scrub',
        'delphixpy/v1_5_0/web/storage/test',
        'delphixpy/v1_5_0/web/storage/device',
        'delphixpy/v1_5_0/web/fault',
        'delphixpy/v1_5_0/web/fault/effect',
        'delphixpy/v1_5_0/web/namespace',
        'delphixpy/v1_5_0/web/system',
        'delphixpy/v1_5_0/web/system/version',
        'delphixpy/v1_5_0/web/repository',
        'delphixpy/v1_5_0/web/repository/template',
        'delphixpy/v1_5_0/web/delphix',
        'delphixpy/v1_5_0/web/source',
        'delphixpy/v1_5_0/web/source/operationTemplate',
        'delphixpy/v1_5_0/web/authorization',
        'delphixpy/v1_5_0/web/analytics',
        'delphixpy/v1_5_0/web/analytics/statistic',
        'delphixpy/v1_5_0/web/registration',
        'delphixpy/v1_5_0/web/registration/status',
        'delphixpy/v1_5_0/web/job',
        'delphixpy/v1_5_0/web/role',
        'delphixpy/v1_5_0/web/toolkit',
        'delphixpy/v1_7_1',
        'delphixpy/v1_7_1/web',
        'delphixpy/v1_7_1/web/action',
        'delphixpy/v1_7_1/web/database',
        'delphixpy/v1_7_1/web/database/template',
        'delphixpy/v1_7_1/web/host',
        'delphixpy/v1_7_1/web/host/privilegeElevation',
        'delphixpy/v1_7_1/web/host/privilegeElevation/profileScript',
        'delphixpy/v1_7_1/web/host/privilegeElevation/profile',
        'delphixpy/v1_7_1/web/vo',
        'delphixpy/v1_7_1/web/jetstream',
        'delphixpy/v1_7_1/web/jetstream/template',
        'delphixpy/v1_7_1/web/jetstream/branch',
        'delphixpy/v1_7_1/web/jetstream/usagedata',
        'delphixpy/v1_7_1/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_7_1/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_7_1/web/jetstream/bookmark',
        'delphixpy/v1_7_1/web/jetstream/datasource',
        'delphixpy/v1_7_1/web/jetstream/container',
        'delphixpy/v1_7_1/web/jetstream/usage',
        'delphixpy/v1_7_1/web/jetstream/usage/template',
        'delphixpy/v1_7_1/web/jetstream/usage/branch',
        'delphixpy/v1_7_1/web/jetstream/usage/user',
        'delphixpy/v1_7_1/web/jetstream/usage/bookmark',
        'delphixpy/v1_7_1/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_7_1/web/jetstream/usage/container',
        'delphixpy/v1_7_1/web/jetstream/operation',
        'delphixpy/v1_7_1/web/snapshot',
        'delphixpy/v1_7_1/web/group',
        'delphixpy/v1_7_1/web/sourceconfig',
        'delphixpy/v1_7_1/web/sourceconfig/oracle',
        'delphixpy/v1_7_1/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_7_1/web/service',
        'delphixpy/v1_7_1/web/service/time',
        'delphixpy/v1_7_1/web/service/linkingsettings',
        'delphixpy/v1_7_1/web/service/ldap',
        'delphixpy/v1_7_1/web/service/ldap/server',
        'delphixpy/v1_7_1/web/service/schema',
        'delphixpy/v1_7_1/web/service/phonehome',
        'delphixpy/v1_7_1/web/service/proxy',
        'delphixpy/v1_7_1/web/service/smtp',
        'delphixpy/v1_7_1/web/service/syslog',
        'delphixpy/v1_7_1/web/service/dns',
        'delphixpy/v1_7_1/web/service/locale',
        'delphixpy/v1_7_1/web/service/security',
        'delphixpy/v1_7_1/web/service/support',
        'delphixpy/v1_7_1/web/service/support/access',
        'delphixpy/v1_7_1/web/service/support/bundle',
        'delphixpy/v1_7_1/web/service/certificate',
        'delphixpy/v1_7_1/web/service/snmp',
        'delphixpy/v1_7_1/web/service/snmp/manager',
        'delphixpy/v1_7_1/web/about',
        'delphixpy/v1_7_1/web/maskingjob',
        'delphixpy/v1_7_1/web/maskingjob/serviceconfig',
        'delphixpy/v1_7_1/web/notification',
        'delphixpy/v1_7_1/web/permission',
        'delphixpy/v1_7_1/web/user',
        'delphixpy/v1_7_1/web/alert',
        'delphixpy/v1_7_1/web/alert/profile',
        'delphixpy/v1_7_1/web/environment',
        'delphixpy/v1_7_1/web/environment/user',
        'delphixpy/v1_7_1/web/environment/oracle',
        'delphixpy/v1_7_1/web/environment/oracle/listener',
        'delphixpy/v1_7_1/web/environment/oracle/clusternode',
        'delphixpy/v1_7_1/web/environment/windows',
        'delphixpy/v1_7_1/web/environment/windows/clusterinstance',
        'delphixpy/v1_7_1/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_7_1/web/environment/windows/clusternode',
        'delphixpy/v1_7_1/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_7_1/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_7_1/web/policy',
        'delphixpy/v1_7_1/web/session',
        'delphixpy/v1_7_1/web/replication',
        'delphixpy/v1_7_1/web/replication/sourcestate',
        'delphixpy/v1_7_1/web/replication/targetstate',
        'delphixpy/v1_7_1/web/replication/spec',
        'delphixpy/v1_7_1/web/replication/serializationpoint',
        'delphixpy/v1_7_1/web/capacity',
        'delphixpy/v1_7_1/web/capacity/snapshot',
        'delphixpy/v1_7_1/web/capacity/group',
        'delphixpy/v1_7_1/web/capacity/group/historical',
        'delphixpy/v1_7_1/web/capacity/system',
        'delphixpy/v1_7_1/web/capacity/system/historical',
        'delphixpy/v1_7_1/web/capacity/consumer',
        'delphixpy/v1_7_1/web/capacity/consumer/historical',
        'delphixpy/v1_7_1/web/transformation',
        'delphixpy/v1_7_1/web/data',
        'delphixpy/v1_7_1/web/domain',
        'delphixpy/v1_7_1/web/connectivity',
        'delphixpy/v1_7_1/web/network',
        'delphixpy/v1_7_1/web/network/route',
        'delphixpy/v1_7_1/web/network/test',
        'delphixpy/v1_7_1/web/network/test/throughput',
        'delphixpy/v1_7_1/web/network/test/latency',
        'delphixpy/v1_7_1/web/network/test/dsp',
        'delphixpy/v1_7_1/web/network/interface',
        'delphixpy/v1_7_1/web/timeflow',
        'delphixpy/v1_7_1/web/timeflow/oracle',
        'delphixpy/v1_7_1/web/timeflow/oracle/log',
        'delphixpy/v1_7_1/web/timeflow/bookmark',
        'delphixpy/v1_7_1/web/storage',
        'delphixpy/v1_7_1/web/storage/remove',
        'delphixpy/v1_7_1/web/storage/scrub',
        'delphixpy/v1_7_1/web/storage/test',
        'delphixpy/v1_7_1/web/storage/device',
        'delphixpy/v1_7_1/web/fault',
        'delphixpy/v1_7_1/web/fault/effect',
        'delphixpy/v1_7_1/web/timezone',
        'delphixpy/v1_7_1/web/namespace',
        'delphixpy/v1_7_1/web/system',
        'delphixpy/v1_7_1/web/system/version',
        'delphixpy/v1_7_1/web/repository',
        'delphixpy/v1_7_1/web/repository/template',
        'delphixpy/v1_7_1/web/delphix',
        'delphixpy/v1_7_1/web/source',
        'delphixpy/v1_7_1/web/source/operationTemplate',
        'delphixpy/v1_7_1/web/authorization',
        'delphixpy/v1_7_1/web/analytics',
        'delphixpy/v1_7_1/web/analytics/statistic',
        'delphixpy/v1_7_1/web/registration',
        'delphixpy/v1_7_1/web/registration/status',
        'delphixpy/v1_7_1/web/job',
        'delphixpy/v1_7_1/web/role',
        'delphixpy/v1_7_1/web/toolkit',
        'delphixpy/v1_4_2',
        'delphixpy/v1_4_2/web',
        'delphixpy/v1_4_2/web/action',
        'delphixpy/v1_4_2/web/database',
        'delphixpy/v1_4_2/web/database/template',
        'delphixpy/v1_4_2/web/host',
        'delphixpy/v1_4_2/web/host/privilegeElevation',
        'delphixpy/v1_4_2/web/host/privilegeElevation/profile',
        'delphixpy/v1_4_2/web/vo',
        'delphixpy/v1_4_2/web/jetstream',
        'delphixpy/v1_4_2/web/jetstream/template',
        'delphixpy/v1_4_2/web/jetstream/branch',
        'delphixpy/v1_4_2/web/jetstream/usagedata',
        'delphixpy/v1_4_2/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_4_2/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_4_2/web/jetstream/bookmark',
        'delphixpy/v1_4_2/web/jetstream/capacity',
        'delphixpy/v1_4_2/web/jetstream/capacity/template',
        'delphixpy/v1_4_2/web/jetstream/capacity/branch',
        'delphixpy/v1_4_2/web/jetstream/capacity/bookmark',
        'delphixpy/v1_4_2/web/jetstream/capacity/bookmark/tag',
        'delphixpy/v1_4_2/web/jetstream/capacity/container',
        'delphixpy/v1_4_2/web/jetstream/datasource',
        'delphixpy/v1_4_2/web/jetstream/container',
        'delphixpy/v1_4_2/web/jetstream/preferences',
        'delphixpy/v1_4_2/web/jetstream/operation',
        'delphixpy/v1_4_2/web/snapshot',
        'delphixpy/v1_4_2/web/group',
        'delphixpy/v1_4_2/web/sourceconfig',
        'delphixpy/v1_4_2/web/sourceconfig/oracle',
        'delphixpy/v1_4_2/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_4_2/web/service',
        'delphixpy/v1_4_2/web/service/time',
        'delphixpy/v1_4_2/web/service/linkingsettings',
        'delphixpy/v1_4_2/web/service/ldap',
        'delphixpy/v1_4_2/web/service/ldap/server',
        'delphixpy/v1_4_2/web/service/phonehome',
        'delphixpy/v1_4_2/web/service/proxy',
        'delphixpy/v1_4_2/web/service/smtp',
        'delphixpy/v1_4_2/web/service/syslog',
        'delphixpy/v1_4_2/web/service/dns',
        'delphixpy/v1_4_2/web/service/locale',
        'delphixpy/v1_4_2/web/service/security',
        'delphixpy/v1_4_2/web/service/support',
        'delphixpy/v1_4_2/web/service/support/access',
        'delphixpy/v1_4_2/web/service/support/bundle',
        'delphixpy/v1_4_2/web/service/certificate',
        'delphixpy/v1_4_2/web/service/snmp',
        'delphixpy/v1_4_2/web/service/snmp/manager',
        'delphixpy/v1_4_2/web/about',
        'delphixpy/v1_4_2/web/notification',
        'delphixpy/v1_4_2/web/permission',
        'delphixpy/v1_4_2/web/user',
        'delphixpy/v1_4_2/web/alert',
        'delphixpy/v1_4_2/web/alert/profile',
        'delphixpy/v1_4_2/web/environment',
        'delphixpy/v1_4_2/web/environment/user',
        'delphixpy/v1_4_2/web/environment/oracle',
        'delphixpy/v1_4_2/web/environment/oracle/listener',
        'delphixpy/v1_4_2/web/environment/oracle/clusternode',
        'delphixpy/v1_4_2/web/environment/windows',
        'delphixpy/v1_4_2/web/environment/windows/clusterinstance',
        'delphixpy/v1_4_2/web/environment/windows/clusternode',
        'delphixpy/v1_4_2/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_4_2/web/policy',
        'delphixpy/v1_4_2/web/session',
        'delphixpy/v1_4_2/web/replication',
        'delphixpy/v1_4_2/web/replication/spec',
        'delphixpy/v1_4_2/web/capacity',
        'delphixpy/v1_4_2/web/capacity/snapshot',
        'delphixpy/v1_4_2/web/capacity/group',
        'delphixpy/v1_4_2/web/capacity/group/historical',
        'delphixpy/v1_4_2/web/capacity/system',
        'delphixpy/v1_4_2/web/capacity/system/historical',
        'delphixpy/v1_4_2/web/capacity/consumer',
        'delphixpy/v1_4_2/web/capacity/consumer/historical',
        'delphixpy/v1_4_2/web/data',
        'delphixpy/v1_4_2/web/domain',
        'delphixpy/v1_4_2/web/connectivity',
        'delphixpy/v1_4_2/web/network',
        'delphixpy/v1_4_2/web/network/route',
        'delphixpy/v1_4_2/web/network/test',
        'delphixpy/v1_4_2/web/network/test/throughput',
        'delphixpy/v1_4_2/web/network/test/latency',
        'delphixpy/v1_4_2/web/network/interface',
        'delphixpy/v1_4_2/web/timeflow',
        'delphixpy/v1_4_2/web/timeflow/bookmark',
        'delphixpy/v1_4_2/web/storage',
        'delphixpy/v1_4_2/web/storage/scrub',
        'delphixpy/v1_4_2/web/storage/device',
        'delphixpy/v1_4_2/web/fault',
        'delphixpy/v1_4_2/web/fault/effect',
        'delphixpy/v1_4_2/web/namespace',
        'delphixpy/v1_4_2/web/system',
        'delphixpy/v1_4_2/web/system/version',
        'delphixpy/v1_4_2/web/repository',
        'delphixpy/v1_4_2/web/delphix',
        'delphixpy/v1_4_2/web/source',
        'delphixpy/v1_4_2/web/authorization',
        'delphixpy/v1_4_2/web/analytics',
        'delphixpy/v1_4_2/web/analytics/statistic',
        'delphixpy/v1_4_2/web/registration',
        'delphixpy/v1_4_2/web/registration/status',
        'delphixpy/v1_4_2/web/job',
        'delphixpy/v1_4_2/web/role',
        'delphixpy/v1_4_2/web/toolkit',
        'delphixpy/v1_8_2',
        'delphixpy/v1_8_2/web',
        'delphixpy/v1_8_2/web/action',
        'delphixpy/v1_8_2/web/database',
        'delphixpy/v1_8_2/web/database/template',
        'delphixpy/v1_8_2/web/host',
        'delphixpy/v1_8_2/web/host/privilegeElevation',
        'delphixpy/v1_8_2/web/host/privilegeElevation/profileScript',
        'delphixpy/v1_8_2/web/host/privilegeElevation/profile',
        'delphixpy/v1_8_2/web/vo',
        'delphixpy/v1_8_2/web/jetstream',
        'delphixpy/v1_8_2/web/jetstream/template',
        'delphixpy/v1_8_2/web/jetstream/branch',
        'delphixpy/v1_8_2/web/jetstream/usagedata',
        'delphixpy/v1_8_2/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_8_2/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_8_2/web/jetstream/bookmark',
        'delphixpy/v1_8_2/web/jetstream/datasource',
        'delphixpy/v1_8_2/web/jetstream/container',
        'delphixpy/v1_8_2/web/jetstream/usage',
        'delphixpy/v1_8_2/web/jetstream/usage/template',
        'delphixpy/v1_8_2/web/jetstream/usage/branch',
        'delphixpy/v1_8_2/web/jetstream/usage/user',
        'delphixpy/v1_8_2/web/jetstream/usage/bookmark',
        'delphixpy/v1_8_2/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_8_2/web/jetstream/usage/container',
        'delphixpy/v1_8_2/web/jetstream/operation',
        'delphixpy/v1_8_2/web/snapshot',
        'delphixpy/v1_8_2/web/group',
        'delphixpy/v1_8_2/web/sourceconfig',
        'delphixpy/v1_8_2/web/sourceconfig/oracle',
        'delphixpy/v1_8_2/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_8_2/web/service',
        'delphixpy/v1_8_2/web/service/time',
        'delphixpy/v1_8_2/web/service/linkingsettings',
        'delphixpy/v1_8_2/web/service/ldap',
        'delphixpy/v1_8_2/web/service/ldap/server',
        'delphixpy/v1_8_2/web/service/schema',
        'delphixpy/v1_8_2/web/service/saml',
        'delphixpy/v1_8_2/web/service/saml/serviceprovider',
        'delphixpy/v1_8_2/web/service/phonehome',
        'delphixpy/v1_8_2/web/service/proxy',
        'delphixpy/v1_8_2/web/service/smtp',
        'delphixpy/v1_8_2/web/service/syslog',
        'delphixpy/v1_8_2/web/service/dns',
        'delphixpy/v1_8_2/web/service/locale',
        'delphixpy/v1_8_2/web/service/security',
        'delphixpy/v1_8_2/web/service/support',
        'delphixpy/v1_8_2/web/service/support/access',
        'delphixpy/v1_8_2/web/service/support/bundle',
        'delphixpy/v1_8_2/web/service/httpConnector',
        'delphixpy/v1_8_2/web/service/certificate',
        'delphixpy/v1_8_2/web/service/kerberos',
        'delphixpy/v1_8_2/web/service/snmp',
        'delphixpy/v1_8_2/web/service/snmp/manager',
        'delphixpy/v1_8_2/web/about',
        'delphixpy/v1_8_2/web/maskingjob',
        'delphixpy/v1_8_2/web/maskingjob/serviceconfig',
        'delphixpy/v1_8_2/web/notification',
        'delphixpy/v1_8_2/web/permission',
        'delphixpy/v1_8_2/web/user',
        'delphixpy/v1_8_2/web/alert',
        'delphixpy/v1_8_2/web/alert/profile',
        'delphixpy/v1_8_2/web/environment',
        'delphixpy/v1_8_2/web/environment/user',
        'delphixpy/v1_8_2/web/environment/oracle',
        'delphixpy/v1_8_2/web/environment/oracle/listener',
        'delphixpy/v1_8_2/web/environment/oracle/clusternode',
        'delphixpy/v1_8_2/web/environment/windows',
        'delphixpy/v1_8_2/web/environment/windows/clusterinstance',
        'delphixpy/v1_8_2/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_8_2/web/environment/windows/clusternode',
        'delphixpy/v1_8_2/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_8_2/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_8_2/web/policy',
        'delphixpy/v1_8_2/web/session',
        'delphixpy/v1_8_2/web/replication',
        'delphixpy/v1_8_2/web/replication/sourcestate',
        'delphixpy/v1_8_2/web/replication/targetstate',
        'delphixpy/v1_8_2/web/replication/spec',
        'delphixpy/v1_8_2/web/replication/serializationpoint',
        'delphixpy/v1_8_2/web/capacity',
        'delphixpy/v1_8_2/web/capacity/snapshot',
        'delphixpy/v1_8_2/web/capacity/group',
        'delphixpy/v1_8_2/web/capacity/group/historical',
        'delphixpy/v1_8_2/web/capacity/system',
        'delphixpy/v1_8_2/web/capacity/system/historical',
        'delphixpy/v1_8_2/web/capacity/consumer',
        'delphixpy/v1_8_2/web/capacity/consumer/historical',
        'delphixpy/v1_8_2/web/transformation',
        'delphixpy/v1_8_2/web/data',
        'delphixpy/v1_8_2/web/domain',
        'delphixpy/v1_8_2/web/connectivity',
        'delphixpy/v1_8_2/web/network',
        'delphixpy/v1_8_2/web/network/route',
        'delphixpy/v1_8_2/web/network/test',
        'delphixpy/v1_8_2/web/network/test/throughput',
        'delphixpy/v1_8_2/web/network/test/latency',
        'delphixpy/v1_8_2/web/network/test/dsp',
        'delphixpy/v1_8_2/web/network/interface',
        'delphixpy/v1_8_2/web/timeflow',
        'delphixpy/v1_8_2/web/timeflow/oracle',
        'delphixpy/v1_8_2/web/timeflow/oracle/log',
        'delphixpy/v1_8_2/web/timeflow/bookmark',
        'delphixpy/v1_8_2/web/storage',
        'delphixpy/v1_8_2/web/storage/remove',
        'delphixpy/v1_8_2/web/storage/scrub',
        'delphixpy/v1_8_2/web/storage/test',
        'delphixpy/v1_8_2/web/storage/device',
        'delphixpy/v1_8_2/web/fault',
        'delphixpy/v1_8_2/web/fault/effect',
        'delphixpy/v1_8_2/web/timezone',
        'delphixpy/v1_8_2/web/namespace',
        'delphixpy/v1_8_2/web/system',
        'delphixpy/v1_8_2/web/system/version',
        'delphixpy/v1_8_2/web/repository',
        'delphixpy/v1_8_2/web/repository/template',
        'delphixpy/v1_8_2/web/delphix',
        'delphixpy/v1_8_2/web/source',
        'delphixpy/v1_8_2/web/source/operationTemplate',
        'delphixpy/v1_8_2/web/authorization',
        'delphixpy/v1_8_2/web/analytics',
        'delphixpy/v1_8_2/web/analytics/statistic',
        'delphixpy/v1_8_2/web/registration',
        'delphixpy/v1_8_2/web/registration/status',
        'delphixpy/v1_8_2/web/job',
        'delphixpy/v1_8_2/web/role',
        'delphixpy/v1_8_2/web/toolkit',
        'delphixpy/web',
        'delphixpy/web/action',
        'delphixpy/web/database',
        'delphixpy/web/database/template',
        'delphixpy/web/database/performanceHistory',
        'delphixpy/web/host',
        'delphixpy/web/host/privilegeElevation',
        'delphixpy/web/host/privilegeElevation/profileScript',
        'delphixpy/web/host/privilegeElevation/profile',
        'delphixpy/web/passwordPolicy',
        'delphixpy/web/vo',
        'delphixpy/web/jetstream',
        'delphixpy/web/jetstream/template',
        'delphixpy/web/jetstream/branch',
        'delphixpy/web/jetstream/usagedata',
        'delphixpy/web/jetstream/usagedata/operationcount',
        'delphixpy/web/jetstream/usagedata/operationduration',
        'delphixpy/web/jetstream/bookmark',
        'delphixpy/web/jetstream/datasource',
        'delphixpy/web/jetstream/config',
        'delphixpy/web/jetstream/container',
        'delphixpy/web/jetstream/usage',
        'delphixpy/web/jetstream/usage/template',
        'delphixpy/web/jetstream/usage/branch',
        'delphixpy/web/jetstream/usage/user',
        'delphixpy/web/jetstream/usage/bookmark',
        'delphixpy/web/jetstream/usage/bookmark/tag',
        'delphixpy/web/jetstream/usage/container',
        'delphixpy/web/jetstream/operation',
        'delphixpy/web/snapshot',
        'delphixpy/web/group',
        'delphixpy/web/sourceconfig',
        'delphixpy/web/service',
        'delphixpy/web/service/time',
        'delphixpy/web/service/linkingsettings',
        'delphixpy/web/service/ldap',
        'delphixpy/web/service/ldap/server',
        'delphixpy/web/service/tls',
        'delphixpy/web/service/tls/cacert',
        'delphixpy/web/service/schema',
        'delphixpy/web/service/saml',
        'delphixpy/web/service/saml/serviceprovider',
        'delphixpy/web/service/phonehome',
        'delphixpy/web/service/proxy',
        'delphixpy/web/service/smtp',
        'delphixpy/web/service/syslog',
        'delphixpy/web/service/dns',
        'delphixpy/web/service/locale',
        'delphixpy/web/service/security',
        'delphixpy/web/service/support',
        'delphixpy/web/service/support/access',
        'delphixpy/web/service/support/bundle',
        'delphixpy/web/service/httpConnector',
        'delphixpy/web/service/certificate',
        'delphixpy/web/service/kerberos',
        'delphixpy/web/service/snmp',
        'delphixpy/web/service/snmp/manager',
        'delphixpy/web/about',
        'delphixpy/web/maskingjob',
        'delphixpy/web/maskingjob/serviceconfig',
        'delphixpy/web/notification',
        'delphixpy/web/permission',
        'delphixpy/web/user',
        'delphixpy/web/alert',
        'delphixpy/web/alert/profile',
        'delphixpy/web/environment',
        'delphixpy/web/environment/user',
        'delphixpy/web/environment/oracle',
        'delphixpy/web/environment/oracle/listener',
        'delphixpy/web/environment/oracle/clusternode',
        'delphixpy/web/environment/windows',
        'delphixpy/web/environment/windows/clusterinstance',
        'delphixpy/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/web/environment/windows/clusternode',
        'delphixpy/web/environment/windows/availabilitygrouplistener',
        'delphixpy/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/web/policy',
        'delphixpy/web/session',
        'delphixpy/web/replication',
        'delphixpy/web/replication/sourcestate',
        'delphixpy/web/replication/targetstate',
        'delphixpy/web/replication/spec',
        'delphixpy/web/replication/serializationpoint',
        'delphixpy/web/capacity',
        'delphixpy/web/capacity/snapshot',
        'delphixpy/web/capacity/group',
        'delphixpy/web/capacity/group/historical',
        'delphixpy/web/capacity/system',
        'delphixpy/web/capacity/system/historical',
        'delphixpy/web/capacity/consumer',
        'delphixpy/web/capacity/consumer/historical',
        'delphixpy/web/transformation',
        'delphixpy/web/data',
        'delphixpy/web/domain',
        'delphixpy/web/connectivity',
        'delphixpy/web/network',
        'delphixpy/web/network/route',
        'delphixpy/web/network/test',
        'delphixpy/web/network/test/throughput',
        'delphixpy/web/network/test/latency',
        'delphixpy/web/network/test/dsp',
        'delphixpy/web/network/interface',
        'delphixpy/web/network/dsp',
        'delphixpy/web/network/dsp/autotune',
        'delphixpy/web/timeflow',
        'delphixpy/web/timeflow/oracle',
        'delphixpy/web/timeflow/oracle/log',
        'delphixpy/web/timeflow/bookmark',
        'delphixpy/web/storage',
        'delphixpy/web/storage/remove',
        'delphixpy/web/storage/scrub',
        'delphixpy/web/storage/test',
        'delphixpy/web/storage/device',
        'delphixpy/web/fault',
        'delphixpy/web/fault/effect',
        'delphixpy/web/timezone',
        'delphixpy/web/namespace',
        'delphixpy/web/system',
        'delphixpy/web/system/upgradeCheckResult',
        'delphixpy/web/system/version',
        'delphixpy/web/system/package',
        'delphixpy/web/repository',
        'delphixpy/web/repository/template',
        'delphixpy/web/delphix',
        'delphixpy/web/source',
        'delphixpy/web/source/operationTemplate',
        'delphixpy/web/authorization',
        'delphixpy/web/analytics',
        'delphixpy/web/analytics/statistic',
        'delphixpy/web/registration',
        'delphixpy/web/registration/status',
        'delphixpy/web/job',
        'delphixpy/web/role',
        'delphixpy/web/toolkit',
        'delphixpy/v1_6_1',
        'delphixpy/v1_6_1/web',
        'delphixpy/v1_6_1/web/action',
        'delphixpy/v1_6_1/web/database',
        'delphixpy/v1_6_1/web/database/template',
        'delphixpy/v1_6_1/web/host',
        'delphixpy/v1_6_1/web/host/privilegeElevation',
        'delphixpy/v1_6_1/web/host/privilegeElevation/profile',
        'delphixpy/v1_6_1/web/vo',
        'delphixpy/v1_6_1/web/jetstream',
        'delphixpy/v1_6_1/web/jetstream/template',
        'delphixpy/v1_6_1/web/jetstream/branch',
        'delphixpy/v1_6_1/web/jetstream/usagedata',
        'delphixpy/v1_6_1/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_6_1/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_6_1/web/jetstream/bookmark',
        'delphixpy/v1_6_1/web/jetstream/datasource',
        'delphixpy/v1_6_1/web/jetstream/container',
        'delphixpy/v1_6_1/web/jetstream/usage',
        'delphixpy/v1_6_1/web/jetstream/usage/template',
        'delphixpy/v1_6_1/web/jetstream/usage/branch',
        'delphixpy/v1_6_1/web/jetstream/usage/user',
        'delphixpy/v1_6_1/web/jetstream/usage/bookmark',
        'delphixpy/v1_6_1/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_6_1/web/jetstream/usage/container',
        'delphixpy/v1_6_1/web/jetstream/operation',
        'delphixpy/v1_6_1/web/snapshot',
        'delphixpy/v1_6_1/web/group',
        'delphixpy/v1_6_1/web/sourceconfig',
        'delphixpy/v1_6_1/web/sourceconfig/oracle',
        'delphixpy/v1_6_1/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_6_1/web/service',
        'delphixpy/v1_6_1/web/service/time',
        'delphixpy/v1_6_1/web/service/linkingsettings',
        'delphixpy/v1_6_1/web/service/ldap',
        'delphixpy/v1_6_1/web/service/ldap/server',
        'delphixpy/v1_6_1/web/service/schema',
        'delphixpy/v1_6_1/web/service/phonehome',
        'delphixpy/v1_6_1/web/service/proxy',
        'delphixpy/v1_6_1/web/service/smtp',
        'delphixpy/v1_6_1/web/service/syslog',
        'delphixpy/v1_6_1/web/service/dns',
        'delphixpy/v1_6_1/web/service/locale',
        'delphixpy/v1_6_1/web/service/security',
        'delphixpy/v1_6_1/web/service/support',
        'delphixpy/v1_6_1/web/service/support/access',
        'delphixpy/v1_6_1/web/service/support/bundle',
        'delphixpy/v1_6_1/web/service/certificate',
        'delphixpy/v1_6_1/web/service/snmp',
        'delphixpy/v1_6_1/web/service/snmp/manager',
        'delphixpy/v1_6_1/web/about',
        'delphixpy/v1_6_1/web/notification',
        'delphixpy/v1_6_1/web/permission',
        'delphixpy/v1_6_1/web/user',
        'delphixpy/v1_6_1/web/alert',
        'delphixpy/v1_6_1/web/alert/profile',
        'delphixpy/v1_6_1/web/environment',
        'delphixpy/v1_6_1/web/environment/user',
        'delphixpy/v1_6_1/web/environment/oracle',
        'delphixpy/v1_6_1/web/environment/oracle/listener',
        'delphixpy/v1_6_1/web/environment/oracle/clusternode',
        'delphixpy/v1_6_1/web/environment/windows',
        'delphixpy/v1_6_1/web/environment/windows/clusterinstance',
        'delphixpy/v1_6_1/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_6_1/web/environment/windows/clusternode',
        'delphixpy/v1_6_1/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_6_1/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_6_1/web/policy',
        'delphixpy/v1_6_1/web/session',
        'delphixpy/v1_6_1/web/replication',
        'delphixpy/v1_6_1/web/replication/sourcestate',
        'delphixpy/v1_6_1/web/replication/targetstate',
        'delphixpy/v1_6_1/web/replication/spec',
        'delphixpy/v1_6_1/web/replication/serializationpoint',
        'delphixpy/v1_6_1/web/capacity',
        'delphixpy/v1_6_1/web/capacity/snapshot',
        'delphixpy/v1_6_1/web/capacity/group',
        'delphixpy/v1_6_1/web/capacity/group/historical',
        'delphixpy/v1_6_1/web/capacity/system',
        'delphixpy/v1_6_1/web/capacity/system/historical',
        'delphixpy/v1_6_1/web/capacity/consumer',
        'delphixpy/v1_6_1/web/capacity/consumer/historical',
        'delphixpy/v1_6_1/web/data',
        'delphixpy/v1_6_1/web/domain',
        'delphixpy/v1_6_1/web/connectivity',
        'delphixpy/v1_6_1/web/network',
        'delphixpy/v1_6_1/web/network/route',
        'delphixpy/v1_6_1/web/network/test',
        'delphixpy/v1_6_1/web/network/test/throughput',
        'delphixpy/v1_6_1/web/network/test/latency',
        'delphixpy/v1_6_1/web/network/test/dsp',
        'delphixpy/v1_6_1/web/network/interface',
        'delphixpy/v1_6_1/web/timeflow',
        'delphixpy/v1_6_1/web/timeflow/oracle',
        'delphixpy/v1_6_1/web/timeflow/oracle/log',
        'delphixpy/v1_6_1/web/timeflow/bookmark',
        'delphixpy/v1_6_1/web/storage',
        'delphixpy/v1_6_1/web/storage/remove',
        'delphixpy/v1_6_1/web/storage/scrub',
        'delphixpy/v1_6_1/web/storage/test',
        'delphixpy/v1_6_1/web/storage/device',
        'delphixpy/v1_6_1/web/fault',
        'delphixpy/v1_6_1/web/fault/effect',
        'delphixpy/v1_6_1/web/namespace',
        'delphixpy/v1_6_1/web/system',
        'delphixpy/v1_6_1/web/system/version',
        'delphixpy/v1_6_1/web/repository',
        'delphixpy/v1_6_1/web/repository/template',
        'delphixpy/v1_6_1/web/delphix',
        'delphixpy/v1_6_1/web/source',
        'delphixpy/v1_6_1/web/source/operationTemplate',
        'delphixpy/v1_6_1/web/authorization',
        'delphixpy/v1_6_1/web/analytics',
        'delphixpy/v1_6_1/web/analytics/statistic',
        'delphixpy/v1_6_1/web/registration',
        'delphixpy/v1_6_1/web/registration/status',
        'delphixpy/v1_6_1/web/job',
        'delphixpy/v1_6_1/web/role',
        'delphixpy/v1_6_1/web/toolkit',
        'delphixpy/v1_4_0',
        'delphixpy/v1_4_0/web',
        'delphixpy/v1_4_0/web/action',
        'delphixpy/v1_4_0/web/database',
        'delphixpy/v1_4_0/web/database/template',
        'delphixpy/v1_4_0/web/host',
        'delphixpy/v1_4_0/web/host/privilegeElevation',
        'delphixpy/v1_4_0/web/host/privilegeElevation/profile',
        'delphixpy/v1_4_0/web/vo',
        'delphixpy/v1_4_0/web/jetstream',
        'delphixpy/v1_4_0/web/jetstream/template',
        'delphixpy/v1_4_0/web/jetstream/branch',
        'delphixpy/v1_4_0/web/jetstream/usagedata',
        'delphixpy/v1_4_0/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_4_0/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_4_0/web/jetstream/bookmark',
        'delphixpy/v1_4_0/web/jetstream/capacity',
        'delphixpy/v1_4_0/web/jetstream/capacity/template',
        'delphixpy/v1_4_0/web/jetstream/capacity/branch',
        'delphixpy/v1_4_0/web/jetstream/capacity/bookmark',
        'delphixpy/v1_4_0/web/jetstream/capacity/bookmark/tag',
        'delphixpy/v1_4_0/web/jetstream/capacity/container',
        'delphixpy/v1_4_0/web/jetstream/datasource',
        'delphixpy/v1_4_0/web/jetstream/container',
        'delphixpy/v1_4_0/web/jetstream/preferences',
        'delphixpy/v1_4_0/web/jetstream/operation',
        'delphixpy/v1_4_0/web/snapshot',
        'delphixpy/v1_4_0/web/group',
        'delphixpy/v1_4_0/web/sourceconfig',
        'delphixpy/v1_4_0/web/sourceconfig/oracle',
        'delphixpy/v1_4_0/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_4_0/web/service',
        'delphixpy/v1_4_0/web/service/time',
        'delphixpy/v1_4_0/web/service/linkingsettings',
        'delphixpy/v1_4_0/web/service/ldap',
        'delphixpy/v1_4_0/web/service/ldap/server',
        'delphixpy/v1_4_0/web/service/phonehome',
        'delphixpy/v1_4_0/web/service/proxy',
        'delphixpy/v1_4_0/web/service/smtp',
        'delphixpy/v1_4_0/web/service/syslog',
        'delphixpy/v1_4_0/web/service/dns',
        'delphixpy/v1_4_0/web/service/locale',
        'delphixpy/v1_4_0/web/service/security',
        'delphixpy/v1_4_0/web/service/support',
        'delphixpy/v1_4_0/web/service/support/access',
        'delphixpy/v1_4_0/web/service/support/bundle',
        'delphixpy/v1_4_0/web/service/certificate',
        'delphixpy/v1_4_0/web/service/snmp',
        'delphixpy/v1_4_0/web/service/snmp/manager',
        'delphixpy/v1_4_0/web/about',
        'delphixpy/v1_4_0/web/notification',
        'delphixpy/v1_4_0/web/permission',
        'delphixpy/v1_4_0/web/user',
        'delphixpy/v1_4_0/web/alert',
        'delphixpy/v1_4_0/web/alert/profile',
        'delphixpy/v1_4_0/web/environment',
        'delphixpy/v1_4_0/web/environment/user',
        'delphixpy/v1_4_0/web/environment/oracle',
        'delphixpy/v1_4_0/web/environment/oracle/listener',
        'delphixpy/v1_4_0/web/environment/oracle/clusternode',
        'delphixpy/v1_4_0/web/environment/windows',
        'delphixpy/v1_4_0/web/environment/windows/clusterinstance',
        'delphixpy/v1_4_0/web/environment/windows/clusternode',
        'delphixpy/v1_4_0/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_4_0/web/policy',
        'delphixpy/v1_4_0/web/session',
        'delphixpy/v1_4_0/web/replication',
        'delphixpy/v1_4_0/web/replication/spec',
        'delphixpy/v1_4_0/web/capacity',
        'delphixpy/v1_4_0/web/capacity/snapshot',
        'delphixpy/v1_4_0/web/capacity/group',
        'delphixpy/v1_4_0/web/capacity/group/historical',
        'delphixpy/v1_4_0/web/capacity/system',
        'delphixpy/v1_4_0/web/capacity/system/historical',
        'delphixpy/v1_4_0/web/capacity/consumer',
        'delphixpy/v1_4_0/web/capacity/consumer/historical',
        'delphixpy/v1_4_0/web/data',
        'delphixpy/v1_4_0/web/domain',
        'delphixpy/v1_4_0/web/connectivity',
        'delphixpy/v1_4_0/web/network',
        'delphixpy/v1_4_0/web/network/route',
        'delphixpy/v1_4_0/web/network/test',
        'delphixpy/v1_4_0/web/network/test/throughput',
        'delphixpy/v1_4_0/web/network/test/latency',
        'delphixpy/v1_4_0/web/network/interface',
        'delphixpy/v1_4_0/web/timeflow',
        'delphixpy/v1_4_0/web/timeflow/bookmark',
        'delphixpy/v1_4_0/web/storage',
        'delphixpy/v1_4_0/web/storage/scrub',
        'delphixpy/v1_4_0/web/storage/device',
        'delphixpy/v1_4_0/web/fault',
        'delphixpy/v1_4_0/web/fault/effect',
        'delphixpy/v1_4_0/web/namespace',
        'delphixpy/v1_4_0/web/system',
        'delphixpy/v1_4_0/web/system/version',
        'delphixpy/v1_4_0/web/repository',
        'delphixpy/v1_4_0/web/delphix',
        'delphixpy/v1_4_0/web/source',
        'delphixpy/v1_4_0/web/authorization',
        'delphixpy/v1_4_0/web/analytics',
        'delphixpy/v1_4_0/web/analytics/statistic',
        'delphixpy/v1_4_0/web/registration',
        'delphixpy/v1_4_0/web/job',
        'delphixpy/v1_4_0/web/role',
        'delphixpy/v1_4_0/web/toolkit',
        'delphixpy/v1_3_1',
        'delphixpy/v1_3_1/web',
        'delphixpy/v1_3_1/web/dvc',
        'delphixpy/v1_3_1/web/dvc/template',
        'delphixpy/v1_3_1/web/dvc/branch',
        'delphixpy/v1_3_1/web/dvc/bookmark',
        'delphixpy/v1_3_1/web/dvc/datasource',
        'delphixpy/v1_3_1/web/dvc/container',
        'delphixpy/v1_3_1/web/dvc/preferences',
        'delphixpy/v1_3_1/web/dvc/operation',
        'delphixpy/v1_3_1/web/database',
        'delphixpy/v1_3_1/web/database/template',
        'delphixpy/v1_3_1/web/host',
        'delphixpy/v1_3_1/web/vo',
        'delphixpy/v1_3_1/web/snapshot',
        'delphixpy/v1_3_1/web/group',
        'delphixpy/v1_3_1/web/sourceconfig',
        'delphixpy/v1_3_1/web/service',
        'delphixpy/v1_3_1/web/service/time',
        'delphixpy/v1_3_1/web/service/linkingsettings',
        'delphixpy/v1_3_1/web/service/ldap',
        'delphixpy/v1_3_1/web/service/ldap/server',
        'delphixpy/v1_3_1/web/service/phonehome',
        'delphixpy/v1_3_1/web/service/proxy',
        'delphixpy/v1_3_1/web/service/smtp',
        'delphixpy/v1_3_1/web/service/syslog',
        'delphixpy/v1_3_1/web/service/dns',
        'delphixpy/v1_3_1/web/service/locale',
        'delphixpy/v1_3_1/web/service/support',
        'delphixpy/v1_3_1/web/service/support/access',
        'delphixpy/v1_3_1/web/service/support/bundle',
        'delphixpy/v1_3_1/web/service/certificate',
        'delphixpy/v1_3_1/web/service/snmp',
        'delphixpy/v1_3_1/web/service/snmp/manager',
        'delphixpy/v1_3_1/web/about',
        'delphixpy/v1_3_1/web/notification',
        'delphixpy/v1_3_1/web/permission',
        'delphixpy/v1_3_1/web/user',
        'delphixpy/v1_3_1/web/alert',
        'delphixpy/v1_3_1/web/alert/profile',
        'delphixpy/v1_3_1/web/environment',
        'delphixpy/v1_3_1/web/environment/user',
        'delphixpy/v1_3_1/web/environment/oracle',
        'delphixpy/v1_3_1/web/environment/oracle/listener',
        'delphixpy/v1_3_1/web/environment/oracle/clusternode',
        'delphixpy/v1_3_1/web/policy',
        'delphixpy/v1_3_1/web/session',
        'delphixpy/v1_3_1/web/replication',
        'delphixpy/v1_3_1/web/replication/spec',
        'delphixpy/v1_3_1/web/capacity',
        'delphixpy/v1_3_1/web/capacity/snapshot',
        'delphixpy/v1_3_1/web/capacity/group',
        'delphixpy/v1_3_1/web/capacity/group/historical',
        'delphixpy/v1_3_1/web/capacity/system',
        'delphixpy/v1_3_1/web/capacity/system/historical',
        'delphixpy/v1_3_1/web/capacity/consumer',
        'delphixpy/v1_3_1/web/capacity/consumer/historical',
        'delphixpy/v1_3_1/web/data',
        'delphixpy/v1_3_1/web/domain',
        'delphixpy/v1_3_1/web/connectivity',
        'delphixpy/v1_3_1/web/network',
        'delphixpy/v1_3_1/web/network/route',
        'delphixpy/v1_3_1/web/network/interface',
        'delphixpy/v1_3_1/web/timeflow',
        'delphixpy/v1_3_1/web/timeflow/bookmark',
        'delphixpy/v1_3_1/web/storage',
        'delphixpy/v1_3_1/web/storage/scrub',
        'delphixpy/v1_3_1/web/storage/device',
        'delphixpy/v1_3_1/web/fault',
        'delphixpy/v1_3_1/web/fault/effect',
        'delphixpy/v1_3_1/web/audit',
        'delphixpy/v1_3_1/web/namespace',
        'delphixpy/v1_3_1/web/system',
        'delphixpy/v1_3_1/web/system/version',
        'delphixpy/v1_3_1/web/repository',
        'delphixpy/v1_3_1/web/delphix',
        'delphixpy/v1_3_1/web/source',
        'delphixpy/v1_3_1/web/authorization',
        'delphixpy/v1_3_1/web/analytics',
        'delphixpy/v1_3_1/web/analytics/statistic',
        'delphixpy/v1_3_1/web/job',
        'delphixpy/v1_3_1/web/role',
        'delphixpy/v1_3_1/web/toolkit',
        'delphixpy/v1_3_3',
        'delphixpy/v1_3_3/web',
        'delphixpy/v1_3_3/web/dvc',
        'delphixpy/v1_3_3/web/dvc/template',
        'delphixpy/v1_3_3/web/dvc/branch',
        'delphixpy/v1_3_3/web/dvc/bookmark',
        'delphixpy/v1_3_3/web/dvc/datasource',
        'delphixpy/v1_3_3/web/dvc/container',
        'delphixpy/v1_3_3/web/dvc/preferences',
        'delphixpy/v1_3_3/web/dvc/operation',
        'delphixpy/v1_3_3/web/database',
        'delphixpy/v1_3_3/web/database/template',
        'delphixpy/v1_3_3/web/host',
        'delphixpy/v1_3_3/web/vo',
        'delphixpy/v1_3_3/web/snapshot',
        'delphixpy/v1_3_3/web/group',
        'delphixpy/v1_3_3/web/sourceconfig',
        'delphixpy/v1_3_3/web/service',
        'delphixpy/v1_3_3/web/service/time',
        'delphixpy/v1_3_3/web/service/linkingsettings',
        'delphixpy/v1_3_3/web/service/ldap',
        'delphixpy/v1_3_3/web/service/ldap/server',
        'delphixpy/v1_3_3/web/service/phonehome',
        'delphixpy/v1_3_3/web/service/proxy',
        'delphixpy/v1_3_3/web/service/smtp',
        'delphixpy/v1_3_3/web/service/syslog',
        'delphixpy/v1_3_3/web/service/dns',
        'delphixpy/v1_3_3/web/service/locale',
        'delphixpy/v1_3_3/web/service/support',
        'delphixpy/v1_3_3/web/service/support/access',
        'delphixpy/v1_3_3/web/service/support/bundle',
        'delphixpy/v1_3_3/web/service/certificate',
        'delphixpy/v1_3_3/web/service/snmp',
        'delphixpy/v1_3_3/web/service/snmp/manager',
        'delphixpy/v1_3_3/web/about',
        'delphixpy/v1_3_3/web/notification',
        'delphixpy/v1_3_3/web/permission',
        'delphixpy/v1_3_3/web/user',
        'delphixpy/v1_3_3/web/alert',
        'delphixpy/v1_3_3/web/alert/profile',
        'delphixpy/v1_3_3/web/environment',
        'delphixpy/v1_3_3/web/environment/user',
        'delphixpy/v1_3_3/web/environment/oracle',
        'delphixpy/v1_3_3/web/environment/oracle/listener',
        'delphixpy/v1_3_3/web/environment/oracle/clusternode',
        'delphixpy/v1_3_3/web/policy',
        'delphixpy/v1_3_3/web/session',
        'delphixpy/v1_3_3/web/replication',
        'delphixpy/v1_3_3/web/replication/spec',
        'delphixpy/v1_3_3/web/capacity',
        'delphixpy/v1_3_3/web/capacity/snapshot',
        'delphixpy/v1_3_3/web/capacity/group',
        'delphixpy/v1_3_3/web/capacity/group/historical',
        'delphixpy/v1_3_3/web/capacity/system',
        'delphixpy/v1_3_3/web/capacity/system/historical',
        'delphixpy/v1_3_3/web/capacity/consumer',
        'delphixpy/v1_3_3/web/capacity/consumer/historical',
        'delphixpy/v1_3_3/web/data',
        'delphixpy/v1_3_3/web/domain',
        'delphixpy/v1_3_3/web/connectivity',
        'delphixpy/v1_3_3/web/network',
        'delphixpy/v1_3_3/web/network/route',
        'delphixpy/v1_3_3/web/network/interface',
        'delphixpy/v1_3_3/web/timeflow',
        'delphixpy/v1_3_3/web/timeflow/bookmark',
        'delphixpy/v1_3_3/web/storage',
        'delphixpy/v1_3_3/web/storage/scrub',
        'delphixpy/v1_3_3/web/storage/device',
        'delphixpy/v1_3_3/web/fault',
        'delphixpy/v1_3_3/web/fault/effect',
        'delphixpy/v1_3_3/web/audit',
        'delphixpy/v1_3_3/web/namespace',
        'delphixpy/v1_3_3/web/system',
        'delphixpy/v1_3_3/web/system/version',
        'delphixpy/v1_3_3/web/repository',
        'delphixpy/v1_3_3/web/delphix',
        'delphixpy/v1_3_3/web/source',
        'delphixpy/v1_3_3/web/authorization',
        'delphixpy/v1_3_3/web/analytics',
        'delphixpy/v1_3_3/web/analytics/statistic',
        'delphixpy/v1_3_3/web/job',
        'delphixpy/v1_3_3/web/role',
        'delphixpy/v1_3_3/web/toolkit',
        'delphixpy/v1_8_1',
        'delphixpy/v1_8_1/web',
        'delphixpy/v1_8_1/web/action',
        'delphixpy/v1_8_1/web/database',
        'delphixpy/v1_8_1/web/database/template',
        'delphixpy/v1_8_1/web/host',
        'delphixpy/v1_8_1/web/host/privilegeElevation',
        'delphixpy/v1_8_1/web/host/privilegeElevation/profileScript',
        'delphixpy/v1_8_1/web/host/privilegeElevation/profile',
        'delphixpy/v1_8_1/web/vo',
        'delphixpy/v1_8_1/web/jetstream',
        'delphixpy/v1_8_1/web/jetstream/template',
        'delphixpy/v1_8_1/web/jetstream/branch',
        'delphixpy/v1_8_1/web/jetstream/usagedata',
        'delphixpy/v1_8_1/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_8_1/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_8_1/web/jetstream/bookmark',
        'delphixpy/v1_8_1/web/jetstream/datasource',
        'delphixpy/v1_8_1/web/jetstream/container',
        'delphixpy/v1_8_1/web/jetstream/usage',
        'delphixpy/v1_8_1/web/jetstream/usage/template',
        'delphixpy/v1_8_1/web/jetstream/usage/branch',
        'delphixpy/v1_8_1/web/jetstream/usage/user',
        'delphixpy/v1_8_1/web/jetstream/usage/bookmark',
        'delphixpy/v1_8_1/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_8_1/web/jetstream/usage/container',
        'delphixpy/v1_8_1/web/jetstream/operation',
        'delphixpy/v1_8_1/web/snapshot',
        'delphixpy/v1_8_1/web/group',
        'delphixpy/v1_8_1/web/sourceconfig',
        'delphixpy/v1_8_1/web/sourceconfig/oracle',
        'delphixpy/v1_8_1/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_8_1/web/service',
        'delphixpy/v1_8_1/web/service/time',
        'delphixpy/v1_8_1/web/service/linkingsettings',
        'delphixpy/v1_8_1/web/service/ldap',
        'delphixpy/v1_8_1/web/service/ldap/server',
        'delphixpy/v1_8_1/web/service/schema',
        'delphixpy/v1_8_1/web/service/saml',
        'delphixpy/v1_8_1/web/service/saml/serviceprovider',
        'delphixpy/v1_8_1/web/service/phonehome',
        'delphixpy/v1_8_1/web/service/proxy',
        'delphixpy/v1_8_1/web/service/smtp',
        'delphixpy/v1_8_1/web/service/syslog',
        'delphixpy/v1_8_1/web/service/dns',
        'delphixpy/v1_8_1/web/service/locale',
        'delphixpy/v1_8_1/web/service/security',
        'delphixpy/v1_8_1/web/service/support',
        'delphixpy/v1_8_1/web/service/support/access',
        'delphixpy/v1_8_1/web/service/support/bundle',
        'delphixpy/v1_8_1/web/service/certificate',
        'delphixpy/v1_8_1/web/service/snmp',
        'delphixpy/v1_8_1/web/service/snmp/manager',
        'delphixpy/v1_8_1/web/about',
        'delphixpy/v1_8_1/web/maskingjob',
        'delphixpy/v1_8_1/web/maskingjob/serviceconfig',
        'delphixpy/v1_8_1/web/notification',
        'delphixpy/v1_8_1/web/permission',
        'delphixpy/v1_8_1/web/user',
        'delphixpy/v1_8_1/web/alert',
        'delphixpy/v1_8_1/web/alert/profile',
        'delphixpy/v1_8_1/web/environment',
        'delphixpy/v1_8_1/web/environment/user',
        'delphixpy/v1_8_1/web/environment/oracle',
        'delphixpy/v1_8_1/web/environment/oracle/listener',
        'delphixpy/v1_8_1/web/environment/oracle/clusternode',
        'delphixpy/v1_8_1/web/environment/windows',
        'delphixpy/v1_8_1/web/environment/windows/clusterinstance',
        'delphixpy/v1_8_1/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_8_1/web/environment/windows/clusternode',
        'delphixpy/v1_8_1/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_8_1/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_8_1/web/policy',
        'delphixpy/v1_8_1/web/session',
        'delphixpy/v1_8_1/web/replication',
        'delphixpy/v1_8_1/web/replication/sourcestate',
        'delphixpy/v1_8_1/web/replication/targetstate',
        'delphixpy/v1_8_1/web/replication/spec',
        'delphixpy/v1_8_1/web/replication/serializationpoint',
        'delphixpy/v1_8_1/web/capacity',
        'delphixpy/v1_8_1/web/capacity/snapshot',
        'delphixpy/v1_8_1/web/capacity/group',
        'delphixpy/v1_8_1/web/capacity/group/historical',
        'delphixpy/v1_8_1/web/capacity/system',
        'delphixpy/v1_8_1/web/capacity/system/historical',
        'delphixpy/v1_8_1/web/capacity/consumer',
        'delphixpy/v1_8_1/web/capacity/consumer/historical',
        'delphixpy/v1_8_1/web/transformation',
        'delphixpy/v1_8_1/web/data',
        'delphixpy/v1_8_1/web/domain',
        'delphixpy/v1_8_1/web/connectivity',
        'delphixpy/v1_8_1/web/network',
        'delphixpy/v1_8_1/web/network/route',
        'delphixpy/v1_8_1/web/network/test',
        'delphixpy/v1_8_1/web/network/test/throughput',
        'delphixpy/v1_8_1/web/network/test/latency',
        'delphixpy/v1_8_1/web/network/test/dsp',
        'delphixpy/v1_8_1/web/network/interface',
        'delphixpy/v1_8_1/web/timeflow',
        'delphixpy/v1_8_1/web/timeflow/oracle',
        'delphixpy/v1_8_1/web/timeflow/oracle/log',
        'delphixpy/v1_8_1/web/timeflow/bookmark',
        'delphixpy/v1_8_1/web/storage',
        'delphixpy/v1_8_1/web/storage/remove',
        'delphixpy/v1_8_1/web/storage/scrub',
        'delphixpy/v1_8_1/web/storage/test',
        'delphixpy/v1_8_1/web/storage/device',
        'delphixpy/v1_8_1/web/fault',
        'delphixpy/v1_8_1/web/fault/effect',
        'delphixpy/v1_8_1/web/timezone',
        'delphixpy/v1_8_1/web/namespace',
        'delphixpy/v1_8_1/web/system',
        'delphixpy/v1_8_1/web/system/version',
        'delphixpy/v1_8_1/web/repository',
        'delphixpy/v1_8_1/web/repository/template',
        'delphixpy/v1_8_1/web/delphix',
        'delphixpy/v1_8_1/web/source',
        'delphixpy/v1_8_1/web/source/operationTemplate',
        'delphixpy/v1_8_1/web/authorization',
        'delphixpy/v1_8_1/web/analytics',
        'delphixpy/v1_8_1/web/analytics/statistic',
        'delphixpy/v1_8_1/web/registration',
        'delphixpy/v1_8_1/web/registration/status',
        'delphixpy/v1_8_1/web/job',
        'delphixpy/v1_8_1/web/role',
        'delphixpy/v1_8_1/web/toolkit',
        'delphixpy/v1_6_0',
        'delphixpy/v1_6_0/web',
        'delphixpy/v1_6_0/web/action',
        'delphixpy/v1_6_0/web/database',
        'delphixpy/v1_6_0/web/database/template',
        'delphixpy/v1_6_0/web/host',
        'delphixpy/v1_6_0/web/host/privilegeElevation',
        'delphixpy/v1_6_0/web/host/privilegeElevation/profile',
        'delphixpy/v1_6_0/web/vo',
        'delphixpy/v1_6_0/web/jetstream',
        'delphixpy/v1_6_0/web/jetstream/template',
        'delphixpy/v1_6_0/web/jetstream/branch',
        'delphixpy/v1_6_0/web/jetstream/usagedata',
        'delphixpy/v1_6_0/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_6_0/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_6_0/web/jetstream/bookmark',
        'delphixpy/v1_6_0/web/jetstream/datasource',
        'delphixpy/v1_6_0/web/jetstream/container',
        'delphixpy/v1_6_0/web/jetstream/usage',
        'delphixpy/v1_6_0/web/jetstream/usage/template',
        'delphixpy/v1_6_0/web/jetstream/usage/branch',
        'delphixpy/v1_6_0/web/jetstream/usage/user',
        'delphixpy/v1_6_0/web/jetstream/usage/bookmark',
        'delphixpy/v1_6_0/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_6_0/web/jetstream/usage/container',
        'delphixpy/v1_6_0/web/jetstream/operation',
        'delphixpy/v1_6_0/web/snapshot',
        'delphixpy/v1_6_0/web/group',
        'delphixpy/v1_6_0/web/sourceconfig',
        'delphixpy/v1_6_0/web/sourceconfig/oracle',
        'delphixpy/v1_6_0/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_6_0/web/service',
        'delphixpy/v1_6_0/web/service/time',
        'delphixpy/v1_6_0/web/service/linkingsettings',
        'delphixpy/v1_6_0/web/service/ldap',
        'delphixpy/v1_6_0/web/service/ldap/server',
        'delphixpy/v1_6_0/web/service/schema',
        'delphixpy/v1_6_0/web/service/phonehome',
        'delphixpy/v1_6_0/web/service/proxy',
        'delphixpy/v1_6_0/web/service/smtp',
        'delphixpy/v1_6_0/web/service/syslog',
        'delphixpy/v1_6_0/web/service/dns',
        'delphixpy/v1_6_0/web/service/locale',
        'delphixpy/v1_6_0/web/service/security',
        'delphixpy/v1_6_0/web/service/support',
        'delphixpy/v1_6_0/web/service/support/access',
        'delphixpy/v1_6_0/web/service/support/bundle',
        'delphixpy/v1_6_0/web/service/certificate',
        'delphixpy/v1_6_0/web/service/snmp',
        'delphixpy/v1_6_0/web/service/snmp/manager',
        'delphixpy/v1_6_0/web/about',
        'delphixpy/v1_6_0/web/notification',
        'delphixpy/v1_6_0/web/permission',
        'delphixpy/v1_6_0/web/user',
        'delphixpy/v1_6_0/web/alert',
        'delphixpy/v1_6_0/web/alert/profile',
        'delphixpy/v1_6_0/web/environment',
        'delphixpy/v1_6_0/web/environment/user',
        'delphixpy/v1_6_0/web/environment/oracle',
        'delphixpy/v1_6_0/web/environment/oracle/listener',
        'delphixpy/v1_6_0/web/environment/oracle/clusternode',
        'delphixpy/v1_6_0/web/environment/windows',
        'delphixpy/v1_6_0/web/environment/windows/clusterinstance',
        'delphixpy/v1_6_0/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_6_0/web/environment/windows/clusternode',
        'delphixpy/v1_6_0/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_6_0/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_6_0/web/policy',
        'delphixpy/v1_6_0/web/session',
        'delphixpy/v1_6_0/web/replication',
        'delphixpy/v1_6_0/web/replication/sourcestate',
        'delphixpy/v1_6_0/web/replication/targetstate',
        'delphixpy/v1_6_0/web/replication/spec',
        'delphixpy/v1_6_0/web/replication/serializationpoint',
        'delphixpy/v1_6_0/web/capacity',
        'delphixpy/v1_6_0/web/capacity/snapshot',
        'delphixpy/v1_6_0/web/capacity/group',
        'delphixpy/v1_6_0/web/capacity/group/historical',
        'delphixpy/v1_6_0/web/capacity/system',
        'delphixpy/v1_6_0/web/capacity/system/historical',
        'delphixpy/v1_6_0/web/capacity/consumer',
        'delphixpy/v1_6_0/web/capacity/consumer/historical',
        'delphixpy/v1_6_0/web/data',
        'delphixpy/v1_6_0/web/domain',
        'delphixpy/v1_6_0/web/connectivity',
        'delphixpy/v1_6_0/web/network',
        'delphixpy/v1_6_0/web/network/route',
        'delphixpy/v1_6_0/web/network/test',
        'delphixpy/v1_6_0/web/network/test/throughput',
        'delphixpy/v1_6_0/web/network/test/latency',
        'delphixpy/v1_6_0/web/network/test/dsp',
        'delphixpy/v1_6_0/web/network/interface',
        'delphixpy/v1_6_0/web/timeflow',
        'delphixpy/v1_6_0/web/timeflow/oracle',
        'delphixpy/v1_6_0/web/timeflow/oracle/log',
        'delphixpy/v1_6_0/web/timeflow/bookmark',
        'delphixpy/v1_6_0/web/storage',
        'delphixpy/v1_6_0/web/storage/remove',
        'delphixpy/v1_6_0/web/storage/scrub',
        'delphixpy/v1_6_0/web/storage/test',
        'delphixpy/v1_6_0/web/storage/device',
        'delphixpy/v1_6_0/web/fault',
        'delphixpy/v1_6_0/web/fault/effect',
        'delphixpy/v1_6_0/web/namespace',
        'delphixpy/v1_6_0/web/system',
        'delphixpy/v1_6_0/web/system/version',
        'delphixpy/v1_6_0/web/repository',
        'delphixpy/v1_6_0/web/repository/template',
        'delphixpy/v1_6_0/web/delphix',
        'delphixpy/v1_6_0/web/source',
        'delphixpy/v1_6_0/web/source/operationTemplate',
        'delphixpy/v1_6_0/web/authorization',
        'delphixpy/v1_6_0/web/analytics',
        'delphixpy/v1_6_0/web/analytics/statistic',
        'delphixpy/v1_6_0/web/registration',
        'delphixpy/v1_6_0/web/registration/status',
        'delphixpy/v1_6_0/web/job',
        'delphixpy/v1_6_0/web/role',
        'delphixpy/v1_6_0/web/toolkit',
        'delphixpy/v1_3_0',
        'delphixpy/v1_3_0/web',
        'delphixpy/v1_3_0/web/dvc',
        'delphixpy/v1_3_0/web/dvc/template',
        'delphixpy/v1_3_0/web/dvc/branch',
        'delphixpy/v1_3_0/web/dvc/bookmark',
        'delphixpy/v1_3_0/web/dvc/datasource',
        'delphixpy/v1_3_0/web/dvc/container',
        'delphixpy/v1_3_0/web/dvc/preferences',
        'delphixpy/v1_3_0/web/dvc/operation',
        'delphixpy/v1_3_0/web/database',
        'delphixpy/v1_3_0/web/database/template',
        'delphixpy/v1_3_0/web/host',
        'delphixpy/v1_3_0/web/vo',
        'delphixpy/v1_3_0/web/snapshot',
        'delphixpy/v1_3_0/web/group',
        'delphixpy/v1_3_0/web/sourceconfig',
        'delphixpy/v1_3_0/web/service',
        'delphixpy/v1_3_0/web/service/time',
        'delphixpy/v1_3_0/web/service/linkingsettings',
        'delphixpy/v1_3_0/web/service/ldap',
        'delphixpy/v1_3_0/web/service/ldap/server',
        'delphixpy/v1_3_0/web/service/phonehome',
        'delphixpy/v1_3_0/web/service/proxy',
        'delphixpy/v1_3_0/web/service/smtp',
        'delphixpy/v1_3_0/web/service/syslog',
        'delphixpy/v1_3_0/web/service/dns',
        'delphixpy/v1_3_0/web/service/locale',
        'delphixpy/v1_3_0/web/service/support',
        'delphixpy/v1_3_0/web/service/support/access',
        'delphixpy/v1_3_0/web/service/support/bundle',
        'delphixpy/v1_3_0/web/service/certificate',
        'delphixpy/v1_3_0/web/service/snmp',
        'delphixpy/v1_3_0/web/service/snmp/manager',
        'delphixpy/v1_3_0/web/about',
        'delphixpy/v1_3_0/web/notification',
        'delphixpy/v1_3_0/web/permission',
        'delphixpy/v1_3_0/web/user',
        'delphixpy/v1_3_0/web/alert',
        'delphixpy/v1_3_0/web/alert/profile',
        'delphixpy/v1_3_0/web/environment',
        'delphixpy/v1_3_0/web/environment/user',
        'delphixpy/v1_3_0/web/environment/oracle',
        'delphixpy/v1_3_0/web/environment/oracle/listener',
        'delphixpy/v1_3_0/web/environment/oracle/clusternode',
        'delphixpy/v1_3_0/web/policy',
        'delphixpy/v1_3_0/web/session',
        'delphixpy/v1_3_0/web/replication',
        'delphixpy/v1_3_0/web/replication/spec',
        'delphixpy/v1_3_0/web/capacity',
        'delphixpy/v1_3_0/web/capacity/snapshot',
        'delphixpy/v1_3_0/web/capacity/group',
        'delphixpy/v1_3_0/web/capacity/group/historical',
        'delphixpy/v1_3_0/web/capacity/system',
        'delphixpy/v1_3_0/web/capacity/system/historical',
        'delphixpy/v1_3_0/web/capacity/consumer',
        'delphixpy/v1_3_0/web/capacity/consumer/historical',
        'delphixpy/v1_3_0/web/data',
        'delphixpy/v1_3_0/web/domain',
        'delphixpy/v1_3_0/web/connectivity',
        'delphixpy/v1_3_0/web/network',
        'delphixpy/v1_3_0/web/network/route',
        'delphixpy/v1_3_0/web/network/interface',
        'delphixpy/v1_3_0/web/timeflow',
        'delphixpy/v1_3_0/web/timeflow/bookmark',
        'delphixpy/v1_3_0/web/storage',
        'delphixpy/v1_3_0/web/storage/scrub',
        'delphixpy/v1_3_0/web/storage/device',
        'delphixpy/v1_3_0/web/fault',
        'delphixpy/v1_3_0/web/fault/effect',
        'delphixpy/v1_3_0/web/audit',
        'delphixpy/v1_3_0/web/namespace',
        'delphixpy/v1_3_0/web/system',
        'delphixpy/v1_3_0/web/system/version',
        'delphixpy/v1_3_0/web/repository',
        'delphixpy/v1_3_0/web/delphix',
        'delphixpy/v1_3_0/web/source',
        'delphixpy/v1_3_0/web/authorization',
        'delphixpy/v1_3_0/web/analytics',
        'delphixpy/v1_3_0/web/analytics/statistic',
        'delphixpy/v1_3_0/web/job',
        'delphixpy/v1_3_0/web/role',
        'delphixpy/v1_3_0/web/toolkit',
        'delphixpy/v1_7_0',
        'delphixpy/v1_7_0/web',
        'delphixpy/v1_7_0/web/action',
        'delphixpy/v1_7_0/web/database',
        'delphixpy/v1_7_0/web/database/template',
        'delphixpy/v1_7_0/web/host',
        'delphixpy/v1_7_0/web/host/privilegeElevation',
        'delphixpy/v1_7_0/web/host/privilegeElevation/profileScript',
        'delphixpy/v1_7_0/web/host/privilegeElevation/profile',
        'delphixpy/v1_7_0/web/vo',
        'delphixpy/v1_7_0/web/jetstream',
        'delphixpy/v1_7_0/web/jetstream/template',
        'delphixpy/v1_7_0/web/jetstream/branch',
        'delphixpy/v1_7_0/web/jetstream/usagedata',
        'delphixpy/v1_7_0/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_7_0/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_7_0/web/jetstream/bookmark',
        'delphixpy/v1_7_0/web/jetstream/datasource',
        'delphixpy/v1_7_0/web/jetstream/container',
        'delphixpy/v1_7_0/web/jetstream/usage',
        'delphixpy/v1_7_0/web/jetstream/usage/template',
        'delphixpy/v1_7_0/web/jetstream/usage/branch',
        'delphixpy/v1_7_0/web/jetstream/usage/user',
        'delphixpy/v1_7_0/web/jetstream/usage/bookmark',
        'delphixpy/v1_7_0/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_7_0/web/jetstream/usage/container',
        'delphixpy/v1_7_0/web/jetstream/operation',
        'delphixpy/v1_7_0/web/snapshot',
        'delphixpy/v1_7_0/web/group',
        'delphixpy/v1_7_0/web/sourceconfig',
        'delphixpy/v1_7_0/web/sourceconfig/oracle',
        'delphixpy/v1_7_0/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_7_0/web/service',
        'delphixpy/v1_7_0/web/service/time',
        'delphixpy/v1_7_0/web/service/linkingsettings',
        'delphixpy/v1_7_0/web/service/ldap',
        'delphixpy/v1_7_0/web/service/ldap/server',
        'delphixpy/v1_7_0/web/service/schema',
        'delphixpy/v1_7_0/web/service/phonehome',
        'delphixpy/v1_7_0/web/service/proxy',
        'delphixpy/v1_7_0/web/service/smtp',
        'delphixpy/v1_7_0/web/service/syslog',
        'delphixpy/v1_7_0/web/service/dns',
        'delphixpy/v1_7_0/web/service/locale',
        'delphixpy/v1_7_0/web/service/security',
        'delphixpy/v1_7_0/web/service/support',
        'delphixpy/v1_7_0/web/service/support/access',
        'delphixpy/v1_7_0/web/service/support/bundle',
        'delphixpy/v1_7_0/web/service/certificate',
        'delphixpy/v1_7_0/web/service/snmp',
        'delphixpy/v1_7_0/web/service/snmp/manager',
        'delphixpy/v1_7_0/web/about',
        'delphixpy/v1_7_0/web/maskingjob',
        'delphixpy/v1_7_0/web/maskingjob/serviceconfig',
        'delphixpy/v1_7_0/web/notification',
        'delphixpy/v1_7_0/web/permission',
        'delphixpy/v1_7_0/web/user',
        'delphixpy/v1_7_0/web/alert',
        'delphixpy/v1_7_0/web/alert/profile',
        'delphixpy/v1_7_0/web/environment',
        'delphixpy/v1_7_0/web/environment/user',
        'delphixpy/v1_7_0/web/environment/oracle',
        'delphixpy/v1_7_0/web/environment/oracle/listener',
        'delphixpy/v1_7_0/web/environment/oracle/clusternode',
        'delphixpy/v1_7_0/web/environment/windows',
        'delphixpy/v1_7_0/web/environment/windows/clusterinstance',
        'delphixpy/v1_7_0/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_7_0/web/environment/windows/clusternode',
        'delphixpy/v1_7_0/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_7_0/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_7_0/web/policy',
        'delphixpy/v1_7_0/web/session',
        'delphixpy/v1_7_0/web/replication',
        'delphixpy/v1_7_0/web/replication/sourcestate',
        'delphixpy/v1_7_0/web/replication/targetstate',
        'delphixpy/v1_7_0/web/replication/spec',
        'delphixpy/v1_7_0/web/replication/serializationpoint',
        'delphixpy/v1_7_0/web/capacity',
        'delphixpy/v1_7_0/web/capacity/snapshot',
        'delphixpy/v1_7_0/web/capacity/group',
        'delphixpy/v1_7_0/web/capacity/group/historical',
        'delphixpy/v1_7_0/web/capacity/system',
        'delphixpy/v1_7_0/web/capacity/system/historical',
        'delphixpy/v1_7_0/web/capacity/consumer',
        'delphixpy/v1_7_0/web/capacity/consumer/historical',
        'delphixpy/v1_7_0/web/transformation',
        'delphixpy/v1_7_0/web/data',
        'delphixpy/v1_7_0/web/domain',
        'delphixpy/v1_7_0/web/connectivity',
        'delphixpy/v1_7_0/web/network',
        'delphixpy/v1_7_0/web/network/route',
        'delphixpy/v1_7_0/web/network/test',
        'delphixpy/v1_7_0/web/network/test/throughput',
        'delphixpy/v1_7_0/web/network/test/latency',
        'delphixpy/v1_7_0/web/network/test/dsp',
        'delphixpy/v1_7_0/web/network/interface',
        'delphixpy/v1_7_0/web/timeflow',
        'delphixpy/v1_7_0/web/timeflow/oracle',
        'delphixpy/v1_7_0/web/timeflow/oracle/log',
        'delphixpy/v1_7_0/web/timeflow/bookmark',
        'delphixpy/v1_7_0/web/storage',
        'delphixpy/v1_7_0/web/storage/remove',
        'delphixpy/v1_7_0/web/storage/scrub',
        'delphixpy/v1_7_0/web/storage/test',
        'delphixpy/v1_7_0/web/storage/device',
        'delphixpy/v1_7_0/web/fault',
        'delphixpy/v1_7_0/web/fault/effect',
        'delphixpy/v1_7_0/web/timezone',
        'delphixpy/v1_7_0/web/namespace',
        'delphixpy/v1_7_0/web/system',
        'delphixpy/v1_7_0/web/system/version',
        'delphixpy/v1_7_0/web/repository',
        'delphixpy/v1_7_0/web/repository/template',
        'delphixpy/v1_7_0/web/delphix',
        'delphixpy/v1_7_0/web/source',
        'delphixpy/v1_7_0/web/source/operationTemplate',
        'delphixpy/v1_7_0/web/authorization',
        'delphixpy/v1_7_0/web/analytics',
        'delphixpy/v1_7_0/web/analytics/statistic',
        'delphixpy/v1_7_0/web/registration',
        'delphixpy/v1_7_0/web/registration/status',
        'delphixpy/v1_7_0/web/job',
        'delphixpy/v1_7_0/web/role',
        'delphixpy/v1_7_0/web/toolkit',
        'delphixpy/v1_4_3',
        'delphixpy/v1_4_3/web',
        'delphixpy/v1_4_3/web/action',
        'delphixpy/v1_4_3/web/database',
        'delphixpy/v1_4_3/web/database/template',
        'delphixpy/v1_4_3/web/host',
        'delphixpy/v1_4_3/web/host/privilegeElevation',
        'delphixpy/v1_4_3/web/host/privilegeElevation/profile',
        'delphixpy/v1_4_3/web/vo',
        'delphixpy/v1_4_3/web/jetstream',
        'delphixpy/v1_4_3/web/jetstream/template',
        'delphixpy/v1_4_3/web/jetstream/branch',
        'delphixpy/v1_4_3/web/jetstream/usagedata',
        'delphixpy/v1_4_3/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_4_3/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_4_3/web/jetstream/bookmark',
        'delphixpy/v1_4_3/web/jetstream/capacity',
        'delphixpy/v1_4_3/web/jetstream/capacity/template',
        'delphixpy/v1_4_3/web/jetstream/capacity/branch',
        'delphixpy/v1_4_3/web/jetstream/capacity/bookmark',
        'delphixpy/v1_4_3/web/jetstream/capacity/bookmark/tag',
        'delphixpy/v1_4_3/web/jetstream/capacity/container',
        'delphixpy/v1_4_3/web/jetstream/datasource',
        'delphixpy/v1_4_3/web/jetstream/container',
        'delphixpy/v1_4_3/web/jetstream/preferences',
        'delphixpy/v1_4_3/web/jetstream/operation',
        'delphixpy/v1_4_3/web/snapshot',
        'delphixpy/v1_4_3/web/group',
        'delphixpy/v1_4_3/web/sourceconfig',
        'delphixpy/v1_4_3/web/sourceconfig/oracle',
        'delphixpy/v1_4_3/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_4_3/web/service',
        'delphixpy/v1_4_3/web/service/time',
        'delphixpy/v1_4_3/web/service/linkingsettings',
        'delphixpy/v1_4_3/web/service/ldap',
        'delphixpy/v1_4_3/web/service/ldap/server',
        'delphixpy/v1_4_3/web/service/phonehome',
        'delphixpy/v1_4_3/web/service/proxy',
        'delphixpy/v1_4_3/web/service/smtp',
        'delphixpy/v1_4_3/web/service/syslog',
        'delphixpy/v1_4_3/web/service/dns',
        'delphixpy/v1_4_3/web/service/locale',
        'delphixpy/v1_4_3/web/service/security',
        'delphixpy/v1_4_3/web/service/support',
        'delphixpy/v1_4_3/web/service/support/access',
        'delphixpy/v1_4_3/web/service/support/bundle',
        'delphixpy/v1_4_3/web/service/certificate',
        'delphixpy/v1_4_3/web/service/snmp',
        'delphixpy/v1_4_3/web/service/snmp/manager',
        'delphixpy/v1_4_3/web/about',
        'delphixpy/v1_4_3/web/notification',
        'delphixpy/v1_4_3/web/permission',
        'delphixpy/v1_4_3/web/user',
        'delphixpy/v1_4_3/web/alert',
        'delphixpy/v1_4_3/web/alert/profile',
        'delphixpy/v1_4_3/web/environment',
        'delphixpy/v1_4_3/web/environment/user',
        'delphixpy/v1_4_3/web/environment/oracle',
        'delphixpy/v1_4_3/web/environment/oracle/listener',
        'delphixpy/v1_4_3/web/environment/oracle/clusternode',
        'delphixpy/v1_4_3/web/environment/windows',
        'delphixpy/v1_4_3/web/environment/windows/clusterinstance',
        'delphixpy/v1_4_3/web/environment/windows/clusternode',
        'delphixpy/v1_4_3/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_4_3/web/policy',
        'delphixpy/v1_4_3/web/session',
        'delphixpy/v1_4_3/web/replication',
        'delphixpy/v1_4_3/web/replication/spec',
        'delphixpy/v1_4_3/web/capacity',
        'delphixpy/v1_4_3/web/capacity/snapshot',
        'delphixpy/v1_4_3/web/capacity/group',
        'delphixpy/v1_4_3/web/capacity/group/historical',
        'delphixpy/v1_4_3/web/capacity/system',
        'delphixpy/v1_4_3/web/capacity/system/historical',
        'delphixpy/v1_4_3/web/capacity/consumer',
        'delphixpy/v1_4_3/web/capacity/consumer/historical',
        'delphixpy/v1_4_3/web/data',
        'delphixpy/v1_4_3/web/domain',
        'delphixpy/v1_4_3/web/connectivity',
        'delphixpy/v1_4_3/web/network',
        'delphixpy/v1_4_3/web/network/route',
        'delphixpy/v1_4_3/web/network/test',
        'delphixpy/v1_4_3/web/network/test/throughput',
        'delphixpy/v1_4_3/web/network/test/latency',
        'delphixpy/v1_4_3/web/network/interface',
        'delphixpy/v1_4_3/web/timeflow',
        'delphixpy/v1_4_3/web/timeflow/bookmark',
        'delphixpy/v1_4_3/web/storage',
        'delphixpy/v1_4_3/web/storage/scrub',
        'delphixpy/v1_4_3/web/storage/device',
        'delphixpy/v1_4_3/web/fault',
        'delphixpy/v1_4_3/web/fault/effect',
        'delphixpy/v1_4_3/web/namespace',
        'delphixpy/v1_4_3/web/system',
        'delphixpy/v1_4_3/web/system/version',
        'delphixpy/v1_4_3/web/repository',
        'delphixpy/v1_4_3/web/delphix',
        'delphixpy/v1_4_3/web/source',
        'delphixpy/v1_4_3/web/authorization',
        'delphixpy/v1_4_3/web/analytics',
        'delphixpy/v1_4_3/web/analytics/statistic',
        'delphixpy/v1_4_3/web/registration',
        'delphixpy/v1_4_3/web/registration/status',
        'delphixpy/v1_4_3/web/job',
        'delphixpy/v1_4_3/web/role',
        'delphixpy/v1_4_3/web/toolkit',
        'delphixpy/v1_3_2',
        'delphixpy/v1_3_2/web',
        'delphixpy/v1_3_2/web/dvc',
        'delphixpy/v1_3_2/web/dvc/template',
        'delphixpy/v1_3_2/web/dvc/branch',
        'delphixpy/v1_3_2/web/dvc/bookmark',
        'delphixpy/v1_3_2/web/dvc/datasource',
        'delphixpy/v1_3_2/web/dvc/container',
        'delphixpy/v1_3_2/web/dvc/preferences',
        'delphixpy/v1_3_2/web/dvc/operation',
        'delphixpy/v1_3_2/web/database',
        'delphixpy/v1_3_2/web/database/template',
        'delphixpy/v1_3_2/web/host',
        'delphixpy/v1_3_2/web/vo',
        'delphixpy/v1_3_2/web/snapshot',
        'delphixpy/v1_3_2/web/group',
        'delphixpy/v1_3_2/web/sourceconfig',
        'delphixpy/v1_3_2/web/service',
        'delphixpy/v1_3_2/web/service/time',
        'delphixpy/v1_3_2/web/service/linkingsettings',
        'delphixpy/v1_3_2/web/service/ldap',
        'delphixpy/v1_3_2/web/service/ldap/server',
        'delphixpy/v1_3_2/web/service/phonehome',
        'delphixpy/v1_3_2/web/service/proxy',
        'delphixpy/v1_3_2/web/service/smtp',
        'delphixpy/v1_3_2/web/service/syslog',
        'delphixpy/v1_3_2/web/service/dns',
        'delphixpy/v1_3_2/web/service/locale',
        'delphixpy/v1_3_2/web/service/support',
        'delphixpy/v1_3_2/web/service/support/access',
        'delphixpy/v1_3_2/web/service/support/bundle',
        'delphixpy/v1_3_2/web/service/certificate',
        'delphixpy/v1_3_2/web/service/snmp',
        'delphixpy/v1_3_2/web/service/snmp/manager',
        'delphixpy/v1_3_2/web/about',
        'delphixpy/v1_3_2/web/notification',
        'delphixpy/v1_3_2/web/permission',
        'delphixpy/v1_3_2/web/user',
        'delphixpy/v1_3_2/web/alert',
        'delphixpy/v1_3_2/web/alert/profile',
        'delphixpy/v1_3_2/web/environment',
        'delphixpy/v1_3_2/web/environment/user',
        'delphixpy/v1_3_2/web/environment/oracle',
        'delphixpy/v1_3_2/web/environment/oracle/listener',
        'delphixpy/v1_3_2/web/environment/oracle/clusternode',
        'delphixpy/v1_3_2/web/policy',
        'delphixpy/v1_3_2/web/session',
        'delphixpy/v1_3_2/web/replication',
        'delphixpy/v1_3_2/web/replication/spec',
        'delphixpy/v1_3_2/web/capacity',
        'delphixpy/v1_3_2/web/capacity/snapshot',
        'delphixpy/v1_3_2/web/capacity/group',
        'delphixpy/v1_3_2/web/capacity/group/historical',
        'delphixpy/v1_3_2/web/capacity/system',
        'delphixpy/v1_3_2/web/capacity/system/historical',
        'delphixpy/v1_3_2/web/capacity/consumer',
        'delphixpy/v1_3_2/web/capacity/consumer/historical',
        'delphixpy/v1_3_2/web/data',
        'delphixpy/v1_3_2/web/domain',
        'delphixpy/v1_3_2/web/connectivity',
        'delphixpy/v1_3_2/web/network',
        'delphixpy/v1_3_2/web/network/route',
        'delphixpy/v1_3_2/web/network/interface',
        'delphixpy/v1_3_2/web/timeflow',
        'delphixpy/v1_3_2/web/timeflow/bookmark',
        'delphixpy/v1_3_2/web/storage',
        'delphixpy/v1_3_2/web/storage/scrub',
        'delphixpy/v1_3_2/web/storage/device',
        'delphixpy/v1_3_2/web/fault',
        'delphixpy/v1_3_2/web/fault/effect',
        'delphixpy/v1_3_2/web/audit',
        'delphixpy/v1_3_2/web/namespace',
        'delphixpy/v1_3_2/web/system',
        'delphixpy/v1_3_2/web/system/version',
        'delphixpy/v1_3_2/web/repository',
        'delphixpy/v1_3_2/web/delphix',
        'delphixpy/v1_3_2/web/source',
        'delphixpy/v1_3_2/web/authorization',
        'delphixpy/v1_3_2/web/analytics',
        'delphixpy/v1_3_2/web/analytics/statistic',
        'delphixpy/v1_3_2/web/job',
        'delphixpy/v1_3_2/web/role',
        'delphixpy/v1_3_2/web/toolkit',
        'delphixpy/v1_5_3',
        'delphixpy/v1_5_3/web',
        'delphixpy/v1_5_3/web/action',
        'delphixpy/v1_5_3/web/database',
        'delphixpy/v1_5_3/web/database/template',
        'delphixpy/v1_5_3/web/host',
        'delphixpy/v1_5_3/web/host/privilegeElevation',
        'delphixpy/v1_5_3/web/host/privilegeElevation/profile',
        'delphixpy/v1_5_3/web/vo',
        'delphixpy/v1_5_3/web/jetstream',
        'delphixpy/v1_5_3/web/jetstream/template',
        'delphixpy/v1_5_3/web/jetstream/branch',
        'delphixpy/v1_5_3/web/jetstream/usagedata',
        'delphixpy/v1_5_3/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_5_3/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_5_3/web/jetstream/bookmark',
        'delphixpy/v1_5_3/web/jetstream/datasource',
        'delphixpy/v1_5_3/web/jetstream/container',
        'delphixpy/v1_5_3/web/jetstream/usage',
        'delphixpy/v1_5_3/web/jetstream/usage/template',
        'delphixpy/v1_5_3/web/jetstream/usage/branch',
        'delphixpy/v1_5_3/web/jetstream/usage/user',
        'delphixpy/v1_5_3/web/jetstream/usage/bookmark',
        'delphixpy/v1_5_3/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_5_3/web/jetstream/usage/container',
        'delphixpy/v1_5_3/web/jetstream/operation',
        'delphixpy/v1_5_3/web/snapshot',
        'delphixpy/v1_5_3/web/group',
        'delphixpy/v1_5_3/web/sourceconfig',
        'delphixpy/v1_5_3/web/sourceconfig/oracle',
        'delphixpy/v1_5_3/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_5_3/web/service',
        'delphixpy/v1_5_3/web/service/time',
        'delphixpy/v1_5_3/web/service/linkingsettings',
        'delphixpy/v1_5_3/web/service/ldap',
        'delphixpy/v1_5_3/web/service/ldap/server',
        'delphixpy/v1_5_3/web/service/schema',
        'delphixpy/v1_5_3/web/service/phonehome',
        'delphixpy/v1_5_3/web/service/proxy',
        'delphixpy/v1_5_3/web/service/smtp',
        'delphixpy/v1_5_3/web/service/syslog',
        'delphixpy/v1_5_3/web/service/dns',
        'delphixpy/v1_5_3/web/service/locale',
        'delphixpy/v1_5_3/web/service/security',
        'delphixpy/v1_5_3/web/service/support',
        'delphixpy/v1_5_3/web/service/support/access',
        'delphixpy/v1_5_3/web/service/support/bundle',
        'delphixpy/v1_5_3/web/service/certificate',
        'delphixpy/v1_5_3/web/service/snmp',
        'delphixpy/v1_5_3/web/service/snmp/manager',
        'delphixpy/v1_5_3/web/about',
        'delphixpy/v1_5_3/web/notification',
        'delphixpy/v1_5_3/web/permission',
        'delphixpy/v1_5_3/web/user',
        'delphixpy/v1_5_3/web/alert',
        'delphixpy/v1_5_3/web/alert/profile',
        'delphixpy/v1_5_3/web/environment',
        'delphixpy/v1_5_3/web/environment/user',
        'delphixpy/v1_5_3/web/environment/oracle',
        'delphixpy/v1_5_3/web/environment/oracle/listener',
        'delphixpy/v1_5_3/web/environment/oracle/clusternode',
        'delphixpy/v1_5_3/web/environment/windows',
        'delphixpy/v1_5_3/web/environment/windows/clusterinstance',
        'delphixpy/v1_5_3/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_5_3/web/environment/windows/clusternode',
        'delphixpy/v1_5_3/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_5_3/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_5_3/web/policy',
        'delphixpy/v1_5_3/web/session',
        'delphixpy/v1_5_3/web/replication',
        'delphixpy/v1_5_3/web/replication/sourcestate',
        'delphixpy/v1_5_3/web/replication/targetstate',
        'delphixpy/v1_5_3/web/replication/spec',
        'delphixpy/v1_5_3/web/replication/serializationpoint',
        'delphixpy/v1_5_3/web/capacity',
        'delphixpy/v1_5_3/web/capacity/snapshot',
        'delphixpy/v1_5_3/web/capacity/group',
        'delphixpy/v1_5_3/web/capacity/group/historical',
        'delphixpy/v1_5_3/web/capacity/system',
        'delphixpy/v1_5_3/web/capacity/system/historical',
        'delphixpy/v1_5_3/web/capacity/consumer',
        'delphixpy/v1_5_3/web/capacity/consumer/historical',
        'delphixpy/v1_5_3/web/data',
        'delphixpy/v1_5_3/web/domain',
        'delphixpy/v1_5_3/web/connectivity',
        'delphixpy/v1_5_3/web/network',
        'delphixpy/v1_5_3/web/network/route',
        'delphixpy/v1_5_3/web/network/test',
        'delphixpy/v1_5_3/web/network/test/throughput',
        'delphixpy/v1_5_3/web/network/test/latency',
        'delphixpy/v1_5_3/web/network/test/dsp',
        'delphixpy/v1_5_3/web/network/interface',
        'delphixpy/v1_5_3/web/timeflow',
        'delphixpy/v1_5_3/web/timeflow/oracle',
        'delphixpy/v1_5_3/web/timeflow/oracle/log',
        'delphixpy/v1_5_3/web/timeflow/bookmark',
        'delphixpy/v1_5_3/web/storage',
        'delphixpy/v1_5_3/web/storage/remove',
        'delphixpy/v1_5_3/web/storage/scrub',
        'delphixpy/v1_5_3/web/storage/test',
        'delphixpy/v1_5_3/web/storage/device',
        'delphixpy/v1_5_3/web/fault',
        'delphixpy/v1_5_3/web/fault/effect',
        'delphixpy/v1_5_3/web/namespace',
        'delphixpy/v1_5_3/web/system',
        'delphixpy/v1_5_3/web/system/version',
        'delphixpy/v1_5_3/web/repository',
        'delphixpy/v1_5_3/web/repository/template',
        'delphixpy/v1_5_3/web/delphix',
        'delphixpy/v1_5_3/web/source',
        'delphixpy/v1_5_3/web/source/operationTemplate',
        'delphixpy/v1_5_3/web/authorization',
        'delphixpy/v1_5_3/web/analytics',
        'delphixpy/v1_5_3/web/analytics/statistic',
        'delphixpy/v1_5_3/web/registration',
        'delphixpy/v1_5_3/web/registration/status',
        'delphixpy/v1_5_3/web/job',
        'delphixpy/v1_5_3/web/role',
        'delphixpy/v1_5_3/web/toolkit',
        'delphixpy/v1_8_0',
        'delphixpy/v1_8_0/web',
        'delphixpy/v1_8_0/web/action',
        'delphixpy/v1_8_0/web/database',
        'delphixpy/v1_8_0/web/database/template',
        'delphixpy/v1_8_0/web/host',
        'delphixpy/v1_8_0/web/host/privilegeElevation',
        'delphixpy/v1_8_0/web/host/privilegeElevation/profileScript',
        'delphixpy/v1_8_0/web/host/privilegeElevation/profile',
        'delphixpy/v1_8_0/web/vo',
        'delphixpy/v1_8_0/web/jetstream',
        'delphixpy/v1_8_0/web/jetstream/template',
        'delphixpy/v1_8_0/web/jetstream/branch',
        'delphixpy/v1_8_0/web/jetstream/usagedata',
        'delphixpy/v1_8_0/web/jetstream/usagedata/operationcount',
        'delphixpy/v1_8_0/web/jetstream/usagedata/operationduration',
        'delphixpy/v1_8_0/web/jetstream/bookmark',
        'delphixpy/v1_8_0/web/jetstream/datasource',
        'delphixpy/v1_8_0/web/jetstream/container',
        'delphixpy/v1_8_0/web/jetstream/usage',
        'delphixpy/v1_8_0/web/jetstream/usage/template',
        'delphixpy/v1_8_0/web/jetstream/usage/branch',
        'delphixpy/v1_8_0/web/jetstream/usage/user',
        'delphixpy/v1_8_0/web/jetstream/usage/bookmark',
        'delphixpy/v1_8_0/web/jetstream/usage/bookmark/tag',
        'delphixpy/v1_8_0/web/jetstream/usage/container',
        'delphixpy/v1_8_0/web/jetstream/operation',
        'delphixpy/v1_8_0/web/snapshot',
        'delphixpy/v1_8_0/web/group',
        'delphixpy/v1_8_0/web/sourceconfig',
        'delphixpy/v1_8_0/web/sourceconfig/oracle',
        'delphixpy/v1_8_0/web/sourceconfig/oracle/pdb',
        'delphixpy/v1_8_0/web/service',
        'delphixpy/v1_8_0/web/service/time',
        'delphixpy/v1_8_0/web/service/linkingsettings',
        'delphixpy/v1_8_0/web/service/ldap',
        'delphixpy/v1_8_0/web/service/ldap/server',
        'delphixpy/v1_8_0/web/service/schema',
        'delphixpy/v1_8_0/web/service/saml',
        'delphixpy/v1_8_0/web/service/saml/serviceprovider',
        'delphixpy/v1_8_0/web/service/phonehome',
        'delphixpy/v1_8_0/web/service/proxy',
        'delphixpy/v1_8_0/web/service/smtp',
        'delphixpy/v1_8_0/web/service/syslog',
        'delphixpy/v1_8_0/web/service/dns',
        'delphixpy/v1_8_0/web/service/locale',
        'delphixpy/v1_8_0/web/service/security',
        'delphixpy/v1_8_0/web/service/support',
        'delphixpy/v1_8_0/web/service/support/access',
        'delphixpy/v1_8_0/web/service/support/bundle',
        'delphixpy/v1_8_0/web/service/certificate',
        'delphixpy/v1_8_0/web/service/snmp',
        'delphixpy/v1_8_0/web/service/snmp/manager',
        'delphixpy/v1_8_0/web/about',
        'delphixpy/v1_8_0/web/maskingjob',
        'delphixpy/v1_8_0/web/maskingjob/serviceconfig',
        'delphixpy/v1_8_0/web/notification',
        'delphixpy/v1_8_0/web/permission',
        'delphixpy/v1_8_0/web/user',
        'delphixpy/v1_8_0/web/alert',
        'delphixpy/v1_8_0/web/alert/profile',
        'delphixpy/v1_8_0/web/environment',
        'delphixpy/v1_8_0/web/environment/user',
        'delphixpy/v1_8_0/web/environment/oracle',
        'delphixpy/v1_8_0/web/environment/oracle/listener',
        'delphixpy/v1_8_0/web/environment/oracle/clusternode',
        'delphixpy/v1_8_0/web/environment/windows',
        'delphixpy/v1_8_0/web/environment/windows/clusterinstance',
        'delphixpy/v1_8_0/web/environment/windows/failoverclusterrepositoryinstance',
        'delphixpy/v1_8_0/web/environment/windows/clusternode',
        'delphixpy/v1_8_0/web/environment/windows/availabilitygrouplistener',
        'delphixpy/v1_8_0/web/environment/windows/failoverclusterrepositorylistener',
        'delphixpy/v1_8_0/web/policy',
        'delphixpy/v1_8_0/web/session',
        'delphixpy/v1_8_0/web/replication',
        'delphixpy/v1_8_0/web/replication/sourcestate',
        'delphixpy/v1_8_0/web/replication/targetstate',
        'delphixpy/v1_8_0/web/replication/spec',
        'delphixpy/v1_8_0/web/replication/serializationpoint',
        'delphixpy/v1_8_0/web/capacity',
        'delphixpy/v1_8_0/web/capacity/snapshot',
        'delphixpy/v1_8_0/web/capacity/group',
        'delphixpy/v1_8_0/web/capacity/group/historical',
        'delphixpy/v1_8_0/web/capacity/system',
        'delphixpy/v1_8_0/web/capacity/system/historical',
        'delphixpy/v1_8_0/web/capacity/consumer',
        'delphixpy/v1_8_0/web/capacity/consumer/historical',
        'delphixpy/v1_8_0/web/transformation',
        'delphixpy/v1_8_0/web/data',
        'delphixpy/v1_8_0/web/domain',
        'delphixpy/v1_8_0/web/connectivity',
        'delphixpy/v1_8_0/web/network',
        'delphixpy/v1_8_0/web/network/route',
        'delphixpy/v1_8_0/web/network/test',
        'delphixpy/v1_8_0/web/network/test/throughput',
        'delphixpy/v1_8_0/web/network/test/latency',
        'delphixpy/v1_8_0/web/network/test/dsp',
        'delphixpy/v1_8_0/web/network/interface',
        'delphixpy/v1_8_0/web/timeflow',
        'delphixpy/v1_8_0/web/timeflow/oracle',
        'delphixpy/v1_8_0/web/timeflow/oracle/log',
        'delphixpy/v1_8_0/web/timeflow/bookmark',
        'delphixpy/v1_8_0/web/storage',
        'delphixpy/v1_8_0/web/storage/remove',
        'delphixpy/v1_8_0/web/storage/scrub',
        'delphixpy/v1_8_0/web/storage/test',
        'delphixpy/v1_8_0/web/storage/device',
        'delphixpy/v1_8_0/web/fault',
        'delphixpy/v1_8_0/web/fault/effect',
        'delphixpy/v1_8_0/web/timezone',
        'delphixpy/v1_8_0/web/namespace',
        'delphixpy/v1_8_0/web/system',
        'delphixpy/v1_8_0/web/system/version',
        'delphixpy/v1_8_0/web/repository',
        'delphixpy/v1_8_0/web/repository/template',
        'delphixpy/v1_8_0/web/delphix',
        'delphixpy/v1_8_0/web/source',
        'delphixpy/v1_8_0/web/source/operationTemplate',
        'delphixpy/v1_8_0/web/authorization',
        'delphixpy/v1_8_0/web/analytics',
        'delphixpy/v1_8_0/web/analytics/statistic',
        'delphixpy/v1_8_0/web/registration',
        'delphixpy/v1_8_0/web/registration/status',
        'delphixpy/v1_8_0/web/job',
        'delphixpy/v1_8_0/web/role',
        'delphixpy/v1_8_0/web/toolkit'
    ]
)